;******************************* STERIA **************************************
; Fichier : $Id: pri-components-list.el,v 1.13 2000/11/03 10:36:54 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Mode du buffer contenant la liste de composants
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-components-list.el,v $
; Historique : Revision 1.13  2000/11/03 10:36:54  clb
; Historique : Correction du nom du composant : TAB en moins.
; Historique : modification de l'etat de la PO courante : on n'a plus saved...
; Historique :
; Revision 1.12  2000/10/27  13:58:36  clb
; Possibilite de tuer le buffer des hypotheses.
; Variable customizable pri-hypothesis-buffer-p.
;
; Revision 1.11  2000/10/27  10:36:32  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Historique : Revision 1.10  2000/10/25 13:18:14  clb
; Historique : sortie correcte d'emacs sur HP (bug 2628).
; Historique : commande "clp" sans argument.
; Historique : script emacspri --eval au lieu de -eval.
; Historique :
; Historique : Revision 1.9  2000/10/24 09:16:47  clb
; Historique : nouvelles icones pp et pp0. correction d'"autoload".
; Historique : La version V1.1.18 ne marche pas.
; Historique :
; Historique : Revision 1.8  2000/10/24 08:09:28  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.7  2000/10/18 14:36:02  clb
; Historique : ouverture d'un composant sur la liste des POs.
; Historique : clic sur une PO => ouverture du tampon Log.
; Historique :
; Historique : Revision 1.6  2000/10/18 08:47:01  clb
; Historique : Correction du nombre de PO total.
; Historique : On peut maintenant rerentrer dans un meme projet/ meme composant.
; Historique :
; Historique : Revision 1.5  2000/10/12 16:10:01  clb
; Historique : Amelioration du temps de chargement : widget-setup quand il faut.
; Historique :
; Historique : Revision 1.4  2000/10/12 13:51:54  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Historique : Revision 1.3  2000/10/10 16:03:49  clb
; Historique : Ajout du bouton Exit dans la fenetre des composants.
; Historique : Exit dans le mode de preuve interactive revient a la liste des composants.
; Historique :
; Historique : Revision 1.2  2000/10/09 15:06:11  clb
; Historique : Modification du message de version.
; Historique :
; Revision 1.1  2000/10/03  12:46:06  clb
; Ajout des tampons de liste des projets et des composants.
; Ils permettent a l'utilisateur de choisir plus facilement
; le projet et le composant voulu.
;
;
;*****************************************************************************/

;;*****************************************************************************
;;"include a la lisp"
(autoload 'pri-trace "pri-traces.el")
(autoload 'pri-output-buffer "pri-tools.el")
(autoload 'PRI-COMPONENTS-LIST "pri-main.el")
(autoload 'PRI-PROJECTS-LIST "pri-main.el")
(autoload 'pri-atb-send-command "pri-terminal.el")
(autoload 'pri-send-command "pri-terminal.el")
(autoload 'pri-hypotheses-list-mode "pri-hypotheses-list.el")
(autoload 'pri-hypothesis-buffer-p "pri-hypotheses-list.el")
(autoload 'pri-proof-tree-mode "pri-proof-tree.el")
(autoload 'pri-goal-mode "pri-goal.el")
(autoload 'pri-old-proof-mode "pri-old-proof.el")
(autoload 'pri-po-list-mode "pri-po-state.el")
(autoload 'pri-beginning-p "pri-po-state.el")
(autoload 'pri-log-mode "pri-log.el")
(autoload 'pri-log-print-p "pri-log.el")
(autoload 'PRI-PO-LIST "pri-main.el")
(autoload 'pri-po-list-window "pri-main.el")
(autoload 'pri-project-name "pri-main.el")
;;(autoload 'pri-inhibit-toolbar "pri-toolbar.el")
(autoload 'pri-version "pri-version.el")
(autoload 'pri-project-change-exit-emacs-menu "pri-projects-list.el")
(require 'widget)
(autoload 'widget-create "wid-edit")
(autoload 'widget-setup "wid-edit")
(autoload 'cansell-prompt-pri "pri-tools.el")
;;(autoload 'pri-button-red-face "pri-atelierb-mode.el")
;;(autoload 'pri-atelierb-mode "pri-atelierb-mode")
(autoload 'pri-machines-mode   "pri-machines-mode.el")
;(require 'pri-machines-mode)
;;(autoload 'pri-machines-B-mode  "pri-tools")
(autoload 'pri-interactive-send-command-p "pri-terminal")


;;*****************************************************************************
;; VARIABLES
(eval-and-compile
(defvar pri-component-name nil "Nom du composant selectionne")
(defvar  cansell-not-pb-p nil "t si pas de pb")
;;(defvar  cansell-pr-p nil "t si pr")
(defvar pri-component-mode-map nil "Table d'associations des touches du mode component-list."))
(defvar cansell-veut-status-project nil "")
(defvar cansell-rech-status-project nil "")
(defvar cansell-edit  nil "")
(defvar  cansell-pas-fini-les-interrupt nil)
;;*****************************************************************************
;; TOOLBAR

(defun   cansell-remove-all-source-buffer (l)
(if l
 (progn

    (let ((buff (file-name-nondirectory (car (cdr l))))) (if (get-buffer buff) (kill-buffer buff)))
     (cansell-remove-all-source-buffer (cddr l))) ;;(pri-trace "coucou")
))

(defun   cansell-load-all-source-buffer (l)
(if l
 (progn
    (let ((buff  (cadr l))) (if (get-buffer buff) ()(progn (setq cans-buff (find-file  buff))(pop-to-buffer PRI-COMPONENTS-LIST nil cansell-proj-frame)(delete-other-windows)
(pop-to-buffer   cans-buff t  cansell-error-frame) 
                            
			 (delete-other-windows )
                           (save-excursion (pri-machines-mode)
			   (x-symbol-mode "B entity") ;;(x-symbol-decode)
			   (font-lock-fontify-buffer)))))
     (cansell-load-all-source-buffer (cddr l))) ;;(pri-trace "coucou")
(cansell-affiche-composant)))

(defun pri-component-exit ()
  (interactive)

 ;; (sleep-for 0.1)
  (kill-buffer PRI-COMPONENTS-LIST)
						  (pop-to-buffer    "pri-errors" t cansell-error-frame) 

                                                 (delete-other-windows)
						 (pri-before-writting-buffer  "pri-errors") 
						 (erase-buffer)
						 (pri-after-writting-buffer)


  (pri-atb-send-command "clp")
 (set-buffer   PRI-PROJECTS-LIST)
  (pop-to-buffer PRI-PROJECTS-LIST nil cansell-proj-frame )
(delete-other-windows)
  (erase-buffer)
(cansell-affiche-projet)
 ;;(set-default-toolbar-position 'bottom)
  (pri-project-change-exit-emacs-menu)

  )




(defvar cansell-number-selected-compo 25 "c'est le nombre de composants  afficher")
(defvar cansell-add-compo 0)




;;*****************************************************************************
;; modifie le raccourci C-x C-c
(eval-and-compile
  (if pri-component-mode-map
	  nil
	(setq pri-component-mode-map (make-sparse-keymap))
	;; avant de quitter emacs on quitte le projet
	(define-key pri-component-mode-map "\C-x\C-c" 'pri-component-exit)))

;;*****************************************************************************
;; FUNCTIONS
;;*****************************************************************************
;;modifie le menu File->Exit XEmacs
(defun pri-component-change-exit-emacs-menu ()
  "modifie le menu File->Exit XEmacs... pourqu'il appelle la fonction pri-component-exit"
  (add-menu-button '("File") ["Exit XEmacs" pri-component-exit t])
)

(eval-and-compile
(defun pri-load-component ()
  "Lance le prouveur interactif sur le composant pri-component-name"
  
  (pri-trace "--> pri-load-component")

  (pri-proof-tree-mode)
  (if pri-hypothesis-buffer-p
	  (pri-hypotheses-list-mode))
 ;; (pri-goal-mode)
  (pri-old-proof-mode)
  (pri-log-mode)
;;  (pri-po-list-mode)

  (message "Balbulette Version : %s." pri-version)

;;  (add-hook 'pri-atelierb-mode-hook 
;;			'turn-on-font-lock)
;; (add-hook 'pri-machines-mode-hook 
;;			'turn-on-font-lock)

  (setq pri-log-print-p nil)  
  (setq pri-beginning-p t)  
  (setq cansell-not-pb-p t)
 (setq cansell-debut-de-la-preuve t)
  (pri-atb-send-command 
    (concat "b " pri-component-name))


))

(eval-and-compile
(defun cansell-widget-insert (c)
;;  (widget-insert c)
 (widget-insert (replace-in-string  c " " ""))
))

(eval-and-compile
(defun cansell-aff-stat (b l)
(if b
(progn	
 (widget-insert " ( ")
 (cansell-widget-insert (car (cdddr (cdddr l))))
 (widget-insert " / ")
  (cansell-widget-insert (car (cdddr l)))
 (widget-insert " / ")
  (cansell-widget-insert (car (cddddr l)))
 (widget-insert " )"))
(progn	
 (widget-insert " ( ")
 (cansell-widget-insert (car (cddr (cdddr l))))
 (widget-insert " / ")
  (cansell-widget-insert (car (cddr l)))
 (widget-insert " / ")
  (cansell-widget-insert (car (cdddr l)))
 (widget-insert " )"))
)))


(eval-and-compile
(defun cansell-confirme-remove-compo (component)
		      (end-of-buffer)
(widget-insert "  Confirm ")
 	 (widget-create  'push-button
           :tag "ys"
	   :value component
	   :format  "%[[%t]%]"
	   :button-face  'pri-components-button-red-face
	   :help-echo ( concat "Confirm remove component "  component ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-rc")) )
		     (progn 
		       (pri-atb-send-command  (concat "rc " (widget-value widget)))
		    ;;   (sleep-for 0.1)

		      ;; (if cansell-veut-status-project (progn
			;;   (setq cansell-status-project nil) (setq cansell-rech-status-project t)(pri-atb-send-command  "sg")))
		       (setq pri-output-buffer PRI-COMPONENTS-LIST)
		     ;;  (sleep-for 0.1)
		       (pri-atb-send-command  "sml")))))
(widget-insert " ")
 	 (widget-create  'push-button
           :tag "no"
	   :value component
	   :format  "%[[%t]%]"
	   :button-face  'pri-components-button-red-face
	   :help-echo ( concat "Do not remove component "  component ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-rc")) )
		       (progn 
			 (erase-buffer)     
			 (cansell-affiche-composant))))) 

))  
(eval-and-compile
(defun pri-add-button-component (component s l)

	 (widget-create  'push-button
           :tag "ed"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo (concat "Edit the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-cmped")))
		      (progn  
			(setq pri-component-file (cansell-recherche-pour-ed  (widget-value widget) cansell-list-pour-ed ))
			(if (get-buffer pri-component-file) () (progn (setq cansell-component-buffer (find-file  pri-component-file)) (pop-to-buffer PRI-COMPONENTS-LIST nil cansell-proj-frame)(delete-other-windows)(end-of-buffer)(if (= cansell-add-compo 0)()(goto-char (widget-field-start cansell-le-nom-du-compo)) ))) 
			 

 (pop-to-buffer    cansell-component-buffer t  cansell-error-frame) 
                            
			 (delete-other-windows )
			 (save-excursion
			   (set-buffer  cansell-component-buffer) (pri-machines-mode)
			   (x-symbol-mode "B entity") ;;(x-symbol-decode)
			   (font-lock-fontify-buffer)
)
) )))
(widget-insert " ")
(if (<= s 1)
	 (widget-create  'push-button
           :tag "ty"
	   :value component
	   :format  "%[[%t]%]"
	   :button-face  'pri-components-button-red-face
	   :help-echo (concat "TypeCheck the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-ty")))
		      (progn  (setq cansell-type-check t) (setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "t " (widget-value widget)))
(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")
))))
	 (widget-create  'push-button
           :tag "ty"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo (concat "TypeCheck the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-ty")))
		      (progn (setq cansell-type-check t)  (setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "t " (widget-value widget)))(setq cansell-envoi-sml t)
;(pri-atb-send-command "sml")
)))))
	 (widget-insert " ")

(if (<= s 2)
	 (widget-create  'push-button
           :tag "po"
	   :value component
	   :format  "%[[%t]%]"
	   :button-face  'pri-components-button-red-face
	   :help-echo  (concat "PO generation for the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-po")))
		      (progn  (setq cansell-type-check t) (setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "po " (widget-value widget) " 0"))
(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")

))))
	 (widget-create  'push-button
           :tag "po"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo  (concat "PO generation for the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-po")))
		      (progn   (setq cansell-type-check t)(if (= cansell-add-compo 0)()(widget-delete  cansell-le-nom-du-compo))(setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "po " (widget-value widget) " 0"))
(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")
)))))

(widget-insert " ")
	 (widget-create  'push-button
           :tag "un"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo (concat "Unprove the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-un")) )
		      (progn  (if (= cansell-add-compo 0)()(widget-delete  cansell-le-nom-du-compo))(setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "u " (widget-value widget)))
(setq cansell-envoi-stat t)
(setq cansell-cmd-stat (concat "s "  (widget-value widget)))
(setq cansell-compo-change   (widget-value widget))
;;(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")
)))) (widget-insert " ")


;;	 (widget-create  'push-button
;;           :tag "sc"
;;	   :value component
;;	   :format  "%[[%t]%]"
;;	   :help-echo ( concat "Status of component " component ) 
;;	   :notify (lambda (widget &rest ignore) 
;;		     (if cansell-affiche-help
;;			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-sc")) )
;;		      (progn  (setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "s " (widget-value widget)))))))
;;(widget-insert " ")
	 (widget-create  'push-button
           :tag "rc"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo ( concat "Remove component "  component ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-rc")) )
		     (progn 
	                   (cansell-confirme-remove-compo(widget-value widget)))))
)

(widget-insert  "    ")
(widget-insert component) 
;;(widget-insert l)
(if (<= 3 s) (cansell-aff-stat (car l) (pri-split-string (cdr l) "|"))) 
(widget-insert  " \n")
	 (widget-create  'push-button
           :tag "p0"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo (concat "Automatic proof (force 0)  the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-prc")))
		      (progn(setq cansell-type-check t) (setq cansell-pas-fini-les-interrupt t)(setq cansell-current-compo  (widget-value widget))(cansell-affiche-composant)(setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "pr " (widget-value widget) " 0"))
(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")
))))
(widget-insert " ")
	 (widget-create  'push-button
           :tag "p1"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo (concat "Automatic proof (force 1)  the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-prc")))
		      (progn (setq cansell-type-check t) (setq cansell-pas-fini-les-interrupt t)(setq cansell-current-compo  (widget-value widget))(cansell-affiche-composant)(setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "pr " (widget-value widget) " 1"))
(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")
))))
(widget-insert " ")

(if (file-exists-p  (concat PRI-MODELE-dir  "/"  pri-project-name  "/bdp/PatchProver"))
	 (widget-create  'push-button
           :tag "up"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo (concat "Use user pass theory on the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-up")))
		      (progn  (setq cansell-pas-fini-les-interrupt t)(setq cansell-current-compo  (widget-value widget))(cansell-affiche-composant)(setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "pr " (widget-value widget) " -3"))
(setq cansell-envoi-sml t)
 ))))

	 (widget-create  'push-button
           :tag "cu"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo (concat "Create predefined user pass theory for the component "component) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-cu")))
		      (progn  (shell-command (concat "cp  " pri-balbulette-dir "/PatchProver " PRI-MODELE-dir  "/"  pri-project-name  "/bdp" ))
(erase-buffer)     
			 (cansell-affiche-composant) )))))

(widget-insert " ")

;;	 (widget-create  'push-button
;;           :tag "p2"
;;	   :value component
;;	   :format  "%[[%t]%]"
;;	   :help-echo (concat "Automatic proof (force 2)  the component "component) 
;;	   :notify (lambda (widget &rest ignore) 
;;		     (if cansell-affiche-help
;;			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-prc")))
;;		      (progn  (setq cansell-pas-fini-les-interrupt t)(cansell-affiche-composant)(setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "pr " (widget-value widget) " 2"))
;;(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml") ))))
;;(widget-insert " ")


;;	 (widget-create  'push-button
;;         :tag "p3"
;;	   :value component
;;	   :format  "%[[%t]%]"
;;	   :help-echo (concat "Automatic proof (force 3)  the component "component) 
;;	   :notify (lambda (widget &rest ignore) 
;;		     (if cansell-affiche-help
;;			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-prc")))
;;		      (progn (setq cansell-pas-fini-les-interrupt t)(cansell-affiche-composant) (setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "pr " (widget-value widget) " 3"))
;;(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")
;;))))
;;(widget-insert " ")

;;	 (widget-create  'push-button
;;         :tag "p3"
;;	   :value component
;;	   :format  "%[[%t]%]"
;;	   :help-echo (concat "Automatic proof (force 3)  the component "component) 
;;	   :notify (lambda (widget &rest ignore) 
;;		     (if cansell-affiche-help
;;			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-prc")))
;;		      (progn (setq cansell-pas-fini-les-interrupt t)(cansell-affiche-composant) (setq cansell-erase-pri-errors t)(pri-atb-send-command  (concat "pr " (widget-value widget) " 3"))
;;(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")
;;))))
;;(widget-insert " ")

	 (widget-create  'push-button
           :tag "rp"
	   :value component
	   :format  "%[[%t]%]"
	   :help-echo ( concat "Replay proof  (component " component ")") 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-rp")) )
		         (progn  (setq cansell-pas-fini-les-interrupt t)(setq cansell-current-compo  (widget-value widget))(cansell-affiche-composant)(setq cansell-erase-pri-errors t) (pri-atb-send-command  (concat "pr " (widget-value widget) " -2"))
(setq cansell-envoi-sml t)
;;(pri-atb-send-command "sml")
))))
(widget-insert " ")
 

	(widget-create 'push-button
				   :tag "ip"
				   ;;:button-suffix component
				   :help-echo (concat "Interactive proof (component " component ")") 
				   :notify (lambda (widget &rest ignore)
					     (if cansell-affiche-help
						 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-ip")))
					       (progn
						  (pop-to-buffer    "pri-errors"  t cansell-error-frame) 
  (delete-other-windows)
						 (pri-before-writting-buffer  "pri-errors") 
						 (erase-buffer)
						 (pri-after-writting-buffer)

						 (setq pri-output-buffer PRI-COMPONENTS-LIST)
						 (set-buffer PRI-COMPONENTS-LIST)
						 (if (= cansell-add-compo 0)()(widget-delete  cansell-le-nom-du-compo))
						 (erase-buffer  PRI-COMPONENTS-LIST)
						 (if (not (widget-get widget :selec))
						     (progn
						       
						       (setq pri-component-name
							     (widget-get widget :component))
						       	(setq pri-component-file (cansell-recherche-pour-ed  pri-component-name cansell-list-pour-ed ))
(if (get-buffer pri-component-file) () (progn (setq cansell-component-buffer (find-file  pri-component-file))(other-window 1)(delete-other-windows)))
						        (pri-load-component);; (pri-atb-send-command (concat "ic " pri-component-name))
						       ))))
							   
							 ;;redraw the button
							 (widget-setup))
					   
				   :format "%[[%t]%]"
				   :selec nil
				   :etat nil
				   :component component
				   )

(widget-insert  " ")
(if (and cansell-pas-fini-les-interrupt (string= cansell-current-compo component))
(widget-create  'push-button
           :tag "it"
	   :value ""
	   :help-echo "Interrupt the prover"
	   :button-face  'pri-components-button-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		  
		(progn (pri-interrupt) (setq cansell-prover-not-works t))
				))(widget-insert  "    "))
(widget-insert  "\n\n")
(widget-setup)
))
(eval-and-compile
(defun cansell-pour-ed (lc lf)
 (if lc 
     (cons (car lc) (cons (car lf) (cansell-pour-ed (cdr lc) (cdr lf))))
   nil)
))

(eval-and-compile
(defun cansell-recherche-pour-ed (m l)
 (if l 
     (if (string= (car l) m)
        (cadr l)
     (cansell-recherche-pour-ed m (cddr l)))
   nil)
))

(eval-and-compile
(defun cansell-affiche-NO-next-compo()
))
(eval-and-compile
(defun cansell-affiche-next-compo()

 (widget-insert "\n")

 
 (widget-insert  "COMP ")
  	 (widget-create  'push-button
           :tag "++"
	   :value ""
	   :help-echo "Another components"
	   ;;:button-face  'pri-button-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-plus-minus")))
		        (if cansell-projet-not-busy (progn
 			      (setq  cansell-selected-compos cansell-selected-composold)
                             (if (< cansell-number-selected-compo 43) (setq cansell-number-selected-compo (+ 1 cansell-number-selected-compo)))
			     (cansell-affiche-composant))

)))) 

 (widget-insert " ") 
(if (> cansell-number-selected-compo)
 (progn
   	 (widget-create  'push-button
           :tag "--"
	   :value ""
	   :help-echo "Another project"
	   ;;:button-face  'pri-button-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-plus-minus")))
		      	 (if cansell-projet-not-busy			    (progn
			               (setq  cansell-selected-compos cansell-selected-composold)
				      (setq cansell-number-selected-compo (1- cansell-number-selected-compo))
				      (cansell-affiche-composant))))))
(widget-insert  " " )
  	 (widget-create  'push-button
           :tag "nc"
	   :value ""
	   :help-echo "Next components"
	   ;;:button-face  'pri-button-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-nh")))
		       (if cansell-projet-not-busy (progn
			       ;;(setq  cansell-selected-projects (cdr cansell-selected-projectsold))
			       (if cansell-selected-compos  () (setq  cansell-selected-compos cansell-liste-machine))
				(cansell-affiche-composant)
				
  )))))) 
 (widget-insert  "         " ))

     
;; (widget-insert " ")     
 (widget-insert  "  ------ " )
(widget-insert  (concat " ("  (int-to-string cansell-number-selected-compo) "/" (int-to-string (length cansell-liste-machine)) ") \n" )  )
(widget-setup)(end-of-buffer)
))
(eval-and-compile
(defun cansell-compense-compo (n)
(if (= n 0) ()
 (progn (pri-before-writting-buffer  PRI-COMPONENTS-LIST)(insert "\n")(pri-after-writting-buffer)( cansell-compense-compo (1- n)))
)))
(eval-and-compile
(defun cansell-affiche-Composant ()

(pop-to-buffer  PRI-COMPONENTS-LIST nil cansell-proj-frame) (delete-other-windows)
 (pri-components-list-mode)

                 (pri-before-writting-buffer  PRI-COMPONENTS-LIST)
                 (erase-buffer)
		 (setq cansell-list-pour-ed (cansell-pour-ed  cansell-liste-machine cansell-machines-name-list))
                (cansell-compense-compo (- 43 (min cansell-number-selected-compo (length cansell-liste-machine)))) 
                 (cansell-calculette-Component)
                 (cansell-calculette-basse-component)(end-of-buffer)(pri-components-list-mode)
		(if (= cansell-add-compo 0)()(goto-char (widget-field-start cansell-le-nom-du-compo)))
(font-lock-fontify-buffer)
		 (pri-after-writting-buffer) 
		 (setq pri-output-buffer "")
(if cansell-load-compo (progn (setq cansell-load-compo nil)(cansell-load-all-source-buffer cansell-list-pour-ed )))
(message cansell-le-message)
		 (widget-setup)
))


(eval-and-compile
(defun cansell-affiche-composant ()

(pop-to-buffer  PRI-COMPONENTS-LIST nil cansell-proj-frame) (delete-other-windows)
 (pri-components-list-mode)

                 (pri-before-writting-buffer  PRI-COMPONENTS-LIST)
                 (erase-buffer)
		 (setq cansell-list-pour-ed (cansell-pour-ed  cansell-liste-machine cansell-machines-name-list))
                 (cansell-calculette-component cansell-liste-machine cansell-machines-stat-list)
                 (cansell-calculette-basse-component)(end-of-buffer)(pri-components-list-mode)
		(if (= cansell-add-compo 0)()(goto-char (widget-field-start cansell-le-nom-du-compo)))
(font-lock-fontify-buffer)
		 (pri-after-writting-buffer) 
		 (setq pri-output-buffer "")

(if cansell-load-compo (progn (setq cansell-load-compo nil)(cansell-load-all-source-buffer cansell-list-pour-ed )))

(message cansell-le-message)
		 (widget-setup)
))

(eval-and-compile
(defun cansell-directory-buffer-file-name ( b )
 (replace-in-string (buffer-file-name b) (concat (buffer-name b) "$") "")
))
 (eval-and-compile
(defun cansell-B-file (f)
   (or (string-match "\\.mch$" f) (string-match "\\.ref$" f) (string-match "\\.imp$" f)) 
))

 (eval-and-compile
(defun cansell-bon-B-file (buff)
(or (not (cansell-B-file (buffer-name buff)))  (file-directory-p (buffer-file-name buff) ))
))
(eval-and-compile
(defun cansell-calculette-basse-component ()
(widget-insert  "\n\n")
(widget-create  'push-button
           :tag "qu"
	   :value ""
	   :help-echo "Quit the project"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-quit-proj")) )
		       (cansell-remove-all-source-buffer cansell-list-pour-ed )   (pri-component-exit))
			
			    
		       )) 
(widget-insert " ")
(if cansell-affiche-help
(widget-create  'push-button
           :tag "hp"
	   :value ""
	   :help-echo "Help?"
	   :button-face  'pri-components-button-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (progn
		       (setq cansell-affiche-help (not cansell-affiche-help))(if (= cansell-add-compo 0)()(widget-delete  cansell-le-nom-du-compo))(cansell-affiche-composant)
					      (set-buffer "pri-help")  (erase-buffer)
		      (pop-to-buffer    "pri-errors"  t  cansell-error-frame) 
  (delete-other-windows)
			    
		       ))) 
(widget-create  'push-button
           :tag "hp"
	   :value ""
	   :help-echo "Help?"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (progn
		       (setq cansell-affiche-help (not cansell-affiche-help))(if (= cansell-add-compo 0)() (widget-delete  cansell-le-nom-du-compo))(cansell-affiche-composant)
		           (pop-to-buffer    "pri-help"  t cansell-error-frame) 
  (delete-other-windows)(set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-start"))(pri-errors-mode)(font-lock-fontify-buffer) 
			
			    
		       ))) )
(widget-insert " ")
;;	 (widget-create  'push-button
;;          :tag "sp"
;;	   :value ""
;;	   :format  "%[[%t]%]"
;;	   :help-echo  "Status project"
;;	   :notify (lambda (widget &rest ignore) 
;;		     (if cansell-affiche-help
;;			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-sp")) )
		      ; (if cansell-veut-status-project 
		;;	 (progn 
		;;	   (setq cansell-veut-status-project nil)
		;	   (setq cansell-status-project nil)
		;;	   (pri-before-writting-buffer  PRI-COMPONENTS-LIST)
		;;	   (erase-buffer)
			   ;;(cansell-calculette-component cansell-liste-machine)
		;;	   (cansell-calculette-basse-component)
		;;	   (pri-after-writting-buffer))
;;			 (progn (setq cansell-erase-pri-errors t)
;;			   (setq cansell-veut-status-project t)
;;			   (setq cansell-rech-status-project t)
;;			   (setq cansell-status-project nil) 
;;			   (pri-atb-send-command  "sg")))))
;;(widget-insert " ")
;;	 (widget-create  'push-button
;;           :tag "ac"
;;	   :value ""
;;	   :format  "%[[%t]%]"
;;	   :help-echo "Add a component " 
;;	   :notify (lambda (widget &rest ignore) 
;;		     (if cansell-affiche-help
;;			 (progn  (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-ac"))) 
;;		       (progn
;;			;; (end-of-buffer)
;;			 (setq cansell-curbuff (buffer-file-name (current-buffer)))
;;			 (if (file-directory-p (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" )) 
;;			 (cd (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))) (message "  Give a  name in the box")
;;			 (setq cansell-add-buffer (toolbar-open))(message "  Give a  name in the box")
;;			 (if (cansell-bon-B-file cansell-add-buffer)
;;			     (progn (pop-to-buffer PRI-COMPONENTS-LIST)(delete-other-windows)(end-of-buffer)(message "You cannot specify a directory. Try again"))
;;			     (progn		       
;;			       (pri-atb-send-command  (concat "cd " (cansell-directory-buffer-file-name cansell-add-buffer)))
;;			       ;;(sleep-for 0.1)
;;			       (pri-atb-send-command  (concat "af " (buffer-name cansell-add-buffer)))
;;			       ;;(if cansell-veut-status-project 
;;				;;   (progn
;;				 ;;    (setq cansell-status-project nil) (setq cansell-rech-status-project t)(pri-atb-send-command  "sg")))
;;			       (setq pri-output-buffer PRI-COMPONENTS-LIST) 
;;			       (pri-atb-send-command  "sml")))))))
;;
;;(widget-insert " ")

(if (= cansell-add-compo 1)
	 (widget-create  'push-button
           :tag "am"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Add a model " 
	   :button-face  'pri-components-button-red-face
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn  (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-am")) )
		       (let ((widget-value-cansell-le-nom-du-compo (replace-in-string    (concat " " (widget-value cansell-le-nom-du-compo)) "^ +" "")))
                         (setq cansell-add-compo 0)
			 (if (string= "" widget-value-cansell-le-nom-du-compo) (cansell-affiche-composant ) (progn
			 (setq cansell-curbuff (buffer-file-name (current-buffer)))
                   (if (file-accessible-directory-p (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
			(progn
                        (cd (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
                        (pri-atb-send-command  (concat "cd " (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" )))
                        )
		      (if cansell-machines-name-list
                     (progn
                        (cd (file-name-directory (car cansell-machines-name-list)))
			(pri-atb-send-command  (concat "cd " (file-name-directory (car cansell-machines-name-list))))
                   )))
			 ;;(sleep-for 0.1)
			 (if (file-exists-p (concat widget-value-cansell-le-nom-du-compo ".mch"))
			     (find-file  (concat widget-value-cansell-le-nom-du-compo ".mch"))
			   (progn 
			   (find-file  (concat widget-value-cansell-le-nom-du-compo ".mch"))
			   (insert "MODEL\n   ") (insert widget-value-cansell-le-nom-du-compo)(insert "\nEND")
			    (basic-save-buffer)))
			 (pri-atb-send-command  (concat "af " widget-value-cansell-le-nom-du-compo ".mch"))
			 (setq pri-output-buffer PRI-COMPONENTS-LIST) 
			 (setq cansell-envoi-sml t);;(pri-atb-send-command  "sml")
))))))
	 (widget-create  'push-button
           :tag "am"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Add a model " 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn  (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-am")) )
		      (setq cansell-add-compo 1)(cansell-affiche-composant)
))))
(widget-insert " ")
(if (= cansell-add-compo 2)
	 (widget-create  'push-button
           :tag "ar"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Add a refinement " 
	   :button-face  'pri-components-button-red-face
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn  (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-ar")) )
		       (progn(if (region-active-p)
(progn
 (setq cansell-name-abstract (buffer-string (mark)(point)))(setq cansell-active t))(setq cansell-active nil))(let ((widget-value-cansell-le-nom-du-compo (replace-in-string    (concat " " (widget-value cansell-le-nom-du-compo)) "^ +" "")))
		             (setq cansell-add-compo 0)
			     (if (string= "" widget-value-cansell-le-nom-du-compo ) (cansell-affiche-composant ) (progn
			 (setq cansell-curbuff (buffer-file-name (current-buffer)))
                   (if (file-accessible-directory-p (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
			(progn
                        (cd (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
                        (pri-atb-send-command  (concat "cd " (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" )))
                        )
		      (if cansell-machines-name-list
                     (progn
                        (cd (file-name-directory (car cansell-machines-name-list)))
			(pri-atb-send-command  (concat "cd " (file-name-directory (car cansell-machines-name-list))))
                   )))
			 ;;(sleep-for 0.1)
			  (if (file-exists-p (concat widget-value-cansell-le-nom-du-compo  ".ref"))
			      (find-file  (concat widget-value-cansell-le-nom-du-compo  ".ref"))
			    (progn 
			      (find-file  (concat widget-value-cansell-le-nom-du-compo  ".ref"))
			      (insert "REFINEMENT\n   ") (insert widget-value-cansell-le-nom-du-compo )



(if cansell-active 
(progn
(insert   "\nREFINES\n   ")(insert cansell-name-abstract)
))
(insert "\nEND")

			      (basic-save-buffer)))
			 (pri-atb-send-command  (concat "af " widget-value-cansell-le-nom-du-compo  ".ref"))
			 (setq pri-output-buffer PRI-COMPONENTS-LIST) 
			 (setq cansell-envoi-sml t);;(pri-atb-send-command  "sml")
)))))))
	 (widget-create  'push-button
           :tag "ar"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Add a refinement " 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn  (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-ar"))) 
		             (setq cansell-add-compo 2)(cansell-affiche-composant)
))))
(widget-insert " ")
(if (= cansell-add-compo 3)
	 (widget-create  'push-button
           :tag "ai"
	   :value ""
	   :format "%[[%t]%]"
	   :help-echo "Add a, implementation " 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn  (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-ai"))) 
		       (let ((widget-value-cansell-le-nom-du-compo (replace-in-string   (concat " " (widget-value cansell-le-nom-du-compo)) "^ +" "")))
					             (setq cansell-add-compo 0)
						     (if (string= "" widget-value-cansell-le-nom-du-compo ) (cansell-affiche-composant ) (progn
			 (setq cansell-curbuff (buffer-file-name (current-buffer)))
                   (if (file-accessible-directory-p (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
			(progn
                        (cd (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
                        (pri-atb-send-command  (concat "cd " (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" )))
                        )
		      (if cansell-machines-name-list
                     (progn
                        (cd (file-name-directory (car cansell-machines-name-list)))
			(pri-atb-send-command  (concat "cd " (file-name-directory (car cansell-machines-name-list))))
                   )))
			 ;;(sleep-for 0.1)
			  (if (file-exists-p (concat widget-value-cansell-le-nom-du-compo ".imp"))
			      (find-file  (concat widget-value-cansell-le-nom-du-compo  ".imp"))
			    (progn 
			      (find-file  (concat widget-value-cansell-le-nom-du-compo  ".imp"))
			      (insert "IMPLEMENTATION\n   ") (insert widget-value-cansell-le-nom-du-compo )(insert "\nEND")
			      (basic-save-buffer)))
			 (pri-atb-send-command  (concat "af " widget-value-cansell-le-nom-du-compo  ".imp"))
			 (setq pri-output-buffer PRI-COMPONENTS-LIST) 
			 (setq cansell-envoi-sml t);;(pri-atb-send-command  "sml")
))))))
	 (widget-create  'push-button
           :tag "ai"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Add a, implementation " 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn  (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-ai")) )
		      		             (setq cansell-add-compo 3)(cansell-affiche-composant) ))))
(widget-insert "    ")

(if (= cansell-add-compo 0)()
                     (setq cansell-le-nom-du-compo  
			    (widget-create 'editable-field
					   ;;:tag "the component name? "
					   :value ""
					   :size 10
					   :help-echo "the new component name, please!"
					   :action (lambda (widget &rest ignore)
						     (if cansell-affiche-help
							 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat  pri-balbulette-dir "/pri-HELP/pri-help-comp")))
						      (progn

(let ((widget-value-cansell-le-nom-du-compo (replace-in-string    (concat " " (widget-value cansell-le-nom-du-compo)) "^ +" "")))
(if (string= "" widget-value-cansell-le-nom-du-compo ) (cansell-affiche-composant ) 
  (cond

  ((= cansell-add-compo 1)
		       
			 
			 (setq cansell-curbuff (buffer-file-name (current-buffer)))
                   (if (file-accessible-directory-p (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
			(progn
                        (cd (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
                        (pri-atb-send-command  (concat "cd " (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" )))
                        )
		      (if cansell-machines-name-list
                     (progn
                        (cd (file-name-directory (car cansell-machines-name-list)))
			(pri-atb-send-command  (concat "cd " (file-name-directory (car cansell-machines-name-list))))
                   )))
			 ;;(sleep-for 0.1)
			 (if (file-exists-p (concat widget-value-cansell-le-nom-du-compo ".mch"))
			     (find-file  (concat widget-value-cansell-le-nom-du-compo ".mch"))
			   (progn 
			   (find-file  (concat widget-value-cansell-le-nom-du-compo ".mch"))
			   (insert "MODEL\n   ") (insert widget-value-cansell-le-nom-du-compo)(insert "\nEND")
			    (basic-save-buffer)))
			 (pri-atb-send-command  (concat "af " widget-value-cansell-le-nom-du-compo ".mch"))
			 (setq pri-output-buffer PRI-COMPONENTS-LIST) 
			 (setq cansell-envoi-sml t)) ;;(pri-atb-send-command  "sml")

  ((= cansell-add-compo 2)
			 (setq cansell-curbuff (buffer-file-name (current-buffer)))
                   (if (file-accessible-directory-p (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
			(progn
                        (cd (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
                        (pri-atb-send-command  (concat "cd " (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" )))
                        )
		      (if cansell-machines-name-list
                     (progn
                        (cd (file-name-directory (car cansell-machines-name-list)))
			(pri-atb-send-command  (concat "cd " (file-name-directory (car cansell-machines-name-list))))
                   )))
			 ;;(sleep-for 0.1)
			  (if (file-exists-p (concat widget-value-cansell-le-nom-du-compo  ".ref"))
			      (find-file  (concat widget-value-cansell-le-nom-du-compo  ".ref"))
			    (progn 
			      (find-file  (concat widget-value-cansell-le-nom-du-compo  ".ref"))
			      (insert "REFINEMENT\n   ") (insert widget-value-cansell-le-nom-du-compo )(insert "\nEND")
			      (basic-save-buffer)))
			 (pri-atb-send-command  (concat "af " widget-value-cansell-le-nom-du-compo  ".ref"))
			 (setq pri-output-buffer PRI-COMPONENTS-LIST) 
			 (setq cansell-envoi-sml t));;(pri-atb-send-command  "sml")
  ((= cansell-add-compo 3)
			 (setq cansell-curbuff (buffer-file-name (current-buffer)))
                   (if (file-accessible-directory-p (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
			(progn
                        (cd (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" ))
                        (pri-atb-send-command  (concat "cd " (concat  PRI-MODELE-dir  "/"  pri-project-name "/sources" )))
                        )
		      (if cansell-machines-name-list
                     (progn
                        (cd (file-name-directory (car cansell-machines-name-list)))
			(pri-atb-send-command  (concat "cd " (file-name-directory (car cansell-machines-name-list))))
                   )))
			 ;;(sleep-for 0.1)
			  (if (file-exists-p (concat widget-value-cansell-le-nom-du-compo ".imp"))
			      (find-file  (concat widget-value-cansell-le-nom-du-compo  ".imp"))
			    (progn 
			      (find-file  (concat widget-value-cansell-le-nom-du-compo  ".imp"))
			      (insert "IMPLEMENTATION\n   ") (insert widget-value-cansell-le-nom-du-compo )(insert "\nEND")
			      (basic-save-buffer)))
			 (pri-atb-send-command  (concat "af " widget-value-cansell-le-nom-du-compo  ".imp"))
			 (setq pri-output-buffer PRI-COMPONENTS-LIST) 
			 (setq cansell-envoi-sml t);;(pri-atb-send-command  "sml")
))
                         (setq cansell-add-compo 0))

)))))))

	(widget-insert "\n\n")  (end-of-buffer)
 (widget-setup) 
))
(eval-and-compile
(defun cansell-affiche-le-status-du-projet (l)
(if l
    (progn
      (cansell-affiche-le-status-du-projet (cdr l))
      (insert(car l)) (insert "\n")
      )
      (insert "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n")
)))
(eval-and-compile
(defun cansell-stat-composant ()
 (setq cansell-NB-pasencore 0)
(pri-atb-send-command "s *")
;;  (cansell-stat-component  cansell-liste-machine)
(while (< cansell-stat-nb-list cansell-nb-mach) (sleep-for 0.1))
 (setq cansell-mach-list-fin  nil)

 (cansell-pasencore-ic cansell-machines-name-list cansell-liste-machine)
(while (<  cansell-NB-pasencore cansell-nb-pasencore)(sleep-for 0.1))
;;(sleep-for 0.4) 
(cansell-affiche-composant)(setq cansell-affiche-dans-errors t)
))
(eval-and-compile
(defun cansell-pasencore-ic (l m)
  (if l
     (if (string= (car l) "pasencore")
     (progn
      (pri-atb-send-command (concat "ic "  (car m) ))
      ( cansell-pasencore-ic  (cdr l) (cdr m))
      ) ( cansell-pasencore-ic  (cdr l) (cdr m)))
   
)))
(eval-and-compile
(defun cansell-stat-component (l)
  (if l
    (progn
      (cansell-stat-component (cdr l))
      (pri-atb-send-command (concat "s "  (car l) ))
      )
   
)))

;;(eval-and-compile
;;(defun cansell-affiche-projet-loop (n)
;;    (let ((cansell-affiche-counter 1))
	 
;;    (while (<= cansell-affiche-counter n)
 ;;     (pri-add-button-component (car cansell-selected-projects) (car cansell-selected-machines-stat-list) (car (cdr cansell-selected-machines-stat-list))) 
 ;;     (setq  cansell-selected-projects (cdr cansell-selected-projects))
 ;;     (setq  cansell-selected-machines-stat-list (cdr (cdr cansell-selected-machines-stat-list)))
 ;;     (if cansell-selected-projects  () (prgn  (setq  cansell-selected-machines-stat-list cansell-machines-stat-list)) (setq  cansell-selected-projects cansell-liste-projet))
 ;;     (setq cansell-affiche-counter (1+ cansell-affiche-counter)) 
;; ))))

(eval-and-compile
(defun cansell-calculette-Component ()
  (if (<= (length cansell-liste-machine) cansell-number-selected-compo) 
    (progn
      (cansell-affiche-compo-loop (length cansell-liste-machine))
      (cansell-affiche-NO-next-projet)
      )
    (progn
      (setq  cansell-selected-composold cansell-selected-compo)
      (cansell-affiche-compo-loop  cansell-number-selected-compo)
      (cansell-affiche-next-projet)

))))
(eval-and-compile
(defun cansell-calculette-component (l s)
  (if l
    (progn
;;      (pri-trace (concat "Machlist: $" (car l) "$"))
;;	(set-buffer PRI-COMPONENTS-LIST)  (pop-to-buffer PRI-COMPONENTS-LIST)
      (cansell-calculette-component (cdr l) (cdr (cdr s)))
      (pri-add-button-component (car l) (car s) (car (cdr s)))
      )
;;    (if cansell-veut-status-project 
;;	(progn (cansell-affiche-le-status-du-projet cansell-status-project)(insert "\n\n\n"))
           (insert "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n") )

))
;;(eval-and-compile
;;(defun pri-add-component (component)
;;  "Affiche un composant dans le buffer des composants"
;;  (set-buffer PRI-COMPONENTS-LIST)
  ;;(goto-char (point-max))
  
;;(pri-add-button-component component)
;;))


(defconst pri-components-list-font-lock-keywords
  (purecopy
   (list

       ;; '("  .*" . pri-components-test-bold-face)

	))
  "Highlight Component" )

;;lance le mode component list
(eval-and-compile
(defun pri-components-list-mode ()

  (interactive)
  (kill-all-local-variables)
  (make-face 'pri-components-red-bold-face)
  (make-face 'pri-components-test-bold-face)
  (make-face 'pri-components-red-face)
 (make-face 'pri-components-blue-face) 
 (make-face 'pri-components-blue-bold-face)
  (make-face 'pri-components-button-red-face)
  (custom-set-faces
   '(pri-components-red-bold-face ((((class color))  (:foreground "red"))))
   '(pri-components-red-face ((((class color))  (:foreground "red"))))
   '(pri-components-blue-face ((((class color))  (:foreground "blue")))) 
   '(pri-components-blue-bold-face ((((class color))  (:foreground "blue")))) 
   '(pri-components-test-bold-face ((((class color))  (:foreground "black"))));; '(pri-components-button-red-face ((t  (:bold t) (:foreground "red"))))
)
  (make-face-bold 'pri-components-red-bold-face)
  (make-face-bold 'pri-components-blue-bold-face)
  (make-face-bold 'pri-components-test-bold-face)
 (copy-face 'widget-button-face 'pri-components-button-red-face)
(set-face-foreground 'pri-components-button-red-face"red")
 (copy-face 'widget-button-face 'pri-components-button-blue-face)
(set-face-foreground 'pri-components-button-blue-face"blue")

;;   '(pri-components-inverse-face ((((class color)) (:foreground "white" :background "black")))))
  (setq major-mode 'pri-components-list-mode)
 
  (run-hooks 'pri-components-list-mode-hook)
  (turn-on-font-lock)

  (use-local-map pri-component-mode-map)  
 (setq mode-name (concat "projet: "  pri-project-name))
  ;;File -> Exit XEmacs appelle pri-component-exit
  (pri-component-change-exit-emacs-menu)
 ;; (pri-component-toolbar)
))

(provide 'pri-components-list-mode)