;******************************* STERIA **************************************
; Fichier : $Id: pri-hypotheses-list.el,v 1.15 2000/11/03 13:54:11 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Fenetre des hypotheses
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-hypotheses-list.el,v $
; Historique : Revision 1.15  2000/11/03 13:54:11  clb
; Historique : Nouveau Menu PRI : item Customize, Save, About Emacspri, Exit.
; Historique :
; Historique : Revision 1.14  2000/11/02 11:01:19  clb
; Historique : Bug : sans le buffer des hypotheses : les hypotheses ajoutees se retrouvent
; Historique : dans le tampon old-proof.
; Historique :
; Revision 1.13  2000/10/27  13:58:36  clb
; Possibilite de tuer le buffer des hypotheses.
; Variable customizable pri-hypothesis-buffer-p.
;
; Revision 1.12  2000/10/27  10:36:32  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Historique : Revision 1.11  2000/10/26 09:47:06  clb
; Historique : Les buffers : goal, hyp, proof-tree et old-proof sont maintenant read-only.
; Historique :
; Historique : Revision 1.10  2000/10/24 08:09:29  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.9  2000/10/12 13:51:54  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Revision 1.8  2000/10/03  12:46:07  clb
; Ajout des tampons de liste des projets et des composants.
; Ils permettent a l'utilisateur de choisir plus facilement
; le projet et le composant voulu.
;
; Revision 1.7  2000/10/02  13:23:29  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.6  2000/09/28  14:24:42  clb
; Ajout de 8 boutons dans la barre d'outils Emacspri :
; stop, back, step, next, proof-tree, old-proof-tree, term, hyp
;
; Revision 1.5  2000/09/27  16:19:59  clb
; Ajout de la toolbar PRI : elle ne contient pour l'instant que le bouton Exit.
; pri-quit => pri-exit.
;
; Revision 1.4  2000/09/26  14:39:47  clb
; ajout d'un mode trace pour le debug.
; pri-trace ==> pri-terminal-print.
; enlevement du autoload de pri-trace aux endroits inutiles.
;
; Revision 1.3  2000/09/25  12:35:49  clb
; synchronisation d'Emacs et du prouvuer interactif :
; attente du prompt PRI> avant de lancer une nouvelle commande.
; enlevement des traces du debut d'Emacs dans la fenetre terminal :
; on arrive sur : PRI>.
;
; Revision 1.2  2000/06/30  09:37:44  clb
; ajout des entetes de fichiers
;
;
;*****************************************************************************

;*****************************************************************************
;; INCLUSIONS
(autoload 'PRI-HYPOTHESIS "pri-main")
(autoload 'pri-send-command "pri-terminal")

;*****************************************************************************
;; VARIABLES
(eval-and-compile
(defvar pri-hypothesis-list nil)
(defvar pri-hypothesis-debut nil)
(defvar pri-hypothesis-fin nil)
(defvar pri-hypothesis-value nil))

;*****************************************************************************
;; VARIABLES CUSTOMIZABLES
(defcustom pri-hypothesis-buffer-p nil
  "*Non-nil means use the hypothesis buffer."
  :type 'boolean
  :group 'pri)

;*****************************************************************************
;; FUNCTIONS

;*****************************************************************************
;;remet la liste des hypotheses a nil
(eval-and-compile
(defun pri-reset-hypothesis-list ()
	(setq pri-hypothesis-list nil)))

;;*****************************************************************************
;; enleve un element string a la liste des hypotheses
;; (on ne peut utiliser delq car la fonction de comparaison
;; utilisee  est eq et non string=)
(eval-and-compile
(defun pri-del-in-hypothesis-list (string)
  (let ((local-string-list pri-hypothesis-list)
		(found nil))
	(while (and (car local-string-list) (not found))
	  (progn
		(if (string= (car local-string-list) string)
			(progn
			  (setq found t)
			  (setq pri-hypothesis-list 
					(delq (car local-string-list) pri-hypothesis-list)))
		  (setq local-string-list (cdr local-string-list))))))))
  
;*****************************************************************************
;;ajout d'une hypothese
(eval-and-compile
(defun pri-add-hypothese (hypothese)
  (if  (or (string-equal " " hypothese)(string-equal "" hypothese))
	  ()
       (progn
	(setq pri-hypothesis-debut (point))
	;;on ajoute 1 a cause de l'espace entre le bouton et l'hypothese
	(setq pri-hypothesis-fin (+ 1 pri-hypothesis-debut (length hypothese)))
	(widget-create 'checkbox
				   :tag hypothese
				   :debut pri-hypothesis-debut
				   :fin pri-hypothesis-fin
				   :notify (lambda (widget &rest ignore)
							 (setq pri-hypothesis-value
								   (replace-in-string 
									(widget-get widget :tag) "&" ""))
							 (font-lock-fontify-region (widget-get widget
																   :debut)
													   (widget-get widget
																   :fin))
							 (message (concat pri-hypothesis-value
											  (if (widget-get widget :value)
												  "selected"
												"unselected")))
										; construire la liste des hypotheses

							 (if (widget-get widget :value)
							     (progn
							        (pri-prouveur-send-command  "3")
							        (pri-prouveur-send-command  "")
							      )))
							 ;;(if (widget-get widget :value)
								;; (setq  pri-hypothesis-list 
									;;	(cons pri-hypothesis-value 
										;;	  pri-hypothesis-list))
							  ;; (pri-del-in-hypothesis-list 
								;;pri-hypothesis-value)))
				   :format "%v%t\n"
				   nil)
	(font-lock-fontify-region  pri-hypothesis-debut pri-hypothesis-fin)))))

;;*****************************************************************************
;; lancement d'une commande sur une seule hypothese
;; fh(hyp) - mh(hyp)
(eval-and-compile
(defun pri-process-one-hyp-command (one-hyp-command)
  (if (cadr pri-hypothesis-list)
	  (message (concat "Only one hypothesis must be selected for " 
					   one-hyp-command))
	(pri-send-command (concat one-hyp-command "(" 
							  (car pri-hypothesis-list) ")")))))
								
;;*****************************************************************************
;; lancement d'une commande sur les hypotheses selectionnees
(eval-and-compile
(defun pri-process-hyp-command (command &optional arg)
  (let ((command-totale command)
		(local-hypothesis-list pri-hypothesis-list)
		(first-hyp t))
	(cond
	 
	 ;;ah
	 ((string-equal command "ah")
	 (progn
	   (setq command-totale (concat command-totale "("))
	   (while (car local-hypothesis-list)
		 (if (not first-hyp)
			 (setq command-totale (concat command-totale " &")))
		 (setq first-hyp nil)
		 (setq command-totale (concat command-totale 
									  (car local-hypothesis-list)))
		 (setq local-hypothesis-list (cdr local-hypothesis-list)))
	   (setq command-totale (concat command-totale ")"))
	   (pri-send-command command-totale)))

	 ;;fh
	 ((string-equal command "fh")
	  (pri-process-one-hyp-command command))

	 ;;mh
	 ((string-equal command "mh")
	  (pri-process-one-hyp-command command))  

	 ;;sh
	 ((string-equal command "sh")
	  (if (region-active-p)
	  (pri-send-command 
	   (concat command "(" (buffer-string (mark) (point)) ")"))
	  (message (concat "you must select an expression for command " command))))

	 ;;eh
	 ((string-equal command "eh")
	  (while (car local-hypothesis-list)
		(progn
		  (let ((hyp (car local-hypothesis-list)))
			(progn
			  (if (and (string-match "\\([^<>]*\\)=\\(.*\\)" hyp)
					   (string= hyp (match-string 0 hyp)))
				  (pri-send-command 
				   (concat command "(" (match-string 1 hyp) "," 
						   (match-string 2 hyp) "," arg ")"))
				(message 
				 (concat 
				  "hypothesis selected must be in the form a=b for command " 
				  command)))))
		  (setq local-hypothesis-list (cdr local-hypothesis-list)))))))))

;;*****************************************************************************
;;mode liste d'hypotheses


(eval-and-compile
(defun pri-hypotheses-list-mode ()
  "Mode de la liste d'hypotheses"
  (pop-to-buffer PRI-HYPOTHESIS)
  (pri-atelierb-mode)
  (setq mode-popup-menu  
		`("Actions on Hypothesis" 
		  [ "ah - Add hypothesis" (pri-process-hyp-command "ah") t]
		  [ "fh - False hypothesis"  (pri-process-hyp-command "fh") t] 
		  [ "eh(Goal) - Use Equality in Hypothesis in Goal" (pri-process-hyp-command "eh" "Goal") t]
		  [ "eh(AllHyp) - Use Equality in Hypothesis in All Hypothesis" (pri-process-hyp-command "eh" "AllHyp") t]
		  [ "sh - Search Hypothesis" (pri-process-hyp-command "sh") t]
		  [ "mh - Modus Ponens" (pri-process-hyp-command "mh") t]
		  ))
  ))

;;*****************************************************************************
;;declaration des services
(provide 'hypothesis-list)
