;******************************* STERIA **************************************
; Fichier : $Id: pri-projects-list.el,v 1.5 2000/10/24 08:09:33 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Mode du buffer contenant la liste de projets
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-projects-list.el,v $
; Historique : Revision 1.5  2000/10/24 08:09:33  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.4  2000/10/18 08:47:01  clb
; Historique : Correction du nombre de PO total.
; Historique : On peut maintenant rerentrer dans un meme projet/ meme composant.
; Historique :
; Historique : Revision 1.3  2000/10/12 16:10:01  clb
; Historique : Amelioration du temps de chargement : widget-setup quand il faut.
; Historique :
; Revision 1.2  2000/10/03  17:05:03  clb
; introduction de la toolbar pour la liste des projets.
; unique icone : Exit qui quitte l'AtelierB correctement, ainsi que
; File->Exit XEmacs et C-x C-c.
;
; Revision 1.1  2000/10/03  12:46:09  clb
; Ajout des tampons de liste des projets et des composants.
; Ils permettent a l'utilisateur de choisir plus facilement
; le projet et le composant voulu.
;
;
;*****************************************************************************/

;;*****************************************************************************
;;"include a la lisp"
(autoload 'pri-output-buffer "pri-tools.el")
(autoload 'PRI-PROJECTS-LIST "pri-main.el")
;;(autoload 'pri-inhibit-toolbar "pri-toolbar.el")
(autoload 'pri-atb-send-command "pri-main.el")
;;(autoload 'pri-button-red-face "pri-atelierb-mode.el")

;;*****************************************************************************
;; VARIABLES
(eval-and-compile
(defvar pri-project-name  nil "Nom du projet selectionne")
(defvar pri-project-mode-map nil "Table d'associations des touches du mode project-list.")
)

;;*****************************************************************************
;; TOOLBAR
(defun pri-project-exit ()
  (interactive)
  (if pri-process-open-p (pri-atb-send-command "q"))
  (kill-emacs)
)

(defvar cansell-number-selected-proj 25 "c'est le nombre de projets  afficher")
(defvar  cansell-new-dir-open default-directory)
(defvar cansell-begin-balbu t)

(defvar cansell-l-archive-file "")

(defvar cansell-projet-not-busy t)
(defvar cansell-rmv nil)
(defvar cansell-ap  nil)
(defvar cansell-rs  nil)


(defun pri-project-toolbar ()
  "change la barre d'outil pour mettre les outils emacspri"
  (if (and (featurep 'toolbar)
	   (console-on-window-system-p)
	   (not pri-inhibit-toolbar))
      (set-specifier default-toolbar (cons (current-buffer) pri-project::toolbar))))


;;*****************************************************************************
;; modifie le raccourci C-x C-c
(eval-and-compile
  (if pri-project-mode-map
	  nil
	(setq pri-project-mode-map (make-sparse-keymap))
	;; avant de quitter emacs on quit le prouveur interactif
	(define-key pri-project-mode-map "\C-x\C-c" 'pri-project-exit)))

;;*****************************************************************************
;; FUNCTIONS
;;*****************************************************************************
;;modifie le menu File->Exit XEmacs
(defun pri-project-change-exit-emacs-menu ()
  "modifie le menu File->Exit XEmacs... pourqu'il appelle la fonction pri-project-exit"
  (add-menu-button '("File") ["Exit XEmacs" pri-project-exit t]))


(eval-and-compile
(defun cansell-confirme-remove (project)
		      (end-of-buffer)
(widget-insert "  Confirm ")
 	 (widget-create  'push-button
           :tag "ys"
	   :value project
	   :format  "%[[%t]%]"
	   :button-face  'pri-projects-red-face
	   :help-echo ( concat "Confirm remove project "  project ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn 
			   (set-buffer "pri-help") 
			   (erase-buffer)
			   (insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rprojys")))
		       (progn (setq cansell-projet-not-busy t) (setq cansell-rmv nil)
		       (pri-atb-send-command  (concat "rp " (widget-value widget)))
		       (sleep-for 0.1)

		       (setq pri-output-buffer PRI-PROJECTS-LIST)
		       ;;(sleep-for 0.1)
		       (pri-atb-send-command  "spl"))))) 
(widget-insert " ")
 	 (widget-create  'push-button
           :tag "no"
	   :value project
	   :format  "%[[%t]%]"
	   :button-face  'pri-projects-red-face
	   :help-echo ( concat "Do not remove project "  project ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn 
			   (set-buffer "pri-help") 
			   (erase-buffer)
			   (insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rprojno")))
		       (progn  (setq cansell-projet-not-busy t) (setq cansell-rmv nil)
			 (erase-buffer)      (setq  cansell-selected-projects cansell-selected-projectsold)
			 (cansell-affiche-projet))))) 
(widget-setup)
))

(eval-and-compile
(defun pri-add-button-projet (project)
;;(set-mouse-pixel-position pri-projects-list-window  1 1  ) 
  "Affiche un projet dans le buffer des projets"
  (set-buffer PRI-PROJECTS-LIST)

 	 (widget-create  'push-button
           :tag "rp"
	   :value project
	   :format  "%[[%t]%]"
	   :help-echo ( concat "Remove project "  project ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn 
			   (set-buffer "pri-help") 
			   (erase-buffer)
			   (insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rproj")))
		      (if cansell-projet-not-busy (progn (setq cansell-projet-not-busy nil) (setq cansell-rmv t)
		           (cansell-confirme-remove(widget-value widget))
			 ))))
	   
)

(widget-insert  " ")
 	 (widget-create  'push-button
           :tag "as"
	   :value project
	   :format  "%[[%t]%]"
	   :help-echo ( concat "Archive project (source files) "  project ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn 
			   (set-buffer "pri-help") 
			   (erase-buffer)
			   (insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-arcas")))
		        (if cansell-projet-not-busy (progn (setq cansell-filegziptar (widget-value widget)) (setq cansell-gziptar t)(setq cansell-erase-pri-errors t) 
		       (pri-atb-send-command  (concat "arc " (widget-value widget) " "  PRI-MODELE-dir  "/Archives/tar" (widget-value widget) ".arc 0"  )))
	   
))))

(widget-insert  " ")
 	 (widget-create  'push-button
           :tag "ar"
	   :value project
	   :format  "%[[%t]%]"
	   :help-echo ( concat "Archive project (source and proof files) "  project ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn 
			   (set-buffer "pri-help") 
			   (erase-buffer)
			   (insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-arcar")))
		       (if cansell-projet-not-busy (progn (setq cansell-filegziptar (widget-value widget))  (setq cansell-gziptar t)(setq cansell-erase-pri-errors t) 
		       (pri-atb-send-command  (concat "arc " (widget-value widget) " "  PRI-MODELE-dir  "/Archives/tar" (widget-value widget) ".arc 2"  )))
	   
))))

(widget-insert  " ")

 	 (widget-create  'push-button
           :tag "aa"
	   :value project
	   :format  "%[[%t]%]"
	   :help-echo ( concat "Archive project (All project) "  project ) 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn 
			   (set-buffer "pri-help") 
			   (erase-buffer)
			   (insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-arcaa")))
		       (if cansell-projet-not-busy  (progn (setq cansell-filegziptar (widget-value widget)) (setq cansell-gziptar t)(setq cansell-erase-pri-errors t) 
		       (pri-atb-send-command  (concat "arc " (widget-value widget) " " PRI-MODELE-dir  "/Archives/tar" (widget-value widget) ".arc 1"  )))
	   
))))

(widget-insert  " ")
		(widget-create 'push-button
				   :tag "op"
				   :help-echo ( concat "Open project "  project ) 
				   :notify (lambda (widget &rest ignore)
					     (if cansell-affiche-help
						 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-op")))
					       (if cansell-projet-not-busy (progn 
						 (setq  cansell-selected-projects cansell-selected-projectsold)
						  (pop-to-buffer    "pri-errors" t cansell-error-frame) 
  (delete-other-windows)
						 (pri-before-writting-buffer  "pri-errors") 
						 (erase-buffer)
						 (pri-after-writting-buffer)
						       (setq pri-output-buffer PRI-PROJECTS-LIST)
							 (set-buffer PRI-PROJECTS-LIST)
							 (erase-buffer) 
							 (if (not (widget-get widget :selec))								 (progn
								   (setq pri-project-name 
										 (widget-get widget :project))
								   ;;(if (get-buffer PRI-COMPONENTS-LIST)  (kill-buffer PRI-COMPONENTS-LIST))
                                                                    (setq cansell-envoi-resources t)
                                                                    (setq cansell-load-compo t)
								   (pri-atb-send-command 
									(concat "op "pri-project-name))
								   (pri-trace pri-project-name)
								  ;; (sleep-for 0.1)
								   ))
							   
							 ;;redraw the button
							 (widget-setup)))))
					   
				   :format "%[[%t]%]"
				   :selec nil
				   :etat nil
				   :project project
				   )
(widget-insert  "    ")(widget-insert project) (widget-insert  "\n")
))

(eval-and-compile
(defun cansell-affiche-projet-loop (n)
    (let ((cansell-affiche-counter 1))
	 
    (while (<= cansell-affiche-counter n)
      (pri-add-button-projet (car cansell-selected-projects))
      (setq  cansell-selected-projects (cdr cansell-selected-projects))
      (if cansell-selected-projects  () (setq  cansell-selected-projects cansell-liste-projet))
      (setq cansell-affiche-counter (1+ cansell-affiche-counter)) 
))))

(eval-and-compile
(defun cansell-affiche-NO-next-projet()
))
(eval-and-compile
(defun cansell-affiche-next-projet()

 (widget-insert "\n")

 
 (widget-insert  "PROJ ")
  	 (widget-create  'push-button
           :tag "++"
	   :value ""
	   :help-echo "Another project"
	   :button-face  'pri-projects-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-plus-minus")))
		        (if cansell-projet-not-busy (progn
 			      (setq  cansell-selected-projects cansell-selected-projectsold)
                             (if (< cansell-number-selected-proj (- cansell-height 14)) (setq cansell-number-selected-proj (+ 1 cansell-number-selected-proj)))
			     (cansell-affiche-projet))

)))) 

 (widget-insert " ") 
(if (> cansell-number-selected-proj)
 (progn
   	 (widget-create  'push-button
           :tag "--"
	   :value ""
	   :help-echo "Another project"
	   :button-face  'pri-projects-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-plus-minus")))
		      	 (if cansell-projet-not-busy			    (progn
			               (setq  cansell-selected-projects cansell-selected-projectsold)
				      (setq cansell-number-selected-proj (1- cansell-number-selected-proj))
				      (cansell-affiche-projet))))))
(widget-insert  " " )
  	 (widget-create  'push-button
           :tag "np"
	   :value ""
	   :help-echo "Next projects"
	   :button-face  'pri-projects-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-nh")))
		       (if cansell-projet-not-busy (progn
			       ;;(setq  cansell-selected-projects (cdr cansell-selected-projectsold))
			       (if cansell-selected-projects  () (setq  cansell-selected-projects cansell-liste-projet))
				(cansell-affiche-projet)
				
  )))))) 
 (widget-insert  "         " ))

     
;; (widget-insert " ")     
 (widget-insert  "  ------ " )
(widget-insert  (concat " ("  (int-to-string cansell-number-selected-proj) "/" (int-to-string (length cansell-liste-projet)) ") \n" )  )
(widget-setup)(end-of-buffer)
))

(eval-and-compile
(defun cansell-calculette-projet ()
  (if (<= (length cansell-liste-projet) cansell-number-selected-proj) 
    (progn
      (cansell-affiche-projet-loop (length cansell-liste-projet))
      (cansell-affiche-NO-next-projet)
      )
    (progn
      (setq  cansell-selected-projectsold cansell-selected-projects)
      (cansell-affiche-projet-loop  cansell-number-selected-proj)
      (cansell-affiche-next-projet)

))))

(eval-and-compile
(defun cansell-add-a-new-project ()
  (let ((cansell-name-proj (replace-in-string    (concat " " (widget-value cansell-le-nom-du-projet)) "^ +" ""))
        )
  (if  (not (string=  "" cansell-name-proj))
	

	(progn
          (widget-delete  cansell-le-nom-du-projet)
         ;; (widget-delete cansell-le-widget-du-dp)
 (setq cansell-projet-not-busy t)(setq cansell-ap nil)
          (make-directory-path   (concat PRI-MODELE-dir  "/"  cansell-name-proj  "/bdp" ))
	  (shell-command (concat "cp  " pri-balbulette-dir "/PatchProver " PRI-MODELE-dir  "/"  cansell-name-proj  "/bdp" ))
       (make-directory-path   (concat   PRI-MODELE-dir  "/"  cansell-name-proj  "/exec" ))
          (make-directory-path   (concat   PRI-MODELE-dir  "/"   cansell-name-proj  "/sources" ))

	  (pri-atb-send-command  (concat "crp "  cansell-name-proj " " (concat  PRI-MODELE-dir  "/"  cansell-name-proj  "/bdp" ) " " (concat   PRI-MODELE-dir  "/"  cansell-name-proj  "/exec")))
	;;	       (sleep-for 0.1)
	  (setq pri-output-buffer PRI-PROJECTS-LIST)
	  (pri-atb-send-command "spl"))

))))

(eval-and-compile
(defun cansell-restore-a-project ()
  (let ((cansell-name-proj (replace-in-string    (concat " " (widget-value cansell-le-nom-du-projet)) "^ +" ""))
)
               
  (if (and (not (string=  "" cansell-name-proj)) (not (string=  "" cansell-l-archive-file)))
	

	(progn
         (if (string-match "\\.gz$" cansell-l-archive-file)
            (progn
             (shell-command (concat "gzip -d " cansell-l-archive-file))
             (setq cansell-l-archive-file (substring cansell-l-archive-file 0 (match-beginning 0)))))
          (widget-delete  cansell-le-nom-du-projet)
         ;; (widget-delete cansell-le-widget-du-dp)
 (setq cansell-projet-not-busy t)(setq cansell-rs nil)
	  (pri-atb-send-command  (concat "res "   cansell-l-archive-file   cansell-rs-nb  cansell-name-proj " " PRI-MODELE-dir  "/" cansell-name-proj ))
	;;	       (sleep-for 0.1)
          (setq cansell-l-archive-file "")
	  (setq pri-output-buffer PRI-PROJECTS-LIST)
	  (pri-atb-send-command "spl"))

))))

(defcustom cansell-toolbar-open-dir 'cd
  "*Function to call when the open icon is selected."
  :type '(radio (function-item cd)
                (function :tag "Other"))
  :group 'toolbar)

(defcustom cansell-toolbar-make-dir 'make-directory-path
  "*Function to call when the open icon is selected."
  :type '(radio (function-item make-directory-path)
                (function :tag "Other"))
  :group 'toolbar)

(defcustom cansell-toolbar-open-file 'find-file
  "*Function to call when the open icon is selected."
  :type '(radio (function-item find-file)
                (function :tag "Other"))
  :group 'toolbar)

(eval-and-compile
(defun cansell-open-file ()
 (interactive)
  (setq cansell-old-dir default-directory)
  (cd  (concat PRI-MODELE-dir  "/Archives/"))
  (setq cansell-new-file-open (call-interactively cansell-toolbar-open-file ))
  (setq  default-directory cansell-old-dir)
 cansell-new-file-open
))

(eval-and-compile
(defun cansell-make-dir ()
 (interactive)
  (setq cansell-old-dir default-directory)
  (cd cansell-new-dir-open)
  (setq cansell-new-dir-open (call-interactively cansell-toolbar-make-dir ))
  (setq  default-directory cansell-old-dir)
 cansell-new-dir-open
))

(eval-and-compile
(defun cansell-choose-dir ()
 (interactive)
  (setq cansell-old-dir default-directory)
  (cd cansell-new-dir-open)
  (setq cansell-new-dir-open (call-interactively cansell-toolbar-open-dir))
  (setq  default-directory cansell-old-dir)
 cansell-new-dir-open
))
(eval-and-compile
(defun cansell-compense (n)
(if (= n 0) ()
 (progn (pri-before-writting-buffer  PRI-PROJECTS-LIST)(insert "\n")(pri-after-writting-buffer)( cansell-compense (1- n)))
)))

(eval-and-compile
(defun cansell-affiche-projet ()
		 (setq pri-output-buffer PRI-COMPONENTS-LIST)
                 (pri-before-writting-buffer  PRI-PROJECTS-LIST)
                 (if (or cansell-ap  cansell-rs) (widget-delete  cansell-le-nom-du-projet))(erase-buffer) 
		      (cansell-compense (- (- cansell-height 14) (min cansell-number-selected-proj (length cansell-liste-projet)))) 
                 (cansell-calculette-projet)
                 (cansell-calculette-basse-projet) (widget-setup)(insert "\n\n")
		 (if cansell-rmv (cansell-confirme-remove "project"))
(if cansell-ap ( cansell-init-projet ))
(if cansell-rs ( cansell-restore-projet)) (widget-setup)
(goto-char (point-max))
 (pri-projects-list-mode)
      (font-lock-fontify-buffer)   
		 (pri-after-writting-buffer) 
		
))

(eval-and-compile
(defun cansell-init-projet ()
		      (end-of-buffer)
		      (setq cansell-le-directory-dbp "")
		      (setq  cansell-le-directory-exec "") 
		      (widget-insert " name of the project  ")
                      (setq cansell-le-nom-du-projet  
			    (widget-create 'editable-field
					   ;;:tag "the project name? "
					   :value ""
					   :size 16
					   :help-echo "the new project name, please!"
					   :action (lambda (widget &rest ignore)
						     (if cansell-affiche-help
							 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-proj")))
						       (cansell-add-a-new-project) ))))
;;		      (widget-insert "\n     directory name   ")
;;
;;			    (widget-create		      
;;			     'push-button
;;			     :tag "dp"
;;			     :value "Directory project"
;;			     :format  "%[[%t]%]"
;;;			     :help-echo "The directory of the project" 
;;			     :notify (lambda (widget &rest ignore) 
;;				       (if cansell-affiche-help
;;					   (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-bd")))
;;					 (progn
;;					   (setq cansell-le-directory-dp (cansell-make-dir)
;;					   (goto-char (widget-field-start cansell-le-widget-du-dp)) 
;;					   (insert cansell-le-directory-dp) (cansell-add-a-new-project) ))))
;;			     (widget-insert " ")
;;			     (setq cansell-le-widget-du-dp
;;				   (widget-create 'editable-field
;;						  ;;:tag "the project name? "
;;						  :value ""
;;						  :size 16
;;						  :help-echo "the new  directory name, please! (use the [dp] button to browse)"
;;						  :action (lambda (widget &rest ignore)
;;							    (if cansell-affiche-help
;;								(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-bd")))
;;							      (cansell-add-a-new-project) ))))
;;			     

			     (widget-insert "\n          ")(widget-setup)


			     (goto-char (widget-field-start cansell-le-nom-du-projet))
))
(eval-and-compile
(defun cansell-restore-projet ()
		      (end-of-buffer)
		      (setq cansell-le-directory-dbp "")
		      (setq  cansell-le-directory-exec "") 
		      (widget-insert " name of the project  ")
                      (setq cansell-le-nom-du-projet  
			    (widget-create 'editable-field
					   ;;:tag "the project name? "
					   :value ""
					   :size 16
					   :help-echo "the new project name, please!"
					   :action (lambda (widget &rest ignore)
						     (if cansell-affiche-help
							 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-proj")))
						       (cansell-restore-a-project) ))))
		      (widget-insert "\n     file name   ")

			    (widget-create		      
			     'push-button
			     :tag "dp"
			     :value "Directory project"
			     :format  "%[[%t]%]"
			     :help-echo "File of the archive project"
			     :notify (lambda (widget &rest ignore) 
				       (if cansell-affiche-help
					   (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-bd")))
					 (progn
					    (setq cansell-old-dir default-directory)
  (cd  (concat PRI-MODELE-dir  "/Archives/"))

 (setq cansell-l-archive-file ( buffer-file-name   (toolbar-open)))
  (kill-this-buffer)    
  (setq  default-directory cansell-old-dir)
					   ;;(goto-char (widget-field-start cansell-le-widget-du-dp)) 
					   ;;(insert cansell-le-directory-dp) 
                                           (cansell-restore-a-project) ))))
			     (widget-insert " ")
;;			     (setq cansell-le-widget-du-dp
;;				   (widget-create 'editable-field
;;						  ;;:tag "the project name? "
;;						  :value ""
;;						  :size 16
;;						  :help-echo "the new  directory name, please! (use the [dp] button to browse)"
;;						  :action (lambda (widget &rest ignore)
;;							    (if cansell-affiche-help
;;								(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-bd")))
;;							      (cansell-add-a-new-project) ))))
;;			     

			     (widget-insert "\n          ")(widget-setup)


			     (goto-char (widget-field-start cansell-le-nom-du-projet))
))

(eval-and-compile
(defun cansell-calculette-basse-projet ()
(widget-insert  "\n\n")(end-of-buffer)
(widget-create  'push-button
           :tag "qu"
	   :value ""
	   :help-echo "Quit Atelier B"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-quit-atb")) )
		        (pri-project-exit))
			
			    
		       )) 
(widget-insert " ")
(if cansell-affiche-help
(widget-create  'push-button
           :tag "hp"
	   :value ""
	   :help-echo "Help?"
	   :button-face  'pri-projects-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (progn
		       (setq cansell-affiche-help (not cansell-affiche-help))
		       (setq  cansell-selected-projects cansell-selected-projectsold)(cansell-affiche-projet)
			 		      (set-buffer "pri-help")  (pri-errors-mode)(erase-buffer)
		       (pop-to-buffer    "pri-errors"  t cansell-error-frame) 
  (delete-other-windows)
			    
		       ))) 
(widget-create  'push-button
           :tag "hp"
	   :value ""
	   :help-echo "Help?"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (progn
		       (setq cansell-affiche-help (not cansell-affiche-help))(setq  cansell-selected-projects cansell-selected-projectsold)(cansell-affiche-projet)
		         (pop-to-buffer    "pri-help" t  cansell-error-frame) 
  (delete-other-windows)(set-buffer "pri-help") (erase-buffer) (insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-start"))(pri-errors-mode)(font-lock-fontify-buffer) 
			
			    
		       ))) )

(widget-insert " ")
	 (widget-create  'push-button
           :tag "ap"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Add a projet " 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ap")) ) 
		        (if cansell-projet-not-busy (progn
			 (setq cansell-ap t)(setq cansell-projet-not-busy nil) (cansell-init-projet)
			 )))))
(widget-insert "\n")
	 (widget-create  'push-button
           :tag "rs"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Restore a projet (source files) " 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rs")))  
		        (if cansell-projet-not-busy (progn
			  (setq cansell-projet-not-busy nil)(setq cansell-rs-nb " 0 ")(setq cansell-rs t)(cansell-restore-projet)(widget-setup)
			 )))))
(widget-insert " ")

	 (widget-create  'push-button
           :tag "rr"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Restore a projet  (source and proof files) " 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rr"))  )
		        (if cansell-projet-not-busy (progn
			  (setq cansell-projet-not-busy nil)(setq cansell-rs-nb " 2 ")(setq cansell-rs t)(cansell-restore-projet)(widget-setup)
			 )))))
(widget-insert " ")

	 (widget-create  'push-button
           :tag "ra"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Restore a projet (All project)" 
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ra")))  
		        (if cansell-projet-not-busy (progn
			  (setq cansell-projet-not-busy nil)(setq cansell-rs-nb " 1 ")(setq cansell-rs t)(cansell-restore-projet)(widget-setup)
			 )))))


(end-of-buffer)(widget-setup)

))
(defconst pri-projects-list-font-lock-keywords
  (purecopy
   (list
        '( "PROJ" . pri-projects-blue-bold-face)

       ;;'("  .+" . pri-projects-test-bold-face)

	))
  "Highlight Project" )
;;lance le mode projects-list
(eval-and-compile
(defun pri-projects-list-mode ()
  "Liste des projets de l'AtelierB"
  (interactive)
  (kill-all-local-variables)
  (make-face 'pri-projects-red-bold-face)
  (make-face 'pri-projects-test-bold-face)
  (make-face 'pri-projects-red-face)
 (make-face 'pri-projects-blue-face) 
 (make-face 'pri-projects-blue-bold-face)
  (make-face 'pri-projects-button-red-face)
  (custom-set-faces
   '(pri-projects-red-bold-face ((((class color))  (:foreground "red"))))
   '(pri-projects-red-face ((((class color))  (:foreground "red"))))
   '(pri-projects-blue-face ((((class color))  (:foreground "blue")))) 
   '(pri-projects-blue-bold-face ((((class color))  (:foreground "blue")))) 
   '(pri-projects-test-bold-face ((((class color))  (:foreground "black"))));; '(pri-projects-button-red-face ((t  (:bold t) (:foreground "red"))))
)
  (make-face-bold 'pri-projects-red-bold-face)
  (make-face-bold 'pri-projects-blue-bold-face)
  (make-face-bold 'pri-projects-test-bold-face)
 (copy-face 'widget-button-face 'pri-projects-button-red-face)
(set-face-foreground 'pri-projects-button-red-face"red")
 (copy-face 'widget-button-face 'pri-projects-button-blue-face)
(set-face-foreground 'pri-projects-button-blue-face"blue")

;;   '(pri-projects-inverse-face ((((class color)) (:foreground "white" :background "black")))))
  (setq major-mode 'pri-projects-list-mode)

  (run-hooks 'pri-projects-list-mode-hook)
  (turn-on-font-lock)

  (use-local-map pri-project-mode-map)  

  ;;File -> Exit XEmacs appelle pri-project-exit
  (pri-project-change-exit-emacs-menu)
  ;;(pri-project-toolbar)
))

(provide 'pri-projects-list-mode)

