;******************************* STERIA **************************************
; Fichier : $Id: pri-terminal.el,v 1.26 2000/11/08 10:51:55 clb Exp $
;
; (C) 2000 STERIA
;
; Description : Fenetre de saisie des commandes
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-terminal.el,v $
; Historique : Revision 1.26  2000/11/08 10:51:55  clb
; Historique : Correction bug interruption sur cubitus.
; Historique :
; Revision 1.25  2000/11/03  16:32:34  clb
; Correction des interruptions.
; Rattrappage de certains messages du kernel.
;
; Revision 1.24  2000/10/27  10:36:35  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Revision 1.23  2000/10/26  15:49:33  clb
; Correction du systeme d'interruption pour hp et linux.
;
; Historique : Revision 1.22  2000/10/25 15:16:58  clb
; Historique : On ne lance plus l'interruption si le prouveur n'est pas entrain de tourner.
; Historique : impression du message : process is not busy dans la fenetre pri-log.
; Historique :
; Revision 1.21  2000/10/25  13:18:14  clb
; sortie correcte d'emacs sur HP (bug 2628).
; commande "clp" sans argument.
; script emacspri --eval au lieu de -eval.
;
; Historique : Revision 1.20  2000/10/24 08:09:34  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.19  2000/10/18 14:36:04  clb
; Historique : ouverture d'un composant sur la liste des POs.
; Historique : clic sur une PO => ouverture du tampon Log.
; Historique :
; Historique : Revision 1.18  2000/10/18 07:56:03  clb
; Historique : remise du en place du pri-output-filter de jfm :
; Historique : fin du tronquage de certains messages
; Historique :
; Historique : Revision 1.17  2000/10/13 08:01:05  clb
; Historique : correction du bug sur la fenetre OLD-PROOF.
; Historique : rattrappage des messages de parsing du kernel.
; Historique : possibilite de lancer l'interface avec une option. ex: extra_large.
; Historique :
; Historique : Revision 1.16  2000/10/12 16:10:01  clb
; Historique : Amelioration du temps de chargement : widget-setup quand il faut.
; Historique :
; Historique : Revision 1.15  2000/10/12 13:51:55  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Historique : Revision 1.14  2000/10/10 16:03:49  clb
; Historique : Ajout du bouton Exit dans la fenetre des composants.
; Historique : Exit dans le mode de preuve interactive revient a la liste des composants.
; Historique :
; Revision 1.13  2000/10/03  15:26:25  clb
; Ajout du but dans la fenetre Log.
; Ajout de cmd: et goal: en inverse video dans la fenetre log.
;
; Revision 1.12  2000/10/03  12:46:09  clb
; Ajout des tampons de liste des projets et des composants.
; Ils permettent a l'utilisateur de choisir plus facilement
; le projet et le composant voulu.
;
; Revision 1.11  2000/10/02  13:23:32  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.10  2000/09/28  14:48:58  clb
; pri-terminal-print => pri-log-print (pri-terminal.el => pri-log.el)
;
; Revision 1.9  2000/09/27  16:20:01  clb
; Ajout de la toolbar PRI : elle ne contient pour l'instant que le bouton Exit.
; pri-quit => pri-exit.
;
; Revision 1.8  2000/09/27  14:01:31  clb
; Files->Exit Emacs et C-x C-c quittent le prouveur interactif.
; la commande "qu" du prouveur quitte Emacs
;
; Revision 1.7  2000/09/26  14:48:04  clb
; deplacement de la fonction pri-terminal-print de
; pri-tools.el vers pri-terminal.el
;
; Revision 1.6  2000/09/26  14:39:51  clb
; ajout d'un mode trace pour le debug.
; pri-trace ==> pri-terminal-print.
; enlevement du autoload de pri-trace aux endroits inutiles.
;
; Revision 1.5  2000/09/26  10:28:55  clb
; ajout de la fonction d'interrruption :
; clic souris droit dans la fenetre Terminal => Interrupt
;
; Revision 1.4  2000/09/25  12:35:50  clb
; synchronisation d'Emacs et du prouvuer interactif :
; attente du prompt PRI> avant de lancer une nouvelle commande.
; enlevement des traces du debut d'Emacs dans la fenetre terminal :
; on arrive sur : PRI>.
;
; Revision 1.3  2000/09/22  14:49:25  clb
; Enlevement des blancs inutiles dans la fenetre Log.
;
; Historique : Revision 1.2  2000/06/30 09:37:47  clb
; Historique : ajout des entetes de fichiers
; Historique :
;
;*****************************************************************************
(autoload 'pri-traiter "pri-tools.el")
;;(autoload 'pri-toolbar "pri-toolbar.el")
(autoload 'pri-log-print "pri-log.el")
(autoload 'PRI-PROCESS "pri-main.el")

(defvar  cansell-pas-fini-les-interrupt nil)
;;*****************************************************************************
;; VARIABLES
(eval-and-compile
(defvar pri-process-busy nil "Non-nil quand on attend le prompt PRI>")
(defvar pri-process-open-p nil "Non-nil si le prouveur interactif est actif"))


;;*****************************************************************************
;;fonction qui attend la reception du promt PRI> ou du message fin de preuve
;; Cette fonction est utilisee avant de lancer une nouvelle commande
(eval-and-compile
(defun pri-process-wait (process)
  "attend la reception du promt bbatch>  ou PRI>. Cette fonction est utilisee avant de lancer une nouvelle commande"
  (while (and process
			  (eq (process-status process) 'run)
			  pri-process-busy
  (accept-process-output process)))))

;;*****************************************************************************
;;fonction qui transmet la commande command a l'AtelierB (startBB)
(eval-and-compile
(defun pri-atb-send-command (command)
 (pri-trace (concat "cmd: " command))
  (process-send-string PRI-PROCESS (concat command "\n"))
  (setq pri-process-busy t)
))


;;*****************************************************************************
;;fonction qui transmet la commande command au prouveur interactif
(eval-and-compile
(defun pri-prouveur-send-command (command)
 
  (if cansell-exist-le-champs (if  (string= "" (widget-value le-champ-editable))()(setq cansell-old-value-widget (widget-value le-champ-editable)))) 
  (pri-process-wait (get-process PRI-PROCESS))
 (pri-trace (concat "cmd: " command))
  (process-send-string PRI-PROCESS (concat command "\n"))
  (setq pri-process-busy t)))


;;fonction de filtrage de la sortie du process
(eval-and-compile
(defun pri-output-filter (process string)
    (mapc
   (function
	(lambda (x)
	  	  (if (char-equal x ?\n)
		  (progn
			(if (cdr pri-memory)
				(progn ;; (pri-trace (concat pri-memory))
				  (pri-traiter (concat (cdr pri-memory)))
				  ))
				(progn (setq pri-memory (cons x nil)) (setq cansell-pri-memory   pri-memory ))
)(progn ;;(pri-trace (concat pri-memory))
		(setcdr cansell-pri-memory  (cons x nil)) (setq   cansell-pri-memory (cdr  cansell-pri-memory ))
))))
   string)
  ));;
;;*****************************************************************************
;;quitte le mode PRI : quitte le prouveur interactif
(eval-and-compile
(defun pri-exit ()
  "Quitte le prouveur interactif"
  (interactive)
(setq cansell-exist-le-champs nil)
  (if pri-process-open-p
	  (pri-send-command "qu"))

;;(save-buffer)


(set-window-buffer  pri-error-list-window "pri-errors")
;;(sleep-for 0.4)
;;(if cansell-not-sv-nv (progn (pri-atb-send-command  "sml")))
))

;;*****************************************************************************
;; gestion des interruptions
(defun pri-ppid-cmd (pid)
  "retourne le pid du pere du processus d'id pid, soit le ppid de pid"
	;;(pri-trace (concat "-->pri-ppid-cmd : " pid))  
	(let* ((cmd  
			(concat "/bin/ps -e -o pid,ppid"
					" | grep "
				 	pid
				  " | cut -c-5 |grep -v " 
				   pid
				  "\n"))
		   (ppid (shell-command-to-string cmd)))
	;; on enleve le \n final
	 ;; (pri-trace (concat "ppid : " ppid))
	 ;; (pri-trace (concat "cmd : " cmd))
	  (if (not (string= ppid ""))
		  (substring ppid 0 (- (length ppid) 1)))))

(defun pri-interrupt ()
  "fonction d'interruption du kernel"
	
  (process-send-signal 'SIGINT PRI-PROCESS)
)

(defun pri-old-interrupt ()
  "fonction d'interruption du kernel"
	
		(progn
		  (let* ((pri-bbatch-pid (pri-ppid-cmd (int-to-string (process-id (get-process PRI-PROCESS)))))
				 
				 )
			(shell-command (concat "kill -2 " pri-bbatch-pid) nil)
			
			))
)


(defun pri-very-ancien-interrupt ()
  "fonction d'interruption du kernel"
	(if pri-process-busy
		(progn
		  (let* ((pri-startBB-pid (int-to-string (process-id (get-process PRI-PROCESS))))
				 (pri-bbatch-pid (pri-ppid-cmd pri-startBB-pid))
				 (pri-kernel-pid (pri-ppid-cmd pri-bbatch-pid)))
			(shell-command (concat "kill -15 " pri-kernel-pid) nil)
			(setq pri-process-busy nil)
			(pri-send-command "interrupt_po")))
	  (pri-log-print "process is not busy")))

;;****************************************************************************
;;le minibuffer sert de terminal
(defvar pri-interactive-send-command-p t "indique s'il faut lancer pri-send-command de facon interactive")

(defun pri-send-command (pri-command)
  "Envoie une commande au prouveur interactif"
;;  (interactive 
;;    (progn
;; 	 (let* ((pri-list 
;; 			 (list (read-from-minibuffer "PRI> " nil read-expression-map nil
;; 									;; ;; 		'read-expression-history))))
;; ;; 	   (setq pri-interactive-send-command-p t)
;; 	   pri-list)))
;;   (progn
;; 	(setq read-expression-history (cons pri-command read-expression-history;; ))
	(pri-prouveur-send-command pri-command))


(provide 'pri-atb-send-command)
(provide 'pri-prouveur-send-command)

