;******************************* STERIA **************************************
; Fichier : $Id: pri-tools.el,v 1.41 2000/11/08 17:35:03 clb Exp $
;
; (C) 2000 STERIA
;
; Description : traitement des messages du prouveur
;               
; Auteur(s) :  clb
;
; Historique : $Log: pri-tools.el,v $
; Historique : Revision 1.41  2000/11/08 17:35:03  clb
; Historique : rattrappage de l'erreur si le composant n'a pas de PO.
; Historique :
; Revision 1.40  2000/11/08  15:35:37  clb
; Proved !!! => PO Proved
;
; Revision 1.39  2000/11/08  13:38:21  clb
; Message Proved!!! quand une PO est prouvee.
;
; Revision 1.38  2000/11/07  15:44:27  clb
; Correction du nom de l'operation courante.
;
; Revision 1.37  2000/11/07  11:15:30  clb
; Positionnement du curseur dans la fenetre pri-log :
; moins de ligne blanche en dessous de l'info utile.
;
; Revision 1.36  2000/11/06  17:06:21  clb
; Correction du bug 2583 : reponse a NextPO.
;
; Historique : Revision 1.35  2000/11/06 11:29:21  clb
; Historique : Correction de l'expression des messages du kernel.
; Historique :
; Revision 1.34  2000/11/03  16:32:35  clb
; Correction des interruptions.
; Rattrappage de certains messages du kernel.
;
; Revision 1.33  2000/11/03  10:36:55  clb
; Correction du nom du composant : TAB en moins.
; modification de l'etat de la PO courante : on n'a plus saved...
;
; Historique : Revision 1.32  2000/11/02 11:01:20  clb
; Historique : Bug : sans le buffer des hypotheses : les hypotheses ajoutees se retrouvent
; Historique : dans le tampon old-proof.
; Historique :
; Revision 1.31  2000/10/30  17:24:29  clb
; Les parties ininteressantes de l'arbre de preuve sont cachees par defaut.
;
; Revision 1.30  2000/10/27  15:04:21  clb
; Correction des problemes de curseur :
; il va en debut de buffer dans les liste des projets/composants/pos,
; et en fin de buffer pour pri-log.
;
; Revision 1.29  2000/10/27  13:58:39  clb
; Possibilite de tuer le buffer des hypotheses.
; Variable customizable pri-hypothesis-buffer-p.
;
; Revision 1.28  2000/10/27  10:36:36  clb
; Le buffer *scratch* n'est plus en mode PRI.
; Correction des C-x C-c et File->Exit Emacs.
;
; Historique : Revision 1.27  2000/10/26 09:47:07  clb
; Historique : Les buffers : goal, hyp, proof-tree et old-proof sont maintenant read-only.
; Historique :
; Revision 1.26  2000/10/26  09:08:25  clb
; Vidage du buffer pri-log au changement de PO.
; Rattrappage des erreurs en cas de lock sur le composant choisi.
;
; Revision 1.25  2000/10/25  13:18:15  clb
; sortie correcte d'emacs sur HP (bug 2628).
; commande "clp" sans argument.
; script emacspri --eval au lieu de -eval.
;
; Revision 1.24  2000/10/24  13:23:35  clb
; correction de la valeur de PRI-PROCESS en version 3.6 de l'AtelierB.
;
; Historique : Revision 1.23  2000/10/24 08:09:34  clb
; Historique : Modification des messages pour la version 3.6 de l'AtelierB.
; Historique :
; Historique : Revision 1.22  2000/10/18 14:36:04  clb
; Historique : ouverture d'un composant sur la liste des POs.
; Historique : clic sur une PO => ouverture du tampon Log.
; Historique :
; Historique : Revision 1.21  2000/10/18 08:47:02  clb
; Historique : Correction du nombre de PO total.
; Historique : On peut maintenant rerentrer dans un meme projet/ meme composant.
; Historique :
; Historique : Revision 1.20  2000/10/13 08:01:05  clb
; Historique : correction du bug sur la fenetre OLD-PROOF.
; Historique : rattrappage des messages de parsing du kernel.
; Historique : possibilite de lancer l'interface avec une option. ex: extra_large.
; Historique :
; Historique : Revision 1.19  2000/10/12 16:10:01  clb
; Historique : Amelioration du temps de chargement : widget-setup quand il faut.
; Historique :
; Historique : Revision 1.18  2000/10/12 13:51:55  clb
; Historique : Suppression de la fenetre global situation :
; Historique : les infos se retrouvent dans la ligne de mode (modeline).
; Historique :
; Historique : Revision 1.17  2000/10/10 16:03:49  clb
; Historique : Ajout du bouton Exit dans la fenetre des composants.
; Historique : Exit dans le mode de preuve interactive revient a la liste des composants.
; Historique :
; Historique : Revision 1.16  2000/10/10 13:05:37  clb
; Historique : modification du script emaspri :
; Historique : ATELIERB_VERSION=version 3.5 ou 3.6 de l'atelier.
; Historique : ATELIERB_DIR=directory de l'executable startBB
; Historique :
; Revision 1.15  2000/10/03  17:05:03  clb
; introduction de la toolbar pour la liste des projets.
; unique icone : Exit qui quitte l'AtelierB correctement, ainsi que
; File->Exit XEmacs et C-x C-c.
;
; Revision 1.14  2000/10/03  15:26:25  clb
; Ajout du but dans la fenetre Log.
; Ajout de cmd: et goal: en inverse video dans la fenetre log.
;
; Revision 1.13  2000/10/03  12:46:10  clb
; Ajout des tampons de liste des projets et des composants.
; Ils permettent a l'utilisateur de choisir plus facilement
; le projet et le composant voulu.
;
; Revision 1.12  2000/10/02  15:40:34  clb
; Amelioration de la fenetre Log :
; 	suppression du prompt
; 	ajout des couleurs et de la toolbar
;
; Revision 1.11  2000/10/02  13:23:33  clb
; Suppression de la fenetre terminal.
; C'est le minibuffer qui sert de terminal.
; Revue des autoloads suite a la compilation de tous les fichiers.
; La seule fenetre au debut est la fenetre Log.
; Correction de pri-version qui etait defini deux fois differements.
; Ajout du fichier pri-traces.el
;
; Revision 1.10  2000/09/28  14:48:58  clb
; pri-terminal-print => pri-log-print (pri-terminal.el => pri-log.el)
;
; Revision 1.9  2000/09/28  14:24:47  clb
; Ajout de 8 boutons dans la barre d'outils Emacspri :
; stop, back, step, next, proof-tree, old-proof-tree, term, hyp
;
; Revision 1.8  2000/09/27  14:01:31  clb
; Files->Exit Emacs et C-x C-c quittent le prouveur interactif.
; la commande "qu" du prouveur quitte Emacs
;
; Revision 1.7  2000/09/26  14:48:05  clb
; deplacement de la fonction pri-terminal-print de
; pri-tools.el vers pri-terminal.el
;
; Revision 1.6  2000/09/26  14:39:51  clb
; ajout d'un mode trace pour le debug.
; pri-trace ==> pri-terminal-print.
; enlevement du autoload de pri-trace aux endroits inutiles.
;
; Revision 1.5  2000/09/26  13:10:29  clb
; correction du bug 2565.
;
; Revision 1.4  2000/09/25  12:35:51  clb
; synchronisation d'Emacs et du prouvuer interactif :
; attente du prompt PRI> avant de lancer une nouvelle commande.
; enlevement des traces du debut d'Emacs dans la fenetre terminal :
; on arrive sur : PRI>.
;
; Revision 1.3  2000/09/22  14:49:25  clb
; Enlevement des blancs inutiles dans la fenetre Log.
;
; Historique : Revision 1.2  2000/06/30 09:37:47  clb
; Historique : ajout des entetes de fichiers
; Historique :
;
;*****************************************************************************
(autoload 'pri-atb-send-command "pri-terminal")
(autoload 'pri-send-command "pri-terminal")
(autoload 'pri-interactive-send-command-p "pri-terminal")
(autoload 'PRI-PROCESS "pri-main")
(autoload 'pri-log-print "pri-log")
(autoload 'pri-log-print-p "pri-log")
(autoload 'pri-add-po "pri-po-state")
(autoload 'pri-reset-po "pri-po-state")
(autoload 'pri-modeline "pri-po-state")
(autoload 'pri-beginning-p "pri-po-state")
(autoload 'pri-add-hypothese "pri-hypotheses-list")
(autoload 'pri-reset-hypothesis-list "pri-hypotheses-list")
(autoload 'pri-hypothesis-buffer-p "pri-hypotheses-list")
(autoload 'pri-trace "pri-traces")
(autoload 'PRI-LOG "pri-main")
(autoload 'PRI-GOAL "pri-main")
(autoload 'PRI-HYPOTHESIS "pri-main")
(autoload 'PRI-OLD-PROOF "pri-main")
(autoload 'PRI-PROOF-TREE "pri-main")
(autoload 'PRI-PO-LIST "pri-main")
(autoload 'PRI-PROJECTS-LIST "pri-main")
(autoload 'PRI-COMPONENTS-LIST "pri-main")
(autoload 'pri-components-list-window "pri-main")
(autoload 'pri-error-list-window "pri-main")
(autoload 'pri-components-list-mode "pri-components-list")
(autoload 'pri-atelierb-mode  "pri-atelierb-mode")
(require 'widget)
(autoload 'widget-insert "wid-edit")
(autoload 'widget-setup "wid-edit")


(eval-when-compile
  (require 'wid-edit)
  (load "pri-messages.el")
  (load "pri-main.el")
  (load "pri-log.el")
  (load "pri-terminal.el")
  (load "pri-po-state.el")
  (load "pri-components-list.el"))




(require 'pri-machines-mode)



(defun pri-split-string (string &optional pattern)
  "Return a list of substrings of STRING which are separated by PATTERN.
If PATTERN is omitted, it defaults to \"[ \\f\\t\\n\\r\\v]+\"."
  (or pattern
      (setq pattern "[ \f\t\n\r\v]+"))
  ;; The FSF version of this function takes care not to cons in case
  ;; of infloop.  Maybe we should synch?
  (let (parts (start 0))
    (while (string-match pattern string start)
      (setq parts (cons (substring string start (match-beginning 0)) parts)
	    start (match-end 0)))
    (nreverse (cons (substring string start) parts))))


(defun cansell-string-nb(n)
  (if (<= n 9)
     (concat "    " (int-to-string n) " ")
     (if (<= n 99) 
	 (concat  "   " (int-to-string n) " ") 
	      (if (<= n 999) 
		  (concat   "  " (int-to-string n) " ")
		  (concat   " " (int-to-string n) " ")
	      )
     )	 
  )
) 

(defvar cansell-list-select nil "contient les hypos selectionnees")
(defvar cansell-list-widget-checkbox nil "contient les widgets des hypos select")
(defvar cansell-list-widget-menu-choice nil "contient les widgets des hypos select")
(defvar cansell-list-widget-value-ph-RSH nil "contient les widgets des champs editables pour recuperer les valeurs")
(defvar cansell-list-widget-value-ph-CACH nil "contient les widgets des champs editables pour recuperer les valeurs")
(defvar cansell-list-widget-value-ph-SEL nil "contient les widgets des champs editables pour recuperer les valeurs")
(defvar cansell-affiche-prompt-pri nil "c'est pour ne pas afficher le prompt")
(defvar cansell-calculette nil "vrai si la calcultte est la (prompt)")
(defvar  cansell-goal nil "pour le goal")
(defvar  cansell-know-goal  nil "pour le goal")


;;(defvar cansell-list-docases (cons "(aa: SS or not(bb: SS))" (cons "not(aa = bb)"(cons " FF[aa$1..bb$1-1] = VV-{bb}"  nil))))

;;(defvar cansell-current-list-docases  cansell-list-docases)
(defvar cansell-les-ph-pas-point nil "c'est les ph dans wx et select sans ...")
(defvar cansell-affiche-help nil "")
(defvar cansell-string-to-paste "")

(defvar cansell-prover-not-works  t "")


(defun Add-to-list (l v) 
  (cons (string-to-int v) l)
)

(defun Delete (v l)
  (delete (string-to-int v) l)
)

(defun Delete-wid (n lw)
  (if lw
      (if (string= (cansell-string-nb n)  (widget-get (car lw):tag))
            (progn
	      (widget-delete (car lw))
	      (cdr lw)
	    )
            (cons (car lw) (Delete-wid n (cdr lw))))
    )
)

;;(defun Delete-wid-list (ln lw)
;;  (if ln
;;      lw
;;      (Delete-wid-list (cdr ln) (Delete-wid (car n) lw))
;;  )
;;)     

(eval-and-compile
(defun  coucou(n)
  n
))

(eval-and-compile
(defun  cansell-wxws-pri-prouveur-send-command (com)
  ;; (coucou com)
   (pri-prouveur-send-command   com)   ;;(concat com  "\n wx & ws"))
))

(eval-and-compile
(defun  cansell-widget-AeAq ()

       ;;   (setq cansell-wid-ah (widget-create  'push-button
       ;;    :tag "Ah"
	;;   :value ""
	 ;;  :help-echo "Add hypothesis"
;;	   :format  "%[[%t]%]"
;;	   :notify (lambda (widget &rest ignore) 
;;			        (cansell-pri-prouveur-send-command nil  (concat "ah(" (widget-value  le-champ-editable) ")")))))(widget-insert " ")


          (setq cansell-wid-ae (widget-create  'push-button
           :tag "ae"
	   :value ""
	   :help-echo "Abstraction (in editable field) Term (selected)"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if cansell-prover-not-works
		      (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ae")))
			      (if (region-active-p)
				  (progn (x-symbol-encode)(if (string= (widget-value le-champ-editable) "") 
				     (cansell-wxws-pri-prouveur-send-command  (concat "ax(" (buffer-string (mark) (point))  ")"))	
				  (cansell-wxws-pri-prouveur-send-command  (concat "ae(" (buffer-string (mark) (point)) "," (widget-value le-champ-editable) ")")))(x-symbol-decode))			   	   )
			      ))

))) (widget-insert " ")

          (setq cansell-wid-aq (widget-create  'push-button
           :tag "aq"
	   :value ""
	   :help-echo "Abstraction (in editable field) Predicate (selected)"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-aq")))
		        (if cansell-affiche-nx () (if (region-active-p) (progn (x-symbol-encode) (cansell-wxws-pri-prouveur-send-command  (concat "aq(" (buffer-string (mark) (point)) ")"))			      ))
	  ))))) )

))

(eval-and-compile
(defun  cansell-delete-prompt-pri ()
;;(pri-before-writting-buffer PRI-LOG)
         (interactive)
(if cansell-calculette
    (progn
(pri-before-writting-buffer PRI-LOG)
;;      (widget-delete cansell-wid-pr)
;;      (widget-delete   cansell-wid-p0)
 ;;     (widget-delete   cansell-wid-p1)
  ;;    (widget-delete  cansell-wid-ae)
    ;;  (widget-delete   cansell-wid-aq)

;;      (widget-delete  le-champ-editable)
  ;;    (widget-delete  cansell-wid-sh)
    ;;  (widget-delete  cansell-wid-ah)
      ;;(widget-delete  cansell-wid-re)
;;      (widget-delete  cansell-wid-st)
  ;;    (widget-delete  cansell-wid-ba)

    ;;  (widget-delete  cansell-wid-sg)
      ;;(widget-delete   cansell-wid-wx)
      (setq cansell-calculette nil)
(pri-after-writting-buffer)
 (widget-setup)))))
(defvar pri-cansell-mode-map nil)
(defvar  cansell-old-value-widget "")
(defvar cansell-exist-le-champs nil)
(defvar cansell-reset-proof  nil)
(defvar cansell-proof-old-tree-pos nil)

(defvar cansell-ba nil)
(defvar  cansell-test-ba nil)
(defvar cansell-after-pr nil)


(eval-and-compile
(defun cansell-backspace-xsymbol()
  (interactive)
  (delete-backward-char)
   (if (memq  (char-before (point) ) (list ?? )  )    (delete-backward-char))
  (widget-setup)
))
(eval-and-compile
(defun  cansell-remet-oldvalue ()
  (interactive)
  (widget-value-set  le-champ-editable  cansell-old-value-widget)
  (x-symbol-decode)
  (widget-setup)
))
(eval-and-compile
  (if pri-cansell-mode-map
	  nil
	(progn (setq pri-cansell-mode-map (make-sparse-keymap)) (set-keymap-parents pri-cansell-mode-map widget-field-keymap )
)
	;; avant de quitter emacs on quitte le projet
	(define-key pri-cansell-mode-map 'up 'cansell-remet-oldvalue)
	(define-key pri-cansell-mode-map [backspace] 'cansell-backspace-xsymbol)
))



(eval-and-compile
(defun  cansell-prompt-pri ( cansell-val-a-remettre)
(pri-before-writting-buffer PRI-LOG)
(end-of-buffer)
 (setq cansell-calculette t)
      	  (widget-insert "\n")
;;          (if  There-are-other-hypos (cansell-other-hypos-widget)(cansell-NO-other-hypos-widget)) 
;;	  (setq cansell-wid-wx (widget-create  'push-button
;;          :tag "Wx"
;;	   :value ""
;;	   :help-echo "Show cache"
;;	   :format  "%[[%t]%]"
;;	   :notify (lambda (widget &rest ignore)
;;			      (progn (setq cansell-wx t)   (cansell-pri-prouveur-send-command  t "wx"))))) (widget-insert " ")
;;
;;	  (setq cansell-wid-wc (widget-create  'push-button
;;           :ta "Wc"
;;	   :value ""
;;	   :help-echo "Show cache"
;;	   :format  "%[[%t]%]"
;;	   :notify (lambda (widget &rest ignore)
;;			      (progn (setq cansell-wx nil)  (cansell-pri-prouveur-send-command  t "wx"))))) (widget-insert " ")
;;
;;	  (setq cansell-wid-ws (widget-create  'push-button
 ;;          :tag "Ws"
;;	   :value ""
;;	   :help-echo "Show cache"
;;	   :format  "%[[%t]%]"
;;	   :notify (lambda (widget &rest ignore)
;;			        (cansell-pri-prouveur-send-command  t "ws"))))       	  (widget-insert "\n")
;;
(widget-create  'push-button
					 :tag "fx"
					 :value ""
					 :help-echo "Forall hypothesis"
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						  (if  cansell-not-sv-nv (if cansell-prover-not-works
						  (if cansell-affiche-help
						      (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-tf")))
						     (if cansell-affiche-nx () (cansell-wxws-pri-prouveur-send-command  "sh(!x?.y?)"))
						   ))))) (widget-insert " ") 
 (widget-create  'push-button
					 :tag "e:"
					 :value ""
					 :help-echo "Type hypothesis"
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-not-sv-nv  (if cansell-prover-not-works
						  (if cansell-affiche-help
						      (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-type")))
						     (if cansell-affiche-nx () (cansell-wxws-pri-prouveur-send-command  "sh(x?:y? _or x?<:y?)"))
						   ))))) (widget-insert " ")

         (setq cansell-wid-sh (widget-create  'push-button
           :tag "sh"
	   :value ""
	   :help-echo "Show hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
		     (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-sh")))
                        (if cansell-affiche-nx () (progn (x-symbol-encode)(if (region-active-p)
                                (cansell-wxws-pri-prouveur-send-command  (concat "sh(" (buffer-string (mark) (point)) ")" ))
			        (cansell-wxws-pri-prouveur-send-command  (concat "sh(" (widget-value le-champ-editable) ")" ))				   	   )(x-symbol-decode)))
))))))
 (widget-insert " ")


         (setq cansell-wid-sg (widget-create  'push-button
           :tag "sg"
	   :value ""
	   :help-echo "Select in selection"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
		     (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-sg")))
                         (if cansell-affiche-nx () (progn (x-symbol-encode)(if (region-active-p)
                                (cansell-wxws-pri-prouveur-send-command  (concat "sg(" (buffer-string (mark) (point)) ")"))
			        (cansell-wxws-pri-prouveur-send-command  (concat "sg(" (widget-value le-champ-editable) ")")))
			(x-symbol-decode))))))))) 

(widget-insert " ")
	 (widget-create  'push-button
           :tag "op"
	   :value ""
	   :help-echo "Old and current proof tree"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-prooftrees")))
		         (progn    (pop-to-buffer    PRI-PROOF-TREE  t cansell-error-frame) 
  (delete-other-windows)(setq w2 (split-window  (frame-selected-window cansell-error-frame) )) (set-window-buffer w2  PRI-OLD-PROOF ))))))

(widget-insert " ")



      	  (widget-insert "\n")


         (setq cansell-wid-m0  (widget-create  'push-button
           :tag "pr"
	   :value ""
	   :help-echo "prouveur force 0"
	  ;; :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
			     (if cansell-affiche-help
				 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-pr")))
			          (if cansell-affiche-nx ()  (progn
                                     (if (string= (widget-value le-champ-editable) "")
				     (progn (setq  cansell-ba t) (setq  cansell-dec-po-old cansell-dec-po) (cansell-wxws-pri-prouveur-send-command  "pr" ))
				    (progn  (x-symbol-encode) (setq  cansell-ba t) (setq  cansell-dec-po-old (1+ cansell-dec-po)) 
				      (cansell-wxws-pri-prouveur-send-command (concat "ah(" (widget-value le-champ-editable) ") & pr")) (x-symbol-decode)))
				      (setq cansell-prover-not-works nil) (cansell-affiche-balbulette-bis) (message "Wait the automatic prover works!")
				      ))
			      )))))) (widget-insert " ")

;;          (setq cansell-wid-m1  (widget-create  'push-button
;           :tag "m1"
;	   :value ""
;	   :help-echo "prouveur force 0+"
;	  ;; :button-face  'pri-machines-red-face
;	   :format  "%[[%t]%]"
;	   :notify (lambda (widget &rest ignore) 
;		      (if  cansell-not-sv-nv (if cansell-prover-not-works
;			     (if cansell-affiche-help
;				 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-pr")))
;			          (if cansell-affiche-nx ()  (progn
;                                     (if (string= (widget-value le-champ-editable) "")
;				      (cansell-wxws-pri-prouveur-send-command  "ml(ff(0;1)|rp.1)" )
;				    (progn  (x-symbol-encode)
;				      (cansell-wxws-pri-prouveur-send-command (concat "ah(" (widget-value le-champ-editable) ") & ml(ff(0;1)|rp.1)")) (x-symbol-decode)))
;				      (setq cansell-prover-not-works nil) (cansell-affiche-balbulette-bis) (message "Wait the automatic prover works!")
;				      ))
;			      )))))) (widget-insert " ")
        (setq cansell-wid-p0 (widget-create  'push-button
           :tag "p0"
	   :value ""
	   :help-echo "pp(rp.0|30)"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
			       (if cansell-affiche-help
				   (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-p0")))
				 (if cansell-affiche-nx ()  (progn
				   (if (string= (widget-value le-champ-editable) "")
				      (cansell-wxws-pri-prouveur-send-command  "pp(rp.0|30)" )
				    (progn  (x-symbol-encode)(cansell-wxws-pri-prouveur-send-command (concat "ah(" (widget-value le-champ-editable) ") & pp(rp.0|30)")) (x-symbol-decode)))
				  
				   (setq cansell-prover-not-works nil)(cansell-affiche-balbulette-bis) (message "Wait the predicate prover works!")
			       ;;(widget-apply widget :deactivate)
			      )))))
)

)) (widget-insert " ")
         (setq cansell-wid-p1 (widget-create  'push-button
           :tag "p1"
	   :value ""
	   :help-echo "pp(rp.1|30)"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
			 (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-p1")))
		 (if cansell-affiche-nx () 	(progn
				   (if (string= (widget-value le-champ-editable) "")
				      (cansell-wxws-pri-prouveur-send-command  "pp(rp.1|30)" )
				    (progn (x-symbol-encode) (cansell-wxws-pri-prouveur-send-command (concat "ah(" (widget-value le-champ-editable) ") & pp(rp.1|30)")) (x-symbol-decode)))
			(setq cansell-prover-not-works nil) (cansell-affiche-balbulette-bis) (message "Wait the predicate prover works!")
		       		;;(widget-apply widget :deactivate)
				)))))
)))  (widget-insert " ")
(if cansell-prover-not-works
         (setq cansell-wid-it (widget-create  'push-button
           :tag "it"
	   :value ""
	   :help-echo "Interrupt the prover"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv  (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-it")))
		;;(pri-interrupt)	
				)))
))

        (setq cansell-wid-it (widget-create  'push-button
           :tag "it"
	   :value ""
	   :help-echo "Interrupt the prover"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		  (if  cansell-not-sv-nv  
		(progn  (setq  cansell-ba nil)(pri-interrupt) (setq cansell-prover-not-works t))
				)))
)
)
(widget-insert " ")

	 (widget-create  'push-button
           :tag "pt"
	   :value ""
	   :help-echo "Proof tree"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-pt")))
		         (progn   (pop-to-buffer    PRI-PROOF-TREE  t cansell-error-frame) 
  (delete-other-windows)
)))))

(widget-insert "  ")


          (setq LeDebEd (point))
          (setq cansell-exist-le-champs t)
	 (setq le-champ-editable (widget-create 'editable-field
                 ;;:tag "   1  "
                 :value ""
                 :size 16
		 :help-echo "A command , please!"
		 :keymap  pri-cansell-mode-map
                 :action (lambda (widget &rest ignore)
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
                        (if cansell-affiche-help
			    (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ef")))
			   (if cansell-affiche-nx () (progn (x-symbol-encode)
                            (setq cansell-old-value-widget (widget-value widget))  (pri-prouveur-send-command  (concat  (widget-value widget) ))(x-symbol-decode)
                          )))
			;;			    (pri-prouveur-send-command "wx&ws")
)))))  	  (widget-insert "\n")



         (setq cansell-wid-re (widget-create  'push-button
           :tag "re"
	   :value ""
	   :help-echo "Reset"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
			        (if cansell-affiche-help
				    (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-re")))
				  (progn (setq cansell-raff-preuve   nil) (setq cansell-debut-d-une-preuve  t)(pri-prouveur-send-command  "re" )))

))))) (widget-insert " ")





          (setq cansell-wid-st (widget-create  'push-button
           :tag "st"
	   :value ""
	   :help-echo "A step"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-not-sv-nv  (if cansell-prover-not-works
			    (if cansell-affiche-help
				(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-st")))
			       (if cansell-affiche-nx () (progn  (setq cansell-prover-not-works nil) (cansell-affiche-balbulette-bis)(cansell-wxws-pri-prouveur-send-command   "st"))))
				   	   ))
))) (widget-insert " ")
          (setq cansell-wid-as (widget-create  'push-button
           :tag "en"
	   :value ""
	   :help-echo "Replay all steps of the old proof (Doesn't works)"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
			    (if cansell-affiche-help
				();;(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-as")))
			    ;; (if cansell-affiche-nx ()  (progn  (setq cansell-prover-not-works nil) (cansell-affiche-balbulette-bis)(cansell-wxws-pri-prouveur-send-command   "st(End)")))
				   	   ))
)))) (widget-insert " ")

         (setq cansell-wid-ba (widget-create  'push-button
           :tag "ba"
	   :value ""
	   :help-echo "Back"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
		      (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ba")))

		        (if cansell-affiche-nx () 
			    (if (and cansell-raff-preuve (= cansell-lg-nx (length cansell-proof-tree))) (message "Nothing to backtrack after last [nx]")(cansell-wxws-pri-prouveur-send-command  "ba" )))
			      ))
))))(widget-insert " ")

         (setq cansell-wid-as (widget-create  'push-button
           :tag "as"
	   :value ""
	   :help-echo "Assume goal"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
		      (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-as")))

		       (if cansell-affiche-nx ()  (if (string= (widget-value le-champ-editable) "")
				      (cansell-wxws-pri-prouveur-send-command  "as" )
				    (progn  (x-symbol-encode)
				      (cansell-wxws-pri-prouveur-send-command (concat "ah(" (widget-value le-champ-editable) ") & as")) (x-symbol-decode)))
			      ))
)))))
 (widget-insert "\n")
(widget-create  'push-button
           :tag "qu"
	   :value ""
	   :help-echo "Quit the proof"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-quit-proof"))) 
		       (progn (setq cansell-pour-aff-old-proof-tree nil)(setq cansell-raff-preuve   nil) (setq cansell-exist-le-champs nil)(pri-exit)))))
			
			    
		       )) 
(widget-insert " ")
(if cansell-affiche-help
(widget-create  'push-button
           :tag "hp"
	   :value ""
	   :help-echo "Help?"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (progn
		       (setq cansell-affiche-help (not cansell-affiche-help))
		       (cansell-affiche-balbulette-bis)
		      (set-buffer "pri-help") (erase-buffer)
		      (pop-to-buffer    "pri-errors" t  cansell-error-frame) 
  (delete-other-windows)
)))
					       
(widget-create  'push-button
           :tag "hp"
	   :value ""
	   :help-echo "Help?"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		     (progn
		       (setq cansell-affiche-help (not cansell-affiche-help))
		       (cansell-affiche-balbulette-bis)
		       (pop-to-buffer    "pri-help" t  cansell-error-frame)  (delete-other-windows)(set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-start1"))(pri-atelierb-mode)(x-symbol-mode)(font-lock-fontify-buffer) 
 

		       ))))) 

(widget-insert " ")


          (setq cansell-wid-dc (widget-create  'push-button
           :tag "dc"
	   :value ""
	   :help-echo "Proof by case"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-not-sv-nv  (if cansell-prover-not-works
                        (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dc")))
		 (if cansell-affiche-nx () (progn (x-symbol-encode)	(if (region-active-p)
                                (cansell-wxws-pri-prouveur-send-command  (concat "dc(" (buffer-string (mark) (point)) ")"))
			        (cansell-wxws-pri-prouveur-send-command  (concat "dc(" (widget-value le-champ-editable) ")")))
                         (x-symbol-decode))))))))) (widget-insert " ")

           (setq cansell-wid-cm (widget-create  'push-button
           :tag "cm"
	   :value ""
	   :help-echo "Add some comment"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
                        (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-cm")))
		 (if cansell-affiche-nx () (progn (x-symbol-encode)	(if (region-active-p)
                                (cansell-wxws-pri-prouveur-send-command  (concat "cm("  (buffer-string (mark) (point)) ")"))
			        (cansell-wxws-pri-prouveur-send-command  (concat "cm(" (widget-value le-champ-editable) ")")))
(x-symbol-decode)))))))) (widget-insert " ")

        (setq cansell-wid-ah (widget-create  'push-button
           :tag "ah"
	   :value ""
	   :help-echo "Add hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
		     (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ah")))
		       (if cansell-affiche-nx ()  (progn (x-symbol-encode)(cansell-wxws-pri-prouveur-send-command  (concat "ah(" (widget-value le-champ-editable) ")"))(x-symbol-decode))) 
		       
))))))
(widget-insert (concat "  " prfailed))
 (pri-after-writting-buffer)
 (widget-setup)))
;;ajout d'une hypothese

(eval-and-compile
(defun cansell-widget-ah-not-cache  (n)
  (widget-create  'push-button
           :tag "sl"
	   :value n
	   :help-echo "Select hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-sl-RSH")))
				 (if cansell-affiche-nx () (progn 
			          ;; (setq cansell-hypo t)
				  (setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)	
				  (pri-prouveur-send-command  "sw(rech)")
				  (pri-prouveur-send-command  (widget-value widget) )
				  (pri-prouveur-send-command  "")))))
	   )
)))

(eval-and-compile
(defun cansell-widget-ah-cache  (n)
  (widget-create  'push-button
           :tag "sl"
	   :value n
	   :help-echo "Select hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-sl-CACH")))
				 (if cansell-affiche-nx () (progn 
			          ;; (setq cansell-hypo t)
				  (pri-prouveur-send-command  "sw(cash)")
				  (pri-prouveur-send-command  (widget-value widget) )
				  (pri-prouveur-send-command  "")
				  (pri-prouveur-send-command  "wx&ws"))
))))
	   )
))

(eval-and-compile
(defun cansell-widget-ah (n cache)
 (if cache
     (cansell-widget-ah-cache n)
   (cansell-widget-ah-not-cache n)
)))


(eval-and-compile
(defun cansell-widget-dl-CACH  (n)
  (widget-create  'push-button
           :tag "dl"
	   :value n
	   :help-echo "remove hypothesis from cache"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dl-CACH")))
			 (if cansell-affiche-nx () 	(progn 
				  (pri-prouveur-send-command "sw(cash)")
				  (pri-prouveur-send-command  (widget-value widget) )
				  (pri-prouveur-send-command  "dl") (pri-prouveur-send-command  "wx&ws"))
)))
	   )
)
))

(eval-and-compile
(defun cansell-widget-dl-SEL  (n)
  (widget-create  'push-button
           :tag "fh"
	   :value n
	   :help-echo "prove negation of hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-fh")))
			 (if cansell-affiche-nx () 	(progn 
				  (cansell-wxws-pri-prouveur-send-command  "sw(cash)")
				  (cansell-wxws-pri-prouveur-send-command   (widget-value widget) )
;;				  (cansell-wxws-pri-prouveur-send-command   "ds")
;;				  (cansell-wxws-pri-prouveur-send-command   (widget-value widget) )
				  (cansell-wxws-pri-prouveur-send-command   "fh")
				  ;;(pri-prouveur-send-command  "wx&ws")
;;(pri-prouveur-send-command  "wx&ws")
))))
	   )
)))

(eval-and-compile
(defun cansell-widget-ds  (n)
  (widget-create  'push-button
           :tag "ds"
	   :value n
	   :help-echo "remove hypothesis from cache"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			     (if cansell-affiche-help
				 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ds")))
			        (if cansell-affiche-nx () (progn 
				 (pri-prouveur-send-command "sw(cash)") 
				 (pri-prouveur-send-command  (widget-value widget) )
				 (pri-prouveur-send-command "ds") (pri-prouveur-send-command  "wx&ws"))
)))
	   )
)))
(eval-and-compile
(defun  cansell-recherche-list-val (n l)
 (if (string= n (car (car l)))
     (cdr (car l))
     (cansell-recherche-list-val n (cdr l))))
)

(eval-and-compile
(defun  cansell-transforme-se (l)
  (if (cdr l)
    (if (string= (widget-value (car (car l))) "") 
	(concat (cansell-transforme-se (cdr l)) "," (car (cdr (car l))))
      (concat (cansell-transforme-se (cdr l)) "," (widget-value (car (car l)))))
    (if (string= (widget-value (car (car l))) "")
	(car (cdr (car l)))
      (widget-value (car (car l)))))
))
  
(eval-and-compile
(defun  cansell-transforme (l)
  (if (cdr l)
    (if (string= (widget-value (car (car l))) "") 
	(concat (cansell-transforme (cdr l)) "," (car (cdr (car l))))
         (if (string= "*" (replace-in-string   (concat " "(widget-value (car (car l)))) "^ +" ""))
	    	(concat (cansell-transforme (cdr l)) ", _h")  
      (concat (cansell-transforme (cdr l)) "," (widget-value (car (car l))))))
    (if (string= (widget-value (car (car l))) "")
	(car (cdr (car l)))
      (if (string= "*" (replace-in-string   (concat " " (widget-value (car (car l)))) "^ +" "")) " _h" (widget-value (car (car l))))))
))

(eval-and-compile
(defun cansell-cherche-instance-du-ph-RSH( n )
    (cansell-transforme (cansell-recherche-list-val n cansell-list-widget-value-ph-RSH))
))  
(eval-and-compile
(defun cansell-cherche-instance-du-ph-CACH( n )
    (cansell-transforme (cansell-recherche-list-val n cansell-list-widget-value-ph-CACH))
))  
(eval-and-compile
(defun cansell-cherche-instance-du-ph-SEL( n )
    (cansell-transforme (cansell-recherche-list-val n cansell-list-widget-value-ph-SEL))
))  

(eval-and-compile
(defun cansell-widget-ph-RSH  (n multi)
(if multi
  (widget-create  'push-button
           :tag "ph"
	   :value n
	   :help-echo "Instanciate the pred with values!"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		      (if cansell-affiche-help
			  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-RSH")))
			 (if cansell-affiche-nx () (progn (x-symbol-encode)
			  (pri-prouveur-send-command "sw(rech)")
			  (pri-prouveur-send-command  (widget-value widget) )
			  (pri-prouveur-send-command  (concat "ph(" (cansell-cherche-instance-du-ph-RSH (widget-value widget) ) ")"))(x-symbol-decode)
			  ;; (pri-prouveur-send-command  "wx&ws")
)))
	   )))
  (widget-create  'push-button
           :tag "ph"
	   :value n
	   :help-echo "Instanciate the pred with values!"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
                (if cansell-affiche-nx () (progn (x-symbol-encode)(cansell-test-ph-RSH (widget-value widget) (buffer-string (mark) (point))(region-active-p))(x-symbol-decode))
))))))


(eval-and-compile
(defun cansell-widget-ph-CACH  (n multi)
(if multi
  (widget-create  'push-button
           :tag "ph"
	   :value n
	   :help-echo "Instanciate the pred with values!"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		      (if cansell-affiche-help
			  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-CACH")))
		 (if cansell-affiche-nx () 	(progn  (x-symbol-encode)
			  (pri-prouveur-send-command "sw(cash)")
			  (pri-prouveur-send-command  (widget-value widget) )
			  (pri-prouveur-send-command (concat "ph(" (cansell-cherche-instance-du-ph-CACH (widget-value widget) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command  "wx&ws")
)))
	   )))
  (widget-create  'push-button
           :tag "ph"
	   :value n
	   :help-echo "Instanciate the pred with values!"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
                (if cansell-affiche-nx () (progn (x-symbol-encode)(cansell-test-ph-CACH (widget-value widget) (buffer-string (mark) (point))(region-active-p))(x-symbol-decode)))			    
)))))


(eval-and-compile
(defun cansell-test-ph-RSH (n b a)
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-RSH")))
		       (if a
                           (progn 
			     (pri-prouveur-send-command "sw(rech)")
			     (pri-prouveur-send-command  n)
			     (pri-prouveur-send-command  (concat "ph(" b ")"));;(pri-prouveur-send-command  "wx&ws")
			     )
			   (progn 
			     (pri-prouveur-send-command "sw(rech)")
			     (pri-prouveur-send-command  n)

(pri-trace (cansell-cherche-instance-du-ph-RSH n ) )
			     (pri-prouveur-send-command  (concat "ph("   (cansell-cherche-instance-du-ph-RSH n ) ")"));;(pri-prouveur-send-command  "wx&ws")
			    )
)))))

(eval-and-compile
(defun cansell-test-ph-CACH (n b a)
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-CACH")))
		       (if a
                           (progn 
			     (pri-prouveur-send-command "sw(cash)")
			     (pri-prouveur-send-command  n)
			     (pri-prouveur-send-command  (concat "ph(" b ")"));;(pri-prouveur-send-command  "wx&ws")
			     )
			   (progn 
			     (pri-prouveur-send-command "sw(cash)")
			     (pri-prouveur-send-command  n)
			     (pri-prouveur-send-command  (concat "ph("  (cansell-cherche-instance-du-ph-CACH n ) ")"));;(pri-prouveur-send-command  "wx&ws")
			    )
)))))

(eval-and-compile
(defun cansell-test-ph-SEL (n b a)
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-SEL")))
		       (if a
                           (progn 
			     (pri-prouveur-send-command "sw(cash)")
			     (pri-prouveur-send-command  n)
			     (pri-prouveur-send-command  (concat "ph(" b ")"));;(pri-prouveur-send-command  "wx&ws")
			     )
			   (progn 
			     (pri-prouveur-send-command "sw(cash)")
			     (pri-prouveur-send-command  n)
			     (pri-prouveur-send-command  (concat "ph("  (cansell-cherche-instance-du-ph-SEL n ) ")"));;(pri-prouveur-send-command  "wx&ws")
			    )
)))))

(eval-and-compile
(defun cansell-widget-ph-SEL  (n multi)
(if multi
  (widget-create  'push-button
           :tag "ph"
	   :value n
	   :help-echo "Instanciate the pred with values!"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-SEL")))
		       (if cansell-affiche-nx ()  (progn  (x-symbol-encode)
			 (pri-prouveur-send-command "sw(cash)")
			 (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command (concat "ph(" (cansell-cherche-instance-du-ph-SEL (widget-value widget) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command  "wx&ws")
)))
		           
	   )))
  (widget-create  'push-button
           :tag "ph"
	   :value n
	   :help-echo "Instanciate the pred with values!"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
                (if cansell-affiche-nx () (progn (x-symbol-encode)(cansell-test-ph-SEL (widget-value widget) (buffer-string (mark) (point))(region-active-p))(x-symbol-decode))
))))))

(eval-and-compile
(defun cansell-widget-ph  (n multi m)
 (if (= m 1) (cansell-widget-ph-RSH n multi)  
       (if (= m 2)  (cansell-widget-ph-CACH n multi) 
	 (cansell-widget-ph-SEL n multi)))
))

(eval-and-compile
(defun cansell-widget-hypo-red-SEL  (s n m)
  (widget-create  'push-button
	   :tag s
	   :value n
	   :help-echo m
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat (concat pri-balbulette-dir "/pri-HELP/pri-help-" (widget-get widget :tag) "-SEL"))))
		       (if cansell-affiche-nx ()  (progn 
			 (setq cansell-prompt-or-not-pri nil) 
			 (pri-prouveur-send-command "sw(cash)")
			 (pri-prouveur-send-command (widget-value widget)  )
			 (pri-prouveur-send-command (widget-get widget :tag))
			   ;;(pri-prouveur-send-command  "wx&ws")
))
		     ))))

	   
))
	
(eval-and-compile
(defun cansell-widget-hypo-SEL  (s n m)
  (widget-create  'push-button
	   :tag s
	   :value n
	   :help-echo m
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat (concat pri-balbulette-dir "/pri-HELP/pri-help-" (widget-get widget :tag) "-SEL"))))
		       (if cansell-affiche-nx ()  (progn 
			 (setq cansell-prompt-or-not-pri nil) 
			 (pri-prouveur-send-command "sw(cash)")
			 (pri-prouveur-send-command (widget-value widget)  )
			 (pri-prouveur-send-command (widget-get widget :tag))
			   ;;(pri-prouveur-send-command  "wx&ws")
))
		     ))))

	   
))

(eval-and-compile
(defun cansell-widget-hypo-CACH  (s n m)
  (widget-create  'push-button
	   :tag s
	   :value n
	   :help-echo m
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		    (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat (concat pri-balbulette-dir "/pri-HELP/pri-help-" (widget-get widget :tag) "-CACH"))))
		      (if cansell-affiche-nx ()  (progn 
		           (setq cansell-prompt-or-not-pri nil) 
			   (pri-prouveur-send-command "sw(cash)")
			   (pri-prouveur-send-command (widget-value widget)  )
			   (pri-prouveur-send-command (widget-get widget :tag))
			   ;;(pri-prouveur-send-command  "wx&ws")
))
		     ))

	   ))
))
(eval-and-compile
(defun cansell-widget-hypo-red-CACH  (s n m)
  (widget-create  'push-button
	   :tag s
	   :value n
	   :help-echo m
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		    (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat (concat pri-balbulette-dir "/pri-HELP/pri-help-" (widget-get widget :tag) "-CACH"))))
		      (if cansell-affiche-nx ()  (progn 
		           (setq cansell-prompt-or-not-pri nil) 
			   (pri-prouveur-send-command "sw(cash)")
			   (pri-prouveur-send-command (widget-value widget)  )
			   (pri-prouveur-send-command (widget-get widget :tag))
			   ;;(pri-prouveur-send-command  "wx&ws")
))
		     ))

	   ))
))

(eval-and-compile
(defun cansell-widget-hypo-red-RSH  (s n m)
  (widget-create  'push-button
	   :tag s
	   :value n
	   :help-echo m
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat (concat pri-balbulette-dir "/pri-HELP/pri-help-" (widget-get widget :tag) "-RSH"))))
		        (if cansell-affiche-nx () (progn 
		           (setq cansell-prompt-or-not-pri nil)
			   (pri-prouveur-send-command "sw(rech)")
			   (pri-prouveur-send-command (widget-value widget)  )
			   (pri-prouveur-send-command (widget-get widget :tag))
			   ;;(pri-prouveur-send-command  "wx&ws")
) ))
)))))

(eval-and-compile
(defun cansell-widget-hypo-RSH  (s n m)
  (widget-create  'push-button
	   :tag s
	   :value n
	   :help-echo m
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
		     (if cansell-affiche-help
			(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat (concat pri-balbulette-dir "/pri-HELP/pri-help-" (widget-get widget :tag) "-RSH"))))
		       (if cansell-affiche-nx ()  (progn 
		           (setq cansell-prompt-or-not-pri nil)
			   (pri-prouveur-send-command "sw(rech)")
			   (pri-prouveur-send-command (widget-value widget)  )
			   (pri-prouveur-send-command (widget-get widget :tag))
			   ;;(pri-prouveur-send-command  "wx&ws")
) ))

	   )
))))

(eval-and-compile
(defun cansell-add-hypothese-RSH (hypothese n)  
        (interactive)
	(cansell-widget-ah n nil)
	;;(widget-insert " ")

	(if cansell-affiche-hypo-nature-ri
           (progn
	   (widget-insert " ") (cansell-add-widget-ri-RSH)))
	(if cansell-affiche-hypo-nature-rm
	    (progn
	      (widget-insert " ")(cansell-add-widget-rm-RSH)))

	(if cansell-affiche-hypo-nature-ov
	    (progn
	     (widget-insert " ") (cansell-add-widget-ov-RSH)))



	(if cansell-affiche-hypo-nature-ri
 	    (if cansell-affiche-hypo-nature-rm
		  (if cansell-affiche-hypo-nature-ov
		      ()
		    (widget-insert "     "))
		  (if cansell-affiche-hypo-nature-ov
		      (widget-insert "     ")
		    (widget-insert "          ")))
	  (if cansell-affiche-hypo-nature-rm
	      (if cansell-affiche-hypo-nature-ov
		  (widget-insert "     ")
		(widget-insert "          "))
	    (if cansell-affiche-hypo-nature-ov
		(widget-insert "          ")
	      (widget-insert "               "))))

 	(widget-insert "     ")
       	(widget-insert hypothese) 
        (widget-insert "\n") (widget-setup)
						
))




(eval-and-compile
(defun cansell-add-hypothese-CACH (hypothese n)  
        (interactive)
	(cansell-widget-dl-CACH n)
	(widget-insert " ")
	(cansell-widget-ah n t)
	;;(widget-insert " ")

	(if cansell-affiche-hypo-nature-ri
           (progn
	    (widget-insert " ")(cansell-add-widget-ri-CACH)))
	(if cansell-affiche-hypo-nature-rm
	    (progn
	      (widget-insert " ")(cansell-add-widget-rm-CACH)))

	(if cansell-affiche-hypo-nature-ov
	    (progn
	      (widget-insert " ")(cansell-add-widget-ov-CACH)))



	(if cansell-affiche-hypo-nature-ri
 	    (if cansell-affiche-hypo-nature-rm
		  (if cansell-affiche-hypo-nature-ov
		      ()
		    (widget-insert "     "))
		  (if cansell-affiche-hypo-nature-ov
		      (widget-insert "     ")
		    (widget-insert "          ")))
	  (if cansell-affiche-hypo-nature-rm
	      (if cansell-affiche-hypo-nature-ov
		  (widget-insert "     ")
		(widget-insert "          "))
	    (if cansell-affiche-hypo-nature-ov
		(widget-insert "          ")
	      (widget-insert "               "))))


;;	(widget-insert " ")
       	(widget-insert hypothese) 
        (widget-insert "\n") (widget-setup)
						
))

(eval-and-compile
(defun cansell-add-hypothese-SEL (hypothese n)  
        (interactive)
	(cansell-widget-dl-SEL n)
	(widget-insert " ")
	(cansell-widget-ds n) 
	;;(widget-insert " ")

	(if cansell-affiche-hypo-nature-ri
           (progn
	    (widget-insert " ")(cansell-add-widget-ri-SEL)))
	(if cansell-affiche-hypo-nature-rm
	    (progn
	     (widget-insert " ") (cansell-add-widget-rm-SEL)))

	(if cansell-affiche-hypo-nature-ov
	    (progn
	     (widget-insert " ") (cansell-add-widget-ov-SEL)))



	(if cansell-affiche-hypo-nature-ri
 	    (if cansell-affiche-hypo-nature-rm
		  (if cansell-affiche-hypo-nature-ov
		      ()
		    (widget-insert "     "))
		  (if cansell-affiche-hypo-nature-ov
		      (widget-insert "     ")
		    (widget-insert "          ")))
	  (if cansell-affiche-hypo-nature-rm
	      (if cansell-affiche-hypo-nature-ov
		  (widget-insert "     ")
		(widget-insert "          "))
	    (if cansell-affiche-hypo-nature-ov
		(widget-insert "          ")
	      (widget-insert "               "))))


	;;(widget-insert " ")
      	(widget-insert hypothese) 
        (widget-insert "\n") (widget-setup)
						
))

(eval-and-compile
(defun cansell-add-hypothese (sel m hypothese n)  						
(if (= m 1) (cansell-add-hypothese-RSH hypothese n)  
(if (= m 2)  (cansell-add-hypothese-CACH hypothese n) 
  (cansell-add-hypothese-SEL hypothese n)))
))

(eval-and-compile
(defun cansell-add-hypothese-imply-RSH (hypothese n)  
 (if  (or (string= " " hypothese) (string= "" hypothese))
     ()
     (progn
        (interactive)

        (cansell-widget-ah n nil)
	(widget-insert " ")
	(cansell-widget-hypo-RSH "mh" n "Modus Ponens") (widget-insert " ")
	(cansell-widget-hypo-RSH "hm" n "Modus Ponens (with negation)") (widget-insert " ")


	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-RSH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-RSH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-RSH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))




	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)))
))

(eval-and-compile
(defun cansell-add-hypothese-imply-CACH (hypothese n)  
 (if  (or (string= " " hypothese) (string= "" hypothese))
     ()
     (progn
        (interactive)
	    (cansell-widget-dl-CACH n)
(widget-insert " ")
	(cansell-widget-ah n t)
	(widget-insert " ")
	(cansell-widget-hypo-CACH "mh" n "Modus Ponens") (widget-insert " ")
	(cansell-widget-hypo-CACH "hm" n "Modus Ponens (with negation)") (widget-insert " ")

	(if cansell-affiche-hypo-nature-ov

	    (cansell-add-widget-ov-CACH)

	    (if cansell-affiche-hypo-nature-rm
		(progn
		 (cansell-add-widget-rm-CACH) 
		 ) 
	       (widget-insert "    ")))


		(widget-insert hypothese) 
(if (and cansell-affiche-hypo-nature-ov cansell-affiche-hypo-nature-rm)(progn (widget-insert "\n                    ")(cansell-add-widget-rm-CACH))         (widget-insert "\n"))

(widget-setup)))
))

(eval-and-compile
(defun cansell-add-hypothese-imply-SEL (hypothese n)  
 (if  (or (string= " " hypothese) (string= "" hypothese))
     ()
     (progn
        (interactive)
	    (cansell-widget-dl-SEL n)
(widget-insert " ")
		  (cansell-widget-ds n)
	(widget-insert " ")
	(cansell-widget-hypo-SEL "mh" n "Modus Ponens") (widget-insert " ")
	(cansell-widget-hypo-SEL "hm" n "Modus Ponens (with negation)") (widget-insert " ")


	(if cansell-affiche-hypo-nature-ov
	    (cansell-add-widget-ov-SEL)

	    (if cansell-affiche-hypo-nature-rm
		(progn
		 (cansell-add-widget-rm-SEL) 
		 ) 
	       (widget-insert "    ")))


		(widget-insert hypothese) 
(if (and cansell-affiche-hypo-nature-ov cansell-affiche-hypo-nature-rm)(progn (widget-insert "\n                    ")(cansell-add-widget-rm-SEL))         (widget-insert "\n"))

(widget-setup)))
))

(eval-and-compile
(defun cansell-add-hypothese-imply (sel m hypothese n)  						
(if (= m 1) (cansell-add-hypothese-imply-RSH hypothese n)  
(if (= m 2)  (cansell-add-hypothese-imply-CACH hypothese n) 
  (cansell-add-hypothese-imply-SEL hypothese n)))
))

(eval-and-compile
(defun cansell-add-hypothese-in-RSH ( hypothese n)  
         (interactive)
	 
		(cansell-widget-ah n nil)
	(widget-insert " ")
	(cansell-widget-hypo-red-RSH "rm" n "Remove Membership") (widget-insert " ")
(if cansell-affiche-hypo-nature-ov
 (cansell-add-widget-ov-RSH)(widget-insert "    ") )	
(widget-insert "    ")  (widget-insert "      ")	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))
(eval-and-compile
(defun cansell-add-hypothese-in-CACH ( hypothese n)  
         (interactive)
	    (cansell-widget-dl-CACH n)
(widget-insert " ")
		(cansell-widget-ah n t)
	(widget-insert " ")
	(cansell-widget-hypo-red-CACH "rm" n "Remove Membership") (widget-insert " ")
(if cansell-affiche-hypo-nature-ov
(cansell-add-widget-ov-CACH)	(widget-insert "    ") )
	(widget-insert "     ") 	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-in-SEL ( hypothese n)  
         (interactive)
	    (cansell-widget-dl-SEL n)
(widget-insert " ")
		  (cansell-widget-ds n)
	(widget-insert " ")
	(cansell-widget-hypo-red-SEL "rm" n "Remove Membership") (widget-insert " ")
(if cansell-affiche-hypo-nature-ov (cansell-add-widget-ov-SEL)	(widget-insert "    ") )	(widget-insert "     ") 	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-in (sel m hypothese n)  						
(if (= m 1) (cansell-add-hypothese-in-RSH hypothese n)  
(if (= m 2)  (cansell-add-hypothese-in-CACH hypothese n) 
  (cansell-add-hypothese-in-SEL hypothese n)))
))

(eval-and-compile
(defun cansell-add-hypothese-in-eq-RSH ( hypothese n)  
         (interactive)
	 
		(cansell-widget-ah n nil)
	(widget-insert " ")
	(cansell-widget-hypo-RSH "eq" n "Set member equality") (widget-insert " ")


	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-RSH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-RSH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-RSH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))

        (widget-insert "     ")	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))
(eval-and-compile
(defun cansell-add-hypothese-in-eq-CACH ( hypothese n)  
         (interactive)
	    (cansell-widget-dl-CACH n)
(widget-insert " ")
		(cansell-widget-ah n t)
	(widget-insert " ")
	(cansell-widget-hypo-CACH "eq" n "Set member equality") (widget-insert " ")

	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-CACH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-CACH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-CACH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))

          (widget-insert hypothese) 
         (widget-insert "\n")(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-in-eq-SEL ( hypothese n)  
         (interactive)
	    (cansell-widget-dl-SEL n)
(widget-insert " ")
		  (cansell-widget-ds n)
	(widget-insert " ")
	(cansell-widget-hypo-SEL "eq" n "Set member equality") (widget-insert " ")
	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-SEL)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-SEL)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-SEL) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))

	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-in-eq (sel m hypothese n)  						
(if (= m 1) (cansell-add-hypothese-in-eq-RSH hypothese n)  
(if (= m 2)  (cansell-add-hypothese-in-eq-CACH hypothese n) 
  (cansell-add-hypothese-in-eq-SEL hypothese n)))
))


(eval-and-compile
(defun cansell-add-hypothese-or-RSH (hypothese n)  
        (interactive)
	
		(cansell-widget-ah n nil)
	(widget-insert " ")
	(cansell-widget-hypo-red-RSH "dc" n "Do Case")  (widget-insert " ")
	(cansell-widget-hypo-RSH "rd" n "Remove Disjunction (imply)") (widget-insert " ")
	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-RSH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-RSH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-RSH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))




	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))


(eval-and-compile
(defun cansell-add-hypothese-or-CACH (hypothese n)  
        (interactive)
	    (cansell-widget-dl-CACH n)
(widget-insert " ")
		(cansell-widget-ah n t)
	(widget-insert " ")
	(cansell-widget-hypo-red-CACH "dc" n "Do Case")  (widget-insert " ")
	(cansell-widget-hypo-CACH "rd" n "Remove Disjunction (imply)") (widget-insert " ")

	(if cansell-affiche-hypo-nature-ov

	    (cansell-add-widget-ov-CACH)

	    (if cansell-affiche-hypo-nature-rm
		(progn
		 (cansell-add-widget-rm-CACH) 
		 ) 
	       (widget-insert "    ")))


		(widget-insert hypothese) 
(if (and cansell-affiche-hypo-nature-ov cansell-affiche-hypo-nature-rm)(progn (widget-insert "\n                    ")(cansell-add-widget-rm-CACH))         (widget-insert "\n"))

(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-or-SEL ( hypothese n)  
        (interactive)
	    (cansell-widget-dl-SEL n)
(widget-insert " ")
		  (cansell-widget-ds n)
	(widget-insert " ")
	(cansell-widget-hypo-red-SEL "dc" n "Do Case")  (widget-insert " ")
	(cansell-widget-hypo-SEL "rd" n "Remove Disjunction (imply)") (widget-insert " ")

	(if cansell-affiche-hypo-nature-ov
	    (cansell-add-widget-ov-SEL)

	    (if cansell-affiche-hypo-nature-rm
		(progn
		 (cansell-add-widget-rm-SEL) 
		 ) 
	       (widget-insert "    ")))


		(widget-insert hypothese) 
(if (and cansell-affiche-hypo-nature-ov cansell-affiche-hypo-nature-rm)(progn (widget-insert "\n                    ")(cansell-add-widget-rm-SEL))         (widget-insert "\n"))

(widget-setup)
))


(eval-and-compile
(defun cansell-add-hypothese-or (sel  m hypothese n)  
 (if  (or (string= " " hypothese) (string= "" hypothese))
     ()
     (progn
(if (= m 1) (cansell-add-hypothese-or-RSH hypothese n)  
(if (= m 2)  (cansell-add-hypothese-or-CACH hypothese n) 
  (cansell-add-hypothese-or-SEL hypothese n)))
))))



(eval-and-compile
(defun cansell-add-hypothese-equals-RSH (hypothese n)  
        (interactive)
	
		(cansell-widget-ah n nil)
	(widget-insert " ")
	(cansell-widget-hypo-RSH "eh" n "Use Equality (left to right)")  (widget-insert " ")
	(cansell-widget-hypo-RSH "he" n "Use Equality (right to left )") (widget-insert " ")
	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-RSH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-RSH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-RSH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))


	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))
(eval-and-compile
(defun cansell-add-hypothese-equals-CACH (hypothese n)  
        (interactive)
	    (cansell-widget-dl-CACH n)
(widget-insert " ")
		(cansell-widget-ah n t)
	(widget-insert " ")
	(cansell-widget-hypo-CACH "eh" n "Use Equality (left to right)")  (widget-insert " ")
	(cansell-widget-hypo-CACH "he" n "Use Equality (right to left )") (widget-insert " ")


	(if cansell-affiche-hypo-nature-ov

	    (cansell-add-widget-ov-CACH)

	    (if cansell-affiche-hypo-nature-rm
		(progn
		 (cansell-add-widget-rm-CACH) 
		 ) 
	       (widget-insert "    ")))


		(widget-insert hypothese) 
(if (and cansell-affiche-hypo-nature-ov cansell-affiche-hypo-nature-rm)(progn (widget-insert "\n                    ")(cansell-add-widget-rm-CACH))         (widget-insert "\n"))

(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-equals-SEL (hypothese n)  
        (interactive)
	    (cansell-widget-dl-SEL n)
(widget-insert " ")
		  (cansell-widget-ds n)
	(widget-insert " ")
	(cansell-widget-hypo-SEL "eh" n "Use Equality (left to right)")  (widget-insert " ")
	(cansell-widget-hypo-SEL "he" n "Use Equality (right to left )") (widget-insert " ")

	(if cansell-affiche-hypo-nature-ov

	    (cansell-add-widget-ov-SEL)

	    (if cansell-affiche-hypo-nature-rm
		(progn
		 (cansell-add-widget-rm-SEL) 
		 ) 
	       (widget-insert "    ")))


		(widget-insert hypothese) 
(if (and cansell-affiche-hypo-nature-ov cansell-affiche-hypo-nature-rm)(progn (widget-insert "\n                    ")(cansell-add-widget-rm-SEL))         (widget-insert "\n"))

(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-equals (sel  m hypothese n)  
 (if  (or (string= " " hypothese) (string= "" hypothese))
     ()
     (progn
(if (= m 1) (cansell-add-hypothese-equals-RSH hypothese n)  
(if (= m 2)  (cansell-add-hypothese-equals-CACH hypothese n) 
  (cansell-add-hypothese-equals-SEL hypothese n)))
))))

(eval-and-compile
(defun cansell-add-hypothese-not-RSH ( hypothese n)  
         (interactive)

		(cansell-widget-ah n nil)
	(widget-insert " ")
	(cansell-widget-hypo-red-RSH "rn" n "Remove Negation") (widget-insert " ")


	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-RSH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-RSH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-RSH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))


 	  (widget-insert "     ")	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))
(eval-and-compile
(defun cansell-add-hypothese-not-CACH ( hypothese n)  
         (interactive)
	    (cansell-widget-dl-CACH n)
(widget-insert " ")
		(cansell-widget-ah n t)
	(widget-insert " ")
	(cansell-widget-hypo-red-CACH "rn" n "Remove Negation") (widget-insert " ")

	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-CACH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-CACH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-CACH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))

 	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-not-SEL ( hypothese n)  
         (interactive)
	    (cansell-widget-dl-SEL n)
(widget-insert " ")
		  (cansell-widget-ds n)
	(widget-insert " ")
	(cansell-widget-hypo-red-SEL "rn" n "Remove Negation") (widget-insert " ")

	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-SEL)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-SEL)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-SEL) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))

          (widget-insert hypothese) 
         (widget-insert "\n")(widget-setup)
))


(eval-and-compile
(defun cansell-add-hypothese-not (sel  m hypothese n)  
 (if  (or (string= " " hypothese) (string= "" hypothese))
     ()
     (progn
(if (= m 1) (cansell-add-hypothese-not-RSH hypothese n)  
(if (= m 2)  (cansell-add-hypothese-not-CACH hypothese n) 
  (cansell-add-hypothese-not-SEL hypothese n)))
))))


(eval-and-compile
(defun cansell-add-hypothese-exists-RSH (hypothese n)  
         (interactive)
	
		(cansell-widget-ah n nil)
	(widget-insert " ")
	(cansell-widget-hypo-red-RSH "rx" n "Remove Exists (chose a free variable)") (widget-insert " ")
	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-RSH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-RSH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-RSH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))

  (widget-insert "    ")	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))

(eval-and-compile
(defun cansell-add-hypothese-exists-CACH (hypothese n)  
         (interactive)
	    (cansell-widget-dl-CACH n)
(widget-insert " ")
		(cansell-widget-ah n t)
	(widget-insert " ")
	(cansell-widget-hypo-red-CACH "rx" n "Remove Exists (chose a free variable)") (widget-insert " ")
	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-CACH)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-CACH)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-CACH) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))

 	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))


(eval-and-compile
(defun cansell-add-hypothese-exists-SEL (hypothese n)  
         (interactive)
	    (cansell-widget-dl-SEL n)
(widget-insert " ")
		  (cansell-widget-ds n)
	(widget-insert " ")
	(cansell-widget-hypo-red-SEL "rx" n "Remove Exists (chose a free variable)") (widget-insert " ")

	(if cansell-affiche-hypo-nature-rm
           (progn
	    (cansell-add-widget-rm-SEL)(widget-insert " ")
	    (if cansell-affiche-hypo-nature-ov
		  (cansell-add-widget-ov-SEL)
	      (widget-insert "    ")))

	    (if cansell-affiche-hypo-nature-ov
		(progn
		 (cansell-add-widget-ov-SEL) (widget-insert "     ")
		 ) 
	       (widget-insert "         ")))

	(widget-insert hypothese) 
        (widget-insert "\n")(widget-setup)
))


(eval-and-compile
(defun cansell-add-hypothese-exists (sel  m hypothese n)  
 (if  (or (string= " " hypothese) (string= "" hypothese))
     ()
     (progn
(if (= m 1) (cansell-add-hypothese-exists-RSH hypothese n)  
(if (= m 2)  (cansell-add-hypothese-exists-CACH hypothese n) 
  (cansell-add-hypothese-exists-SEL hypothese n)))
))))



;;(defvar editable-mode-map
;;  (let ((edit-map (make-sparse-keymap)))
;;     (define-key edit-map (kbd "<mouse-2>") `(widget-value-set ""))))


(eval-and-compile
(defun cansell-add-multi-ph-RSH (n lh)
         (interactive)
	 (widget-insert (concat "!(" (car lh) " "))
	(setq cansell-list-ph-RSH (cons (cons (widget-create 'editable-field
                 :tag n 
                 :value ""
                 :size (length (car lh))
		 :help-echo "A term , please!"
		 
                 :action (lambda (widget &rest ignore)
		     (if cansell-prover-not-works
			   (if cansell-affiche-help
			       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-RSH")))
			     (if cansell-affiche-nx ()  (progn (x-symbol-encode)
			       (pri-prouveur-send-command "sw(rech)")
			       (pri-prouveur-send-command  (widget-get widget :tag))
			       (pri-prouveur-send-command  (concat "ph(" (cansell-cherche-instance-du-ph-RSH (widget-get widget :tag) ) ")"))(x-symbol-decode) ;;(pri-prouveur-send-command "wx&ws")
			  
))))
                )) (cons (car lh) nil)) nil)) 
	 (setq lh (cdr lh))
	  (while lh 
            (progn
	      	  (widget-insert (concat ","(car lh)  " "))
		(setq cansell-list-ph-RSH   
                     (cons (cons (widget-create 'editable-field
					  :tag n
					  :value ""
					  :size (length (car lh))
					  :help-echo "A term , please!"
					  
					  :action (lambda (widget &rest ignore)
						    (if cansell-prover-not-works
						    (if cansell-affiche-help
							(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-RSH")))
						      (if cansell-affiche-nx ()  (progn  (x-symbol-encode)
							(pri-prouveur-send-command "sw(rech)")
							(pri-prouveur-send-command  (widget-get widget :tag))
							(pri-prouveur-send-command (concat "ph(" (cansell-cherche-instance-du-ph-RSH (widget-get widget :tag) ) ")"))(x-symbol-decode)
						      ;;(pri-prouveur-send-command "wx&ws")
))
						    )))) (cons (car lh) nil))  cansell-list-ph-RSH)) 
		  (setq lh (cdr lh))
		  
	    ))	   
     (widget-insert ").(")
 (widget-setup)
 cansell-list-ph-RSH
))


(eval-and-compile
(defun cansell-add-multi-ph-CACH (n lh)
         (interactive)
	 (widget-insert (concat "!("(car lh) " " ))
	(setq cansell-list-ph-CACH (cons (cons (widget-create 'editable-field
                 :tag n 
                 :value ""
                 :size (length (car lh))
		 :help-echo "A term , please!"
		 
                 :action (lambda (widget &rest ignore)
		     (if cansell-prover-not-works
			   (if cansell-affiche-help
			       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-CACH")))
			      (if cansell-affiche-nx () (progn  (x-symbol-encode)
			       (pri-prouveur-send-command "sw(cash)")
			       (pri-prouveur-send-command  (widget-get widget :tag))
			       (pri-prouveur-send-command  (concat "ph(" (cansell-cherche-instance-du-ph-CACH (widget-get widget :tag) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command "wx&ws")
			  
))))
                )) (cons (car lh) nil)) nil)) 
	 (setq lh (cdr lh))
	  (while lh 
            (progn
	      	  (widget-insert (concat "," (car lh) " "))
		(setq cansell-list-ph-CACH   
                     (cons (cons (widget-create 'editable-field
					  :tag n
					  :value ""
					  :size (length (car lh))
					  :help-echo "A term , please!"
					  
					  :action (lambda (widget &rest ignore)
						    (if cansell-prover-not-works
						    (if cansell-affiche-help
							(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-CACH")))
						       (if cansell-affiche-nx () (progn  (x-symbol-encode)
				                        (pri-prouveur-send-command "sw(cash)")
							(pri-prouveur-send-command  (widget-get widget :tag))
							(pri-prouveur-send-command  (concat "ph(" (cansell-cherche-instance-du-ph-CACH (widget-get widget :tag) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command "wx&ws")
			      
))))
						    ))  (cons (car lh) nil)) cansell-list-ph-CACH)) 
		  (setq lh (cdr lh))
		  
	    ))	   
     (widget-insert ").(")
 (widget-setup)
 cansell-list-ph-CACH
))

(eval-and-compile
(defun cansell-add-multi-ph-SEL (n lh)
         (interactive)
	 (widget-insert (concat "!("(car lh) " ") )
	(setq cansell-list-ph-SEL (cons (cons (widget-create 'editable-field
                 :tag n 
                 :value ""
                 :size (length (car lh))
		 :help-echo "A term , please!"
		 
                 :action (lambda (widget &rest ignore)
		     (if cansell-prover-not-works
			   (if cansell-affiche-help
			       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-SEL")))
			     (if cansell-affiche-nx ()  (progn  (x-symbol-encode)
			       (pri-prouveur-send-command "sw(cash)")
			       (pri-prouveur-send-command  (widget-get widget :tag))
			       (pri-prouveur-send-command (concat "ph(" (cansell-cherche-instance-du-ph-SEL (widget-get widget :tag) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command "wx&ws")
			  
))))
                ))  (cons (car lh) nil)) nil)) 
	 (setq lh (cdr lh))
	  (while lh 
            (progn
	      	  (widget-insert (concat "," (car lh) " "))
		(setq cansell-list-ph-SEL   
                     (cons  (cons (widget-create 'editable-field
					  :tag n
					  :value ""
					  :size (length (car lh))
					  :help-echo "A term , please!"
					  
					  :action (lambda (widget &rest ignore)
						    (if cansell-prover-not-works
						    (if cansell-affiche-help
							(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-SEL")))
						      (if cansell-affiche-nx ()  (progn  (x-symbol-encode)
							(pri-prouveur-send-command "sw(cash)")
							(pri-prouveur-send-command  (widget-get widget :tag))
							(pri-prouveur-send-command (concat "ph(" (cansell-cherche-instance-du-ph-SEL (widget-get widget :tag) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command "wx&ws")
			      
))))
						    ))  (cons (car lh) nil)) cansell-list-ph-SEL)) 
		  (setq lh (cdr lh))
		  
	    ))	   
     (widget-insert ").(")
 (widget-setup)
 cansell-list-ph-SEL
))

(eval-and-compile
(defun cansell-add-multi-ph (n lh m)
(if (= m 1) (cansell-add-multi-ph-RSH n lh)  
       (if (= m 2)  (cansell-add-multi-ph-CACH  n lh) 
	 (cansell-add-multi-ph-SEL  n lh)))
))

(eval-and-compile
(defun cansell-add-ph-RSH (n h) 
        (interactive)
          (widget-insert (concat "!" h " "))
	(setq Thephwid-RSH  (widget-create 'editable-field
                 :tag n
                 :value ""
                 :size (length h)
		 :help-echo "A term , please!"		
                 :action (lambda (widget &rest ignore)
		     (if cansell-prover-not-works
 			   (if cansell-affiche-help
			       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-RSH")))
			      (if cansell-affiche-nx () (progn  (x-symbol-encode)
			       (pri-prouveur-send-command "sw(rech)")
			       (pri-prouveur-send-command  (widget-get widget :tag))
			       (pri-prouveur-send-command  (concat "ph(" (cansell-cherche-instance-du-ph-RSH (widget-get widget :tag) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command "wx&ws")
			      ))
                )))))
           (widget-insert ".(")
 (widget-setup)
 (cons (cons Thephwid-RSH (cons h nil)) nil)
))

(eval-and-compile
(defun cansell-add-ph-CACH (n h) 
        (interactive)
          (widget-insert (concat "!" h " "))
	(setq Thephwid-CACH  (widget-create 'editable-field
                 :tag n
                 :value ""
                 :size (length h)
		 :help-echo "A term , please!"		
                 :action (lambda (widget &rest ignore)
		     (if cansell-prover-not-works
 			   (if cansell-affiche-help
			       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-CACH")))
			     (if cansell-affiche-nx ()  (progn  (x-symbol-encode)
			       (pri-prouveur-send-command "sw(cash)")
			       (pri-prouveur-send-command  (widget-get widget :tag))
			       (pri-prouveur-send-command (concat "ph(" (cansell-cherche-instance-du-ph-CACH (widget-get widget :tag) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command "wx&ws")
			      ))
                )))))
           (widget-insert ".(")
 (widget-setup)
 (cons (cons Thephwid-CACH  (cons h nil))nil)
))

(eval-and-compile
(defun cansell-add-ph-SEL (n h) 
        (interactive)
          (widget-insert (concat "!" h " "))
	(setq Thephwid-SEL  (widget-create 'editable-field
                 :tag n
                 :value ""
                 :size (length h)
		 :help-echo "A term , please!"		
                 :action (lambda (widget &rest ignore)
		     (if cansell-prover-not-works
 			   (if cansell-affiche-help
			       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ph-SEL")))
			      (if cansell-affiche-nx () (progn  (x-symbol-encode)
			       (pri-prouveur-send-command "sw(cash)")
			       (pri-prouveur-send-command  (widget-get widget :tag))
			       (pri-prouveur-send-command (concat "ph(" (cansell-cherche-instance-du-ph-SEL (widget-get widget :tag) ) ")"))(x-symbol-decode);;(pri-prouveur-send-command "wx&ws")
			      )))
                ))))
           (widget-insert ".(")
 (widget-setup)
 (cons (cons Thephwid-SEL (cons h nil)) nil)
))

(eval-and-compile
(defun cansell-add-ph (n h m) 
(if (= m 1) (cansell-add-ph-RSH n h)  
       (if (= m 2)  (cansell-add-ph-CACH  n h) 
	 (cansell-add-ph-SEL  n h)))
))
(eval-and-compile
(defun cansell-length-debhypo (h)
    (if (search "!(" h)
      (length (pri-split-string (replace-in-string  (replace-in-string  h "  !(" "") ").(" "") ","))
      1
)))

(eval-and-compile
(defun cansell-insert-ph (n h m)
    (if (search "!(" h)
      (cansell-add-multi-ph n (pri-split-string (replace-in-string  (replace-in-string  h "  !(" "") ").(" "") ",") m)
      (cansell-add-ph n (replace-in-string  (replace-in-string  h "  !" "") ".(" "") m)
)))

(eval-and-compile
(defun cansell-add-hypothese-forall-RSH (hypothese x n)  
        (interactive)

		(cansell-widget-ah n nil)
	(widget-insert " ")
	(cansell-widget-ph n (search "!(" hypothese ) 1) 
(widget-insert " ")
(cansell-widget-zoom-RSH n)(widget-insert " ")

	(if cansell-affiche-hypo-nature-rm
           
	    (cansell-add-widget-rm-RSH)
	      (widget-insert "    "))



(widget-insert "       ")

 	(setq  cansell-list-widget-value-ph-RSH 
                (cons (cons n (cansell-insert-ph n hypothese 1))
                       cansell-list-widget-value-ph-RSH))
       (if x (widget-insert "\n"))
(widget-setup)						
))

(eval-and-compile
(defun cansell-add-hypothese-forall-CACH (hypothese x n)  
        (interactive)
	    (cansell-widget-dl-CACH n)
(widget-insert " ")
		(cansell-widget-ah n t)
	(widget-insert " ")
	(cansell-widget-ph n (search "!(" hypothese ) 2) 
(widget-insert " ")
(cansell-widget-zoom-CACH n)(widget-insert " ")
	(if cansell-affiche-hypo-nature-rm
           
	    (cansell-add-widget-rm-CACH)
	      (widget-insert "    "))


(widget-insert "  ")
 	(setq  cansell-list-widget-value-ph-CACH 
                (cons (cons n (cansell-insert-ph n hypothese 2))
                       cansell-list-widget-value-ph-CACH))
       (if x (widget-insert "\n"))
(widget-setup)						
))

(eval-and-compile
(defun cansell-add-hypothese-forall-SEL (hypothese x n)  
        (interactive)
	    (cansell-widget-dl-SEL n)
(widget-insert " ")
		  (cansell-widget-ds n)
	(widget-insert " ")
	(cansell-widget-ph  n (search "!(" hypothese ) 3) 
(widget-insert " ")
(cansell-widget-zoom-SEL n)(widget-insert " ")

	(if cansell-affiche-hypo-nature-rm
           
	    (cansell-add-widget-rm-SEL)
	      (widget-insert "    "))


(widget-insert "  ")
 	(setq  cansell-list-widget-value-ph-SEL 
                (cons (cons n (cansell-insert-ph n hypothese 3))
                       cansell-list-widget-value-ph-SEL))
       (if x (widget-insert "\n"))
(widget-setup)						
))


(eval-and-compile
(defun cansell-add-hypothese-forall (sel m hypothese x n)  						
 (if  (or (string= " " hypothese) (string= "" hypothese))
     ()
     (if (= m 1) (cansell-add-hypothese-forall-RSH hypothese x n)  
       (if (= m 2)  (cansell-add-hypothese-forall-CACH hypothese x n) 
	 (cansell-add-hypothese-forall-SEL hypothese x n)))
)))
				   
(eval-and-compile
(defun cansell-hypotheses-list-mode ()
  "Mode de la liste d'hypotheses"
  (pop-to-buffer PRI-HYPOTHESIS)
  
  (setq mode-popup-menu  
		`("Actions on Hypothesis" 
		  [ "ah - Add hypothesis" (pri-prouveur-send-command  "") t]
		 ;; [ "fh - False hypothesis"  (pri-process-hyp-command "fh") t] 
		  [ "eh - Use Equality in Hypothesis in Goal"  (pri-prouveur-send-command  "eh") t]
		 ;; [ "eh(AllHyp) - Use Equality in Hypothesis in All Hypothesis" (pri-process-hyp-command "eh" "AllHyp") t]
		 ;; [ "sh - Search Hypothesis" (pri-process-hyp-command "sh") t]
		  [ "mh - Modus Ponens" (pri-prouveur-send-command  "mh") t]
		  ))
  ))

;;*****************************************************************************
;; CONSTANTES
(eval-and-compile
(defconst pri-kernel-msg-regexp "\\(memory refused\\|compiler memory short\\|sequence memory short\\|int sequence memory short\\|reallocating \\|OK, memory obtained, we continue.\\|memory obtained, we continue.\\|int sequence id short\\\|sequence id short\\|Unable to open input file \\|TOO MANY HYPOTHESES\\|GOALS STACK OVERFLOW\\|Cannot access the project \\).*$" "Kernel memory message"))

;;*****************************************************************************
;; VARIABLES



  
(eval-and-compile
(defvar pri-output-buffer PRI-LOG "Tampon de sortie")
(defvar pri-begin-message nil "Debut de message")
(defvar cansell-nb 0)
(defvar cansell-hypo nil "On marque les hypos qui descendent"))
(defvar cansell-affiche-wid-goal nil "")
(defvar cansell-goal-or nil "")
(defvar cansell-goal-not nil "")
(defvar cansell-goal-member nil "")
(defvar cansell-goal-imply nil "")
(defvar cansell-goal-and nil "")
(defvar cansell-goal-forall nil "")
(defvar cansell-goal-exists nil "")
(defvar cansell-succes  nil "")
(defvar	cansell-SUCCES   nil "")

(defvar cansell-no-backtrack nil "") 
(defvar cansell-traite-le-goal  nil "")

(defvar cansell-first-cache-RSH  nil "")
(defvar cansell-first-cache-CACH  nil "")
(defvar cansell-first-cache-SEL  nil "")


(defvar cansell-number-selected-hypos-CACH 5 "c'est le nombre d'hypos  afficher")
(defvar cansell-number-selected-hypos-SEL 5 "c'est le nombre d'hypos  afficher")
(defvar cansell-number-selected-hypos-RSH 5 "c'est le nombre d'hypos  afficher")
(defvar cansell-hypos-selection-CACH nil)
(defvar cansell-hypos-selection-SEL nil)
(defvar cansell-hypos-selection-RSH nil)
(defvar cansell-nb-RSH 1)
(defvar cansell-nb-SEL 1)
(defvar cansell-nb-CACH 1)

(defvar cansell-message  nil "")
(defvar cansell-invariant "")
(defvar cansell-le-message "")

(defvar cansell-wx t)
(defvar cansell-affiche-SEL  t "")
(defvar cansell-affiche-RSH  t "")
(defvar cansell-affiche-CACH  t "")
(defvar  cansell-a-les-tables nil "")
(defvar  cansell-debut-de-la-preuve  nil "")
(defvar  cansell-debut-d-une-preuve  nil "")
(defvar cansell-affiche-status-project nil "")
(defvar  cansell-bientot-la-fin nil "")
(defvar cansell-liste-machine  nil "")
(defvar cansell-liste-Machine  nil "")
(defvar  old-message "")
(defvar cansell-erase-pri-errors nil "")
(defvar cansell-decr-nb-Unpr  nil "")
(defvar cansell-beginner nil "")
(defvar  cansell-hypo-not-found nil "") 
(defvar  cansell-prj-list nil "") 
(defvar  cansell-mach-list nil "") 
(defvar  cansell-stat-list nil "") 
(defvar  cansell-not-sv-nv  t "") 
(defvar cansell-marque-dec-as nil "") 
(defvar cansell-affiche-nx  nil "") 
(defvar cansell-mach-stat "")
(defvar  cansell-after-nx  nil "") 
(defvar  cansell-Proof-Tree nil "")
(defvar  cansell-Old-Proof-Tree nil "")
(defvar  cansell-res-diff nil "")
(defvar  cansell-raff-preuve nil "")
(defvar  cansell-not-pri-log nil "")
(defvar cansell-mouse-in-pri-log nil)
(defvar  cansell-mach-list-fin  nil)
(defvar cansell-pour-aff-proof-tree  nil)
(defvar cansell-pour-aff-old-proof-tree  nil)
(defvar cansell-PT-marque1  nil)
(defvar cansell-OPT-marque1  nil)
(defvar cansell-not-aff-pos  t)
(defvar  cansell-sortez   nil)
(defvar  cansell-affiche-dans-errors  t)
(defvar   cansell-stat-NB-list 0) 
(defvar cansell-pog-affiche-point nil)
(defvar cansell-pr-affiche-plus-moins  nil)
(defvar cansell-cherche-stat nil)
(defvar cansell-trouve-stat nil)
(defvar cansell-Dependency-graph nil)
(defvar cansell-pasencore nil) 
(defvar cansell-envoi-sml nil)
(defvar cansell-envoi-stat nil)
(defvar cansell-envoi-resources  nil)
(defvar cansell-PT-envoi nil)
(defvar  cansell-type-check nil)
(defvar cansell-clause-entete "")
(defvar cansell-attend-stat nil)
(defvar cansell-gziptar nil)
(defvar  cansell-filegziptar "CON")
(defvar  cansell-RS  nil)
(defvar  cansell-dans-error t)
(autoload 'cansell-pas-fini-les-interrupt "pri-terminal.el")

;;*****************************************************************************
;; FUNCTIONS
(eval-and-compile
(defun pri-end-of-buffer ()
  (goto-char (point-max))
;;  (recenter -1)
))

(eval-and-compile
(defun cansell-affiche-goal (l)
  (if (cdr l)
      (progn 
	(cansell-affiche-goal (cdr l))
	(insert (concat "                         " (car l) "\n"))
	)
    (progn (cansell-wid-goal (car l)) (insert "\n")))
))

 (eval-and-compile
(defun cansell-affiche-goal-ln (l)
  (if l
      (progn 
	(concat (cansell-affiche-goal-ln (cdr l))
	  (car l) )
	))

))
    
(eval-and-compile
(defun cansell-wid-goal ( h )
  (cansell-widget-AeAq)
  (widget-insert " ")
          (widget-create  'push-button
           :tag "ct"
	   :value ""
	   :help-echo "Proof by contradiction"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ct")))
		        (if cansell-affiche-nx () (cansell-wxws-pri-prouveur-send-command "ct" )))
			      )
))   (widget-insert " ")
          (widget-create  'push-button
           :tag "ss"
	   :value ""
	   :help-echo "Simplify set"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ss")))
		        (if cansell-affiche-nx () (cansell-wxws-pri-prouveur-send-command "ss" ))))))

(widget-insert " ")

(setq cansell-nb-boutons-goal 4)




 

;;(widget-insert "\n")
;;(setq cansell-nb-blanc "     ")
;; (cond 
;;	  (cansell-goal-or  (setq cansell-nb-blanc ""))
;;
;;	  (cansell-goal-not (setq cansell-nb-blanc ""))
;;
;;	  (cansell-goal-member (setq cansell-nb-blanc ""))
;;
;;	  (cansell-goal-forall (setq cansell-nb-blanc ""))
;;
;;	  (cansell-goal-exists (setq cansell-nb-blanc "  "))
;;
;;	  (t (setq cansell-nb-blanc "     ")))
       ;;(if (not cansell-goal-imply) (setq cansell-nb-blanc (concat "    " cansell-nb-blanc )))   
       ;;(interactive)
 
 ;;       (setq LeDebDc (point))
 ;;   (widget-create  'push-button
 ;;          :tag "Dc"
;;	   :value ""
;;	   :help-echo "Proof by case"
;;	   :format  "%[[%t]%]"
;;	   :notify (lambda (widget &rest ignore) 
;;			        (progn 
;;				  (goto-char LeDebDc)
;;				   (search-forward 	(car cansell-current-list-docases))
;;				   (setq LeDebcurrentDc (point)) 
;;				   (search-backward 	(car cansell-current-list-docases))
;;				   (setq LaFincurrentDc (point))
 ;;				   (isearch-highlight LeDebcurrentDc LaFincurrentDc)
;;				   (if (cdr cansell-current-list-docases) 
;;				     (setq cansell-current-list-docases (cdr cansell-current-list-docases))
;;				   (setq cansell-current-list-docases cansell-list-docases))))) (widget-insert " ")




;;      (if cansell-goal-imply (progn (widget-create  'push-button
;;           :tag "Dd"
;;	   :value ""
;;	   :help-echo "Deduction"
;;	   :format  "%[[%t]%]"
;;	   :notify (lambda (widget &rest ignore) 
;;			        (cansell-pri-prouveur-send-command nil "dd"))) (widget-insert " "))

;;(setq cansell-goal-imply nil)


         

(cond
((search "rx" cansell-goal-natu)
    (progn
       (setq cansell-nb-boutons-goal (1+ cansell-nb-boutons-goal))
       (widget-create  'push-button
           :tag "rx"
	   :value ""
	   :help-echo "Remove not emptyset"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			     (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-nd")))
			    (if cansell-affiche-nx () (pri-prouveur-send-command  "rx" ))
			   ;;(pri-prouveur-send-command  "wx&ws")
			  ))
)) (widget-insert " ")))
((search "nd" cansell-goal-natu)
    (progn
       (setq cansell-nb-boutons-goal (1+ cansell-nb-boutons-goal))
       (widget-create  'push-button
           :tag "nd"
	   :value ""
	   :help-echo "Proof by induction"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			     (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-nd")))
			    (if cansell-affiche-nx () (pri-prouveur-send-command  "nd" ))
			   ;;(pri-prouveur-send-command  "wx&ws")
			  ))
)) (widget-insert " ")))
	 ((search "or" cansell-goal-natu) 
	  (setq cansell-nb-boutons-goal (1+ cansell-nb-boutons-goal))
	  (widget-create  'push-button
           :tag "rd"
	   :value ""
	   :button-face  'pri-machines-red-face
	   :help-echo "Remove disjunction"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rd")))
		       (if cansell-affiche-nx ()  (pri-prouveur-send-command  "rd" ))
			   ;;(pri-prouveur-send-command  "wx&ws")
			  ))))
	    (widget-insert " ") 
	    (setq cansell-goal-or nil))

	  ((search "nt"  cansell-goal-natu) 
	  (setq cansell-nb-boutons-goal (1+ cansell-nb-boutons-goal))
	   (widget-create  'push-button
           :tag "rn"
	   :value ""
	   :button-face  'pri-machines-red-face
	   :help-echo "Remove negation"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rn")))
		       (if cansell-affiche-nx ()  (pri-prouveur-send-command  "rn" ))
			   ;;(pri-prouveur-send-command  "wx&ws")
			  ))))
	    (widget-insert " ")
	    (setq cansell-goal-not nil))

	  ((search ":"  cansell-goal-natu) 
	  (setq cansell-nb-boutons-goal (1+ cansell-nb-boutons-goal))
	   (widget-create  'push-button
           :tag "rm"
	   :value ""
	   :button-face  'pri-machines-red-face
	   :help-echo "Remove Membership"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rm")))
		       (if cansell-affiche-nx ()  (pri-prouveur-send-command  "rm" ))
			   ;;(pri-prouveur-send-command  "wx&ws")
			  ))			        
))
             (widget-insert " ") 
	     (setq cansell-goal-member nil))

	  ((search "!"  cansell-goal-natu) 
	  (setq cansell-nb-boutons-goal (1+ cansell-nb-boutons-goal))
	   (widget-create  'push-button
           :tag "gn"
	   :value ""
	   :help-echo "Remove forall"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-gn")))
		        (if cansell-affiche-nx () (pri-prouveur-send-command  "gn" ))
			   ;;(pri-prouveur-send-command  "wx&ws")
			  ))
			      )) 
	     (widget-insert " ") 
	     (setq cansell-goal-forall nil))


 ((search "<+" cansell-goal-natu)
    (progn
      (setq cansell-nb-boutons-goal (1+ cansell-nb-boutons-goal))
        (widget-create  'push-button
           :tag "ov"
	   :value ""
	   :help-echo "Proof by case"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ov")))
			   (if cansell-affiche-nx ()  (pri-prouveur-send-command  "ov" ))
			   ;;(pri-prouveur-send-command  "wx&ws")
			  ))			   
			   
))) (widget-insert " "))

 ((search "<<" cansell-goal-natu)
    (progn
      (setq cansell-nb-boutons-goal (1+ cansell-nb-boutons-goal))
        (widget-create  'push-button
           :tag "ri"
	   :value ""
	   :help-echo "Remove inclusion"
	   ;;:button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ri")))
			   (if cansell-affiche-nx ()  (pri-prouveur-send-command  "ri" ))
			   ;;(pri-prouveur-send-command  "wx&ws")
			  ))			   
			   
))) (widget-insert " "))

)	  ;;(t (widget-insert "     "))
	  


 (setq LeCharPixelCol (current-column))

(if (search "#"  cansell-goal-natu)
  (cansell-add-se-goal h)
  (widget-insert  (concat (cansell-compense-blanc  cansell-nb-boutons-goal) h)))
(widget-setup)
))

(eval-and-compile
(defun cansell-compense-blanc (n)
  (if (>= n 5) "" (concat "     "  (cansell-compense-blanc (1+ n))))))
 
(eval-and-compile
(defun cansell-add-se-goal (h)
        (setq cansell-goal-exists nil)
  	(setq lse (pri-split-string h "\\."))
	(cansell-affiche-se (car lse))
	(insert (cansell-concat-point (cdr lse)))
))
(eval-and-compile
(defun cansell-concat-point (l)
  (if l
    (concat "." (car l) (cansell-concat-point (cdr l)))
    ""
    )
))

(eval-and-compile
(defun cansell-affiche-se (h)
  (if (search "#(" h)
      (cansell-add-multi-se  (pri-split-string (replace-in-string  (replace-in-string  h "#(" "") ")" "") ","))
(cansell-add-se  (replace-in-string  h "#" "")) 
)))

(eval-and-compile
(defun cansell-add-multi-se (lh)
  (if (cdr lh)
    ( cansell-add-multi-se-bon lh)
   (cansell-add-se (car lh)))
))

(eval-and-compile
(defun cansell-add-multi-se-bon (lh)

         (interactive)
(widget-create  'push-button
           :tag "se"
	   :value ""
	   :help-echo "Instantiation"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-se")))
		       (if cansell-affiche-nx ()  (if (cansell-all-se-vide) (cansell-wxws-pri-prouveur-send-command "se")
(progn(x-symbol-encode) (cansell-wxws-pri-prouveur-send-command (concat "se(" (cansell-cherche-instance-du-se ) ")"))(x-symbol-decode)) ))
))))

	(widget-insert (cansell-compense-blanc  (1+ cansell-nb-boutons-goal))) (widget-insert (concat "  #("(car lh)  " "))

	(setq cansell-list-se (cons (cons (widget-create 'editable-field
                 
                 :value ""
                 :size (length (car lh))
		 :help-echo "A term , please!"
		 ;;:format  "%[%v%]"
                 :action (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
			   (if cansell-affiche-help
			       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-se")))
			     (if cansell-affiche-nx ()  (progn  (x-symbol-encode)
			       (cansell-wxws-pri-prouveur-send-command (concat "se(" (cansell-cherche-instance-du-se ) ")"))(x-symbol-decode)))
                ))))(cons (car lh) nil))  nil)) 
	 (setq lh (cdr lh))
	  (while lh 
            (progn
	      	  (widget-insert (concat "," (car lh) " "))
		(setq cansell-list-se   
                     (cons (cons (widget-create 'editable-field
					  
					  :value ""
					  :size (length (car lh))
					  :help-echo "A term , please!"
					  :action (lambda (widget &rest ignore)
						    (if  cansell-prover-not-works 
							(if cansell-affiche-help
							(progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-se")))
						      (if cansell-affiche-nx ()  (progn  (x-symbol-encode)
							(cansell-wxws-pri-prouveur-send-command (concat "se(" (cansell-cherche-instance-du-se ) ")"))(x-symbol-decode)))))
						    
       )) (cons (car lh) nil)) cansell-list-se)) 
		  (setq lh (cdr lh))
		  
	    ))	   
     (widget-insert ")")
 (widget-setup)
))


(eval-and-compile
(defun  cansell-all-vide (l)
  (if  l
    (if (string= (widget-value (car (car l))) "") 
	 (cansell-all-vide (cdr l))
         nil)
     t)

))

(eval-and-compile
(defun  cansell-all-se-vide ()
    (cansell-all-vide cansell-list-se)
))

(eval-and-compile
(defun cansell-cherche-instance-du-se ()
    (cansell-transforme-se cansell-list-se)
))

(eval-and-compile
(defun cansell-test-se (a  b  v)
 		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-se")))
		       (if a
			   (cansell-wxws-pri-prouveur-send-command  (concat "se(" b ")"))
			 (if (string= v "")
			     (cansell-wxws-pri-prouveur-send-command "se")
			   (cansell-wxws-pri-prouveur-send-command (concat "se(" v ")")))))
)))

(eval-and-compile
(defun cansell-add-se ( h) 
        (interactive)
(widget-create  'push-button
           :tag "se"
	   :value ""
	   :help-echo "Instantiation"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if cansell-affiche-nx () (progn (x-symbol-encode) (cansell-test-se (region-active-p)(buffer-string (mark) (point))(widget-value Le-wid-se))(x-symbol-decode)))

))

   	(widget-insert (cansell-compense-blanc  (1+ cansell-nb-boutons-goal)))       (widget-insert (concat "  #" (replace-in-string   h " " "") " "))
	(setq Le-wid-se (widget-create 'editable-field
                 
                 :value ""
                 :size (length h)
		 :help-echo "A term , please!"
                 :action (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
			   (if cansell-affiche-help
			       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-se")))
			     (if cansell-affiche-nx () (progn (x-symbol-encode) (cansell-wxws-pri-prouveur-send-command  (concat "se(" (widget-value widget)  ")"))(x-symbol-decode)))))
		 ;;:format  "%[%v%]"
                
                )))
(widget-insert " ")
 (widget-setup)
))


(eval-and-compile
(defun cansell-add-bouton-ed ()
	 (pri-before-writting-buffer PRI-LOG)
	 (end-of-buffer)
         ;;(widget-insert " ")
	 (widget-create  'push-button
           :tag "ed"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Edition of component"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
	 		 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ed"))   )
		        
			  (if cansell-affiche-nx ()  (progn
			  
			   (pop-to-buffer    cansell-component-buffer nil cansell-error-frame) 
			 (delete-other-windows)
			  
                           (set-buffer  cansell-component-buffer)
			    (x-symbol-mode "B entity")
			   (font-lock-fontify-buffer) 
                           (cansell-affiche-balbulette-bis)			 )))
			
)))

(widget-insert " ")
	 (widget-create  'push-button
           :tag "od"
	   :value ""
	   :help-echo "Old proof"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-oldproof")))
		         (progn   (pop-to-buffer    PRI-OLD-PROOF t  cansell-error-frame) (delete-other-windows))))))
 (pri-after-writting-buffer)
))

(eval-and-compile
(defun cansell-add-bouton-ne-pv()
	(pri-before-writting-buffer PRI-LOG)
	(end-of-buffer)
        ;;(widget-insert " ")
	 (widget-create  'push-button
           :tag "ne"
	   :value ""
	   :format  "%[[%t]%]"
	   :help-echo "Next proof obligation"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ne")))
		        (if cansell-affiche-nx ()  (progn 		(setq cansell-raff-preuve   nil)(setq cansell-pour-aff-old-proof-tree nil)	  (setq cansell-debut-d-une-preuve t)(setq cansell-decr-nb-Unpr t)(setq cansell-cansell-nb-as 0)(pri-prouveur-send-command  "ne" )))))))
	 (widget-insert " ")

	 (widget-create  'push-button
           :tag "pv"
	   :value ""
	   :help-echo "Previous proof obligation"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-pv")))
		      (if cansell-affiche-nx ()  (progn 	(setq cansell-raff-preuve   nil)	(setq cansell-pour-aff-old-proof-tree nil)	  (setq cansell-debut-d-une-preuve t)(setq cansell-decr-nb-Unpr t) (pri-prouveur-send-command  "pv" )))))))
 (widget-insert " ")
(if cansell-beginner
	 (widget-create  'push-button
           :tag "xp"
	   :value ""
	   :help-echo "Expert mode"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-xp")))
		      (if cansell-affiche-nx ()  (progn    (pri-prouveur-send-command  "xp" ))))))) 
	 (widget-create  'push-button
           :tag "bg"
	   :value ""
	   :help-echo "Beginner mode"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-bg")))
		      (progn   (if cansell-affiche-nx () (pri-prouveur-send-command  "bg" )))))))) 
 (widget-insert "\n")

	 (widget-create  'push-button
           :tag "np"
	   :value ""
	   :help-echo "Next proof tree (Doesn't work)"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-bg")))
		      (progn   (if cansell-affiche-nx () (pri-prouveur-send-command  "npt" )))))))
 
 (widget-insert " ")
	 (widget-create  'push-button
           :tag "pp"
	   :value ""
	   :help-echo "Previous proof tree (doesn't work)"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-bg")))
		      (progn   (if cansell-affiche-nx () (pri-prouveur-send-command  "ppt" ))))))) 


 (widget-insert " ")
	 (widget-create  'push-button
           :tag "rs"
	   :value ""
	   :help-echo "Display RS table in another window"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-RS")))
		      (progn   (if cansell-affiche-nx () (progn(if (not cansell-RS) (progn   (setq cansell-RS t) (pop-to-buffer"pri-rs" nil cansell-proj-frame) (delete-other-windows) (setq wrs (split-window  (frame-selected-window cansell-proj-frame) )) (set-window-buffer wrs  "pri-log" )
(walk-windows  (function (lambda (w) (select-window w) 
      (if (string= "pri-rs" (buffer-name (window-buffer))) 
                                (recenter -1) 
 )))
 'nomini)
       (select-window wrs)   (if (string= "pri-log" (buffer-name (window-buffer))) 
          (cansell-affiche-balbulette-bis)


))

  (progn (setq cansell-RS nil)(pop-to-buffer  PRI-LOG nil cansell-proj-frame) (delete-other-windows)
;; (scroll-down (min 0 (- (count-lines-buffer) (window-height) )))
) )))))))) 

 (if (cansell-encore-des-as cansell-proof-tree)
    (progn    (widget-insert " ") (setq cansell-wid-r1 (widget-create  'push-button
           :tag "r1"
	   :value ""
	   :help-echo "Reset with local proof refinement"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
			        (if cansell-affiche-help
				    (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-re")))
				  (progn 

(pop-to-buffer    PRI-PROOF-TREE  t cansell-error-frame) 
  (delete-other-windows)(setq w2 (split-window  (frame-selected-window cansell-error-frame) )) (set-window-buffer w2  PRI-OLD-PROOF )
(setq cansell-cansell-nb-as 0)(setq cansell-raff-preuve   t)(setq cansell-reset-proof   t)                    (if cansell-pour-aff-proof-tree
                     (setq cansell-pour-aff-proof-tree-old cansell-pour-aff-proof-tree)(setq cansell-pour-aff-proof-tree-old nil))(setq cansell-debut-d-une-preuve  t)(pri-prouveur-send-command  "r1" )))

)))))))

(if (cansell-encore-des-as cansell-proof-old-tree-pos)
       (progn  (widget-insert " ")
       (setq cansell-wid-r2 (widget-create  'push-button
           :tag "r2"
	   :value ""
	   :help-echo "Reset with old proof"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		      (if  cansell-not-sv-nv (if cansell-prover-not-works
			        (if cansell-affiche-help
				    (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-re")))
				  (progn  (pop-to-buffer    PRI-PROOF-TREE  t cansell-error-frame) 
  (delete-other-windows)(setq w2 (split-window  (frame-selected-window cansell-error-frame))) (set-window-buffer w2  PRI-OLD-PROOF )(setq cansell-cansell-nb-as 0)(setq cansell-raff-preuve   t)(setq cansell-reset-proof   t)                    (setq cansell-debut-d-une-preuve  t)(pri-prouveur-send-command  "r2" )))

)))))))

(if cansell-affiche-nx 
(progn (widget-insert " ")
	 (widget-create  'push-button
           :tag "nx"
	   :value ""
	   :help-echo "next as"
	   :format  "%[[%t]%]"
	   :button-face  'pri-machines-red-face
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-bg")))
		      (progn    (setq cansell-marque-dec-as t) (setq cansell-after-nx t)
				(let ((entre-deux (cansell-entre-deux-as)))
				   ;;(tester entre-deux)
				  (if entre-deux (cansell-pri-send-command-list-pt entre-deux )
				    (progn (pri-send-command "gl")
)))))
)
)))) 
	 (pri-after-writting-buffer)

 ))

(defun kill-goal ()
(pri-before-writting-buffer PRI-LOG)
(interactive)
  (beginning-of-buffer)
  (search-forward  " ______________ ")
  (beginning-of-line)
  (setq LeDeb (point))
  (next-line 1)
  (search-forward  " ______________ ")
  (end-of-line)
  (setq LaFin (point))
  (kill-region LeDeb  LaFin )
  (pri-after-writting-buffer)
)
(eval-and-compile
(defun cansell-widget-zoom-RSH( n)
   	 (widget-create  'push-button
           :tag "zm"
	   :value n
	   :help-echo "Zoom or UnZoom"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-zm")))
		       (if (cansell-string-est-dans (widget-value widget)cansell-les-ph-pas-point-RSH)  (setq cansell-les-ph-pas-point-RSH (cansell-string-delete (widget-value widget)cansell-les-ph-pas-point-RSH)) 
			   (setq cansell-les-ph-pas-point-RSH (cons (widget-value widget) cansell-les-ph-pas-point-RSH)))
				(setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)	

								
 (cansell-affiche-balbulette-bis) ))))   (widget-setup)
)) 

(eval-and-compile
(defun cansell-widget-zoom-CACH( n)
   	 (widget-create  'push-button
           :tag "zm"
	   :value n
	   :help-echo "Zoom or UnZoom"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-zm")))
		       (if (cansell-string-est-dans (widget-value widget)cansell-les-ph-pas-point-CACH)  (setq cansell-les-ph-pas-point-CACH (cansell-string-delete (widget-value widget)cansell-les-ph-pas-point-CACH)) 
			 (setq cansell-les-ph-pas-point-CACH (cons (widget-value widget) cansell-les-ph-pas-point-CACH)))
		       (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)	

								
 (cansell-affiche-balbulette-bis) ))))   (widget-setup)
)) 

(eval-and-compile
(defun cansell-widget-zoom-SEL( n)
   	 (widget-create  'push-button
           :tag "zm"
	   :value n
	   :help-echo "Zoom or UnZoom"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-zm"))) 
				   (if (cansell-string-est-dans (widget-value widget)cansell-les-ph-pas-point-SEL)  (setq cansell-les-ph-pas-point-SEL (cansell-string-delete (widget-value widget)cansell-les-ph-pas-point-SEL)) 
			   (setq cansell-les-ph-pas-point-SEL (cons (widget-value widget) cansell-les-ph-pas-point-SEL)))
				(setq 	cansell-hypos-selection-SEL cansell-hypos-selection-SELold)	

								
 (cansell-affiche-balbulette-bis) ))))   (widget-setup)
)) 


(eval-and-compile
(defun cansell-widget-zoom (n m)
  (cond
    ((= m 1)  (cansell-widget-zoom-RSH n))
    ((= m 2)  (cansell-widget-zoom-CACH n))
    ( t  (cansell-widget-zoom-SEL n)))
)) 

(eval-and-compile
(defun cansell-add-point (n h)
   	 (widget-create  'push-button
           :tag ".."
	   :value n
	   :help-echo "Show hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dot")))
(if (cansell-string-est-dans (widget-value widget)cansell-les-ph-pas-point-droit)  (setq cansell-les-ph-pas-point-droit (cansell-string-delete (widget-value widget)cansell-les-ph-pas-point-droit)) 
(setq cansell-les-ph-pas-point-droit (cons (widget-value widget) cansell-les-ph-pas-point-droit)))
(cansell-affiche-balbulette-bis)
			       ;; (setq cansell-les-ph-pas-point (cons (widget-value widget) cansell-les-ph-pas-point))

  )))) (widget-insert (concat " =>" (replace-in-string h "          " "")))  (widget-setup)
)) 

(eval-and-compile
(defun cansell-add-point-droit-RSH (n)
   	 (widget-create  'push-button
           :tag ".."
	   :value n
	   :help-echo "Show hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dot")))
		       (progn
			 (if (cansell-string-est-dans (widget-value widget) cansell-les-ph-pas-point-droit-RSH)  
			     (setq cansell-les-ph-pas-point-droit-RSH (cansell-string-delete (widget-value widget)cansell-les-ph-pas-point-droit-RSH)) 
			   (setq cansell-les-ph-pas-point-droit-RSH (cons (widget-value widget) cansell-les-ph-pas-point-droit-RSH)))

			 ;; (setq cansell-les-ph-pas-point (cons (widget-value widget) cansell-les-ph-pas-point))
			 (setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)	
			 (cansell-affiche-balbulette-bis)))

)))   (widget-setup)
)) 

(eval-and-compile
(defun cansell-add-point-droit-CACH (n)
   	 (widget-create  'push-button
           :tag ".."
	   :value n
	   :help-echo "Show hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dot")))
		       (progn
			 (if (cansell-string-est-dans (widget-value widget) cansell-les-ph-pas-point-droit-CACH)  
			     (setq cansell-les-ph-pas-point-droit-CACH (cansell-string-delete (widget-value widget)cansell-les-ph-pas-point-droit-CACH)) 
			   (setq cansell-les-ph-pas-point-droit-CACH (cons (widget-value widget) cansell-les-ph-pas-point-droit-CACH)))
			 
			 ;; (setq cansell-les-ph-pas-point (cons (widget-value widget) cansell-les-ph-pas-point))
			 (setq 	cansell-hypos-selection-SEL cansell-hypos-selection-SELold)
			 (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)	
			 (cansell-affiche-balbulette-bis)
			 )))

))   (widget-setup)
)) 

(eval-and-compile
(defun cansell-add-point-droit-SEL (n)
   	 (widget-create  'push-button
           :tag ".."
	   :value n
	   :help-echo "Show hypothesis"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dot")))
		       (progn 
			 (if (cansell-string-est-dans (widget-value widget) cansell-les-ph-pas-point-droit-SEL)  
			     (setq cansell-les-ph-pas-point-droit-SEL (cansell-string-delete (widget-value widget)cansell-les-ph-pas-point-droit-SEL)) 
			   (setq cansell-les-ph-pas-point-droit-SEL (cons (widget-value widget) cansell-les-ph-pas-point-droit-SEL)))
			 
			 ;; (setq cansell-les-ph-pas-point (cons (widget-value widget) cansell-les-ph-pas-point))
			 (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)
			 (setq 	cansell-hypos-selection-SEL cansell-hypos-selection-SELold)	
			 (cansell-affiche-balbulette-bis)
			 )))

))   (widget-setup)
)) 

(eval-and-compile
(defun cansell-add-point-droit (n m)
  (cond
    ((= m 1)  (cansell-add-point-droit-RSH n))
    ((= m 2)  (cansell-add-point-droit-CACH n))
    ( t  (cansell-add-point-droit-SEL n))
)))

(eval-and-compile
(defun cansell-affiche-reste-hypo-avec-points-droit (l n m)
  (if (string= (car  l) "          => ")
      (progn
	(cansell-affiche-reste-hypo-sans-nl (cdr l))
	(insert " => ")
	(cansell-add-point-droit n m)
	(insert " "))
      (progn
	(cansell-affiche-reste-hypo-avec-points-droit (cdr l) n m)
	))
))

(eval-and-compile
(defun cansell-affiche-reste-hypo-avec-points (l n d m)
  (if (string= (car (cdr l)) "          => ")
      (progn (insert " ")(cansell-add-point-droit n  m) (widget-insert (concat " =>" (replace-in-string (car l) "          " "") )))
      (progn
	(cansell-affiche-reste-hypo-avec-points (cdr l) n d m)
	(insert (replace-in-string (car l) "^ +" "") )
	))
))

(eval-and-compile
(defun cansell-nblanc (n)
  (if (= n 0) "" (concat " " (cansell-nblanc (- n 1))))
  ))

(eval-and-compile
(defun cansell-affiche-reste-hypo (l)
  (if l
      (progn
	(cansell-affiche-reste-hypo (cdr l))
	(insert (concat "                 " (car l) "\n"))
	)
)))

(eval-and-compile
(defun cansell-affiche-reste-hypo-sans-nl(l)
  (if l
      (progn
	(cansell-affiche-reste-hypo-sans-nl (cdr l))
	(insert (concat " " (replace-in-string (replace-in-string (car l)"^ +" "") " $" "") ))
	)
)))

(eval-and-compile
(defun cansell-string-delete (v l)
     (if (string= v (car l))
	 (cdr l)
       (cons (car l) (cansell-string-delete v (cdr l)))
)))



(eval-and-compile
(defun cansell-string-est-dans (v l)
 (if l
     (if (string= v (car l))
	 t
       (cansell-string-est-dans v (cdr l)))
   nil)))

(eval-and-compile
(defun cansell-add-widget-ov-RSH() 
        (widget-create  'push-button
           :tag "ov"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Proof by case"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ov-RSH")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(rech)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "ov" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))

(eval-and-compile
(defun cansell-add-widget-ov-CACH() 
        (widget-create  'push-button
           :tag "ov"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Proof by case"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ov-CACH")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(cash)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "ov" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))

(eval-and-compile
(defun cansell-add-widget-ov-SEL() 
        (widget-create  'push-button
           :tag "ov"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Proof by case"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ov-SEL")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(cash)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "ov" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))

(eval-and-compile
(defun cansell-add-widget-rm-RSH() 
        (widget-create  'push-button
           :tag "rm"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Remove Membership"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rm-RSH")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(rech)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "rm" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))

(eval-and-compile
(defun cansell-add-widget-rm-CACH() 
        (widget-create  'push-button
           :tag "rm"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Remove Membership"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rm-CACH")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(cash)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "rm" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))


(eval-and-compile
(defun cansell-add-widget-rm-SEL() 
        (widget-create  'push-button
           :tag "rm"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Remove Membership"
	   :button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-rm-SEL")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(cash)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "rm" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))

(eval-and-compile
(defun cansell-add-widget-ri-RSH() 
        (widget-create  'push-button
           :tag "ri"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Remove inclusion"
	   ;;:button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ri-RSH")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(rech)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "ri" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))

(eval-and-compile
(defun cansell-add-widget-ri-CACH() 
        (widget-create  'push-button
           :tag "ri"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Remove inclusion"
	   ;;:button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ri-CACH")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(cash)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "ri" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))

(eval-and-compile
(defun cansell-add-widget-ri-SEL() 
        (widget-create  'push-button
           :tag "ri"
	   :value cansell-affiche-hypo-NUMBER
	   :help-echo "Remove inclusion"
	   ;;:button-face  'pri-machines-red-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if  cansell-prover-not-works 
			 (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ri-SEL")))
			 (if cansell-affiche-nx ()  (progn  				  (pri-prouveur-send-command  "sw(cash)")
				  (pri-prouveur-send-command  (widget-value widget) )
			 (pri-prouveur-send-command  "ri" )
			   ;;(pri-prouveur-send-command  "wx&ws")
			  )))			   
			   
)))
))


(eval-and-compile
(defun cansell-affiche-sel-No (n m)
    (let ((cansell-affiche-counter 1))
	 
    (while (< cansell-affiche-counter n)
      (setq cansell-hypos-selection (if (= m 1) cansell-hypos-selection-RSH  (if (= m 2)  cansell-hypos-selection-CACH cansell-hypos-selection-SEL)))
      (setq  cansell-les-ph-pas-point (if (= m 1)  cansell-les-ph-pas-point-RSH  (if (= m 2)   cansell-les-ph-pas-point-CACH  cansell-les-ph-pas-point-SEL)))
      (setq  cansell-les-ph-pas-point-droit (if (= m 1)  cansell-les-ph-pas-point-droit-RSH  (if (= m 2)   cansell-les-ph-pas-point-droit-CACH  cansell-les-ph-pas-point-droit-SEL)))

      (let 
          ((cansell-affiche-hypo-number (car (car cansell-hypos-selection)))
	   (cansell-affiche-hypo-nature (car (cdr (car cansell-hypos-selection)))) 
           (cansell-affiche-deb-hypo (car (cdr (cdr (car cansell-hypos-selection)))))
           (cansell-affiche-la-suite-des-hypos  (car (cdr (cdr (cdr (car cansell-hypos-selection)))))))
	(progn
	 (widget-insert "\n")
	  (if (search "<+" cansell-affiche-hypo-nature) 
	      (progn 
		(setq cansell-affiche-hypo-nature (replace-in-string  cansell-affiche-hypo-nature "<\\+" ""))
		(setq cansell-affiche-hypo-nature-ov t))
	 	(setq cansell-affiche-hypo-nature-ov nil))
	  (if (search "<<" cansell-affiche-hypo-nature) 
	      (progn 
		(setq cansell-affiche-hypo-nature (replace-in-string  cansell-affiche-hypo-nature "<<" ""))
		(setq cansell-affiche-hypo-nature-ri t))
	 	(setq cansell-affiche-hypo-nature-ri nil))
	  (if (search ":" cansell-affiche-hypo-nature) 
	      (progn 
		(setq cansell-affiche-hypo-nature (replace-in-string  cansell-affiche-hypo-nature ":" ""))
		(setq cansell-affiche-hypo-nature-rm t))
	 	(setq cansell-affiche-hypo-nature-rm nil))
	  (setq cansell-affiche-hypo-NUMBER (cansell-string-nb cansell-affiche-hypo-number))
          (setq  cansell-affiche-deb-hypo  (concat "  " (replace-in-string  cansell-affiche-deb-hypo "^ +" "")))
	  (cond
	    ( (string= "=>"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-imply  nil m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))

	     )

	    ((string= "or"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-or  nil m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )
 
	    ((string= "="  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-equals nil m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )

	    ((string= "nt"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-not nil m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )


	    ((string= "!"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-forall nil  m
	      cansell-affiche-deb-hypo 
	      (cansell-string-est-dans  (cansell-string-nb cansell-affiche-hypo-number) cansell-les-ph-pas-point)
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )


	    ((string= "#"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-exists nil m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )


;;	    ((string= ":"  cansell-affiche-hypo-nature)
;;	     (cansell-add-hypothese-in nil m
;;	      cansell-affiche-deb-hypo
;;	      (cansell-string-nb cansell-affiche-hypo-number))
;;	     )

	    ((string= "eq"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-in-eq nil m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )

	    ( (string= "s=>"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-imply t m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))

	     )

	    ((string= "sor"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-or t m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )
 
	    ((string= "s="  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-equals t m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )

	    ((string= "snt"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-not t m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )


	    ((string= "s!"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-forall t m
	      cansell-affiche-deb-hypo 
	      (cansell-string-est-dans  (cansell-string-nb cansell-affiche-hypo-number) cansell-les-ph-pas-point)
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )


	    ((string= "s#"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-exists t m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )


	    ((string= "s:"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-in t m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )
	    ((string= "seq"  cansell-affiche-hypo-nature)
	     (cansell-add-hypothese-in-eq t m
	      cansell-affiche-deb-hypo
	      (cansell-string-nb cansell-affiche-hypo-number))
	     )

	    ((string= "sother"  cansell-affiche-hypo-nature)
	          (cansell-add-hypothese  t m
		   cansell-affiche-deb-hypo
		   (cansell-string-nb cansell-affiche-hypo-number)))
	    

	    ( t (cansell-add-hypothese  nil m
	          cansell-affiche-deb-hypo
	         (cansell-string-nb cansell-affiche-hypo-number))
	    )
  
)

(if (or (string= "!"  cansell-affiche-hypo-nature) (string= "s!"  cansell-affiche-hypo-nature) )
  (if (cansell-string-est-dans  (cansell-string-nb cansell-affiche-hypo-number) cansell-les-ph-pas-point)
(cansell-affiche-reste-hypo cansell-affiche-la-suite-des-hypos)
  (if (cansell-string-est-dans  (cansell-string-nb cansell-affiche-hypo-number) cansell-les-ph-pas-point-droit)
       (progn
	 (cansell-affiche-reste-hypo-avec-points-droit (cdr cansell-affiche-la-suite-des-hypos) (cansell-string-nb cansell-affiche-hypo-number) m) (widget-insert ")\n"))
      (progn
          (cansell-affiche-reste-hypo-avec-points (cdr cansell-affiche-la-suite-des-hypos) (cansell-string-nb cansell-affiche-hypo-number) (cansell-nblanc (+ (length cansell-affiche-deb-hypo) 19 (cansell-length-debhypo cansell-affiche-deb-hypo))) m) (widget-insert ")\n"))

)
)

(cansell-affiche-reste-hypo  cansell-affiche-la-suite-des-hypos)        
)
 (if (= m 1) 
   (progn 
    (setq  cansell-hypos-selection-RSH (cdr cansell-hypos-selection-RSH)  )
  (if cansell-hypos-selection-RSH () (setq cansell-hypos-selection-RSH cansell-first-cache-RSH)))
  (if (= m 2) 
   (progn 
     (setq  cansell-hypos-selection-CACH (cdr cansell-hypos-selection-CACH)  )
   (if cansell-hypos-selection-CACH () (setq cansell-hypos-selection-CACH cansell-first-cache-CACH)))
    (progn 
    (setq  cansell-hypos-selection-SEL (cdr cansell-hypos-selection-SEL)  )
   (if cansell-hypos-selection-SEL () (setq cansell-hypos-selection-SEL cansell-first-cache-SEL)))))
   (setq cansell-affiche-counter (1+ cansell-affiche-counter))
)
)))))




(eval-and-compile
(defun cansell-affiche-sel (n m)
    (cansell-affiche-sel-No n m) 
    (cansell-NO-other-hypos-widget m)
))


(eval-and-compile
(defun cansell-NO-other-hypos-widget (m)
(if (= m 1) (cansell-NO-other-hypos-widget-RSH)  
(if (= m 2)  (cansell-NO-other-hypos-widget-CACH) 
  (cansell-NO-other-hypos-widget-SEL))))
)


(eval-and-compile
(defun cansell-NO-other-hypos-widget-RSH ()
 (widget-insert "\n")  
(widget-create  'push-button
					 :tag "RS"
					 :value ""
					 :help-echo "visible or not"
					 :button-face  'pri-machines-blue-face
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-prover-not-works 
						       (if cansell-affiche-help
							   (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-RSH"))
)							 (progn    
							   (setq cansell-affiche-RSH (not cansell-affiche-RSH))
							   (cansell-affiche-balbulette-bis))))))
 (widget-insert  " ")
 (widget-create  'push-button
           :tag "[--]"
	   :value ""
	   :help-echo "Another hypothesis"
	   :format  "%[%t%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-minus")))
		       (if (>  cansell-number-selected-hypos-RSH 2)
				    (progn
				      (setq cansell-number-selected-hypos-RSH (1- cansell-number-selected-hypos-RSH))
				      (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)	
				      (setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)
				      (cansell-affiche-balbulette-bis))

)))))		 		     
;;  (widget-insert  " ")


  (widget-insert  " --------------------------------- " )
(widget-insert  (concat " (" (int-to-string (1- cansell-nb-RSH )) "/" (int-to-string (1- cansell-nb-RSH )) ")\n " )  )
(widget-setup)))

(eval-and-compile
(defun cansell-NO-RSH-hypos-widget ()
 (widget-insert "\n")  
(widget-create  'push-button
					 :tag "RS"
					 :value ""
					 :help-echo "visible or not"
					 :button-face  'pri-machines-blue-face
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-prover-not-works 
						   (if cansell-affiche-help
						       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-RSH")))
						     (progn    
						       (setq cansell-affiche-RSH (not cansell-affiche-RSH))
						       (cansell-affiche-balbulette-bis))))))
 (widget-insert  " ")

  (widget-insert  " ------------------------------------- " )
(widget-insert  (concat " (" (int-to-string (1- cansell-nb-RSH )) "/" (int-to-string (1- cansell-nb-RSH )) ")\n " )  )
(widget-setup)))


(eval-and-compile
(defun cansell-NO-other-hypos-widget-CACH ()
 (widget-insert "\n")  
(widget-create  'push-button
					 :tag "KH"
					 :value ""
					 :help-echo "visible or not"
					 :button-face  'pri-machines-blue-face
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-prover-not-works 
						   (if cansell-affiche-help
						       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-CACH")))
						     (progn    
						       (setq cansell-affiche-CACH (not cansell-affiche-CACH))
						       (cansell-affiche-balbulette-bis))))))
(widget-insert  " ")
 (if (>  cansell-number-selected-hypos-CACH 1)
 (widget-create  'push-button
           :tag "--"
	   :value ""
	   :help-echo "Another hypothesis"
	   :button-face  'pri-machines-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-minus")))
		       				    (progn
				      (setq cansell-number-selected-hypos-CACH (1- cansell-number-selected-hypos-CACH))
				      (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)	
				      (setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)
				      (cansell-affiche-balbulette-bis))

))))


(widget-insert  "    ") )

(widget-insert  " ")
  (widget-create  'push-button
           :tag "cl"
	  ;; :value n
	   :help-echo "remove all hypothesis from KH"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dl-CACH")))
			 (if cansell-affiche-nx () 	(progn 
				  (pri-prouveur-send-command "clk")
				  (pri-prouveur-send-command  "wx&ws"))
)))
	   )
)
		  (widget-insert  " --------------------------------- " )
 (widget-insert  (concat " (" (int-to-string (1- cansell-nb-CACH )) "/" (int-to-string (1- cansell-nb-CACH )) ") \n" )  )
(widget-setup)))

(eval-and-compile
(defun cansell-NO-CACH-hypos-widget ()
 (widget-insert "\n")  
(widget-create  'push-button
					 :tag "KH"
					 :value ""
					 :help-echo "visible or not"
					 :button-face  'pri-machines-blue-face
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-prover-not-works 
						   (if cansell-affiche-help
						       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-CACH")))
						     (progn    
						       (setq cansell-affiche-CACH (not cansell-affiche-CACH))
						       (cansell-affiche-balbulette-bis))))))
(widget-insert  " ")

  (widget-create  'push-button
           :tag "cl"
	  ;; :value n
	   :help-echo "remove all hypothesis from KH"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dl-CACH")))
			 (if cansell-affiche-nx () 	(progn 
				  (pri-prouveur-send-command "clk")
				  (pri-prouveur-send-command  "wx&ws"))
)))
	   )
)
(widget-insert  " ")
	  (widget-insert  " ------------------------------------- " )
 (widget-insert  (concat " (" (int-to-string (1- cansell-nb-CACH )) "/" (int-to-string (1- cansell-nb-CACH )) ") \n" )  )
(widget-setup)))


(eval-and-compile
(defun cansell-NO-other-hypos-widget-SEL ()
;; (widget-insert "\n[No] ")
 ;;      (setq Le-wid-cansell-number-selected-hypos-SEL  (widget-create 'editable-field
;;                 
;;                 :value (concat " " (int-to-string (1- cansell-number-selected-hypos-SEL ))) 
;;                 :size 2
;;		 :help-echo "A number of hypothesis please!"
;;                :action (lambda (widget &rest ignore)
;;			   (progn
;;			     (setq cansell-number-selected-hypos-SEL (+ 1 (string-to-int (widget-value widget))))
;;			     (setq 	cansell-hypos-selection-SEL cansell-hypos-selection-SELold)	
;;			     (cansell-affiche-balbulette-bis)

;;))))  (widget-insert "  ")	(widget-create  'push-button
;;					 :tag "vb"
;;					 :value ""
;;					 :help-echo "Visible or not"
;;					 :format  "%[[%t]%]"
;;					 :notify (lambda (widget &rest ignore) 
;;						 (progn    
;;						   (setq cansell-affiche-SEL (not cansell-affiche-SEL))
;;						   (cansell-affiche-balbulette-bis)))) 		     
;;(widget-setup)))
))


(eval-and-compile
(defun cansell-other-hypos-widget-RSH ()
 
 (widget-insert "\n")
(widget-create  'push-button
					 :tag "RS"
					 :value ""
					 :help-echo "visible or not"
					 :button-face  'pri-machines-blue-face
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-prover-not-works 
						   (if cansell-affiche-help
						       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-RSH")))
						     (progn    
						       (setq cansell-affiche-RSH (not cansell-affiche-RSH))
						       (cansell-affiche-balbulette-bis))))))
 
 (widget-insert  " ")
  	 (widget-create  'push-button
           :tag "++"
	   :value ""
	   :help-echo "Another hypothesis"
	   :button-face  'pri-machines-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-plus-minus")))
		       (progn
 			     (setq cansell-number-selected-hypos-RSH (+ 1 cansell-number-selected-hypos-RSH))
			     (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)	
			     (setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)
			     (cansell-affiche-balbulette-bis))

)))) 

 (widget-insert " ") 
(if (> cansell-number-selected-hypos-RSH 1)
 (progn
   	 (widget-create  'push-button
           :tag "--"
	   :value ""
	   :help-echo "Another hypothesis"
	   :button-face  'pri-machines-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-minus")))
		      				    (progn
				      (setq cansell-number-selected-hypos-RSH (1- cansell-number-selected-hypos-RSH))
				      (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)	
				      (setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)
				      (cansell-affiche-balbulette-bis))))))
(widget-insert  " " )
  	 (widget-create  'push-button
           :tag "nh"
	   :value ""
	   :help-echo "Next selected hypothesis"
	   :button-face  'pri-machines-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-nh")))
		       (progn
			 (setq  cansell-hypos-selection-RSH (cdr cansell-hypos-selection-RSHold)  )
			 (if cansell-hypos-selection-RSH () (setq cansell-hypos-selection-RSH cansell-first-cache-RSH))
				(setq 	cansell-hypos-selection-RSHold cansell-hypos-selection-RSH)
				(setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)
				(setq 	cansell-hypos-selection-SEL cansell-hypos-selection-SELold)	
				(cansell-affiche-balbulette-bis))
				
  ))))) 
 (widget-insert  "         " )
)

 

     
;; (widget-insert " ")     
 (widget-insert  "  ---------------------- " )
(widget-insert  (concat " (" (int-to-string (1-  cansell-number-selected-hypos-RSH )) "/" (int-to-string (1- cansell-nb-RSH )) ") \n" )  )
(widget-setup)
))

(eval-and-compile
(defun cansell-other-hypos-widget-CACH ()
  (widget-insert "\n")
(widget-create  'push-button
					 :tag "KH"
					 :value ""
					 :help-echo "visible or not"
					 :button-face  'pri-machines-blue-face
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-prover-not-works 
						   (if cansell-affiche-help
						       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-CACH")))
						     (progn    
						       (setq cansell-affiche-CACH (not cansell-affiche-CACH))
						       (cansell-affiche-balbulette-bis))))))
(widget-insert  " " )

  	 (widget-create  'push-button
           :tag "++"
	   :value ""
	   :help-echo "Another hypothesis"
	   :button-face  'pri-machines-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-plus-minus")))
		       (progn
 			     (setq cansell-number-selected-hypos-CACH (+ 1 cansell-number-selected-hypos-CACH))
			     (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)	
			     (setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)
			     (cansell-affiche-balbulette-bis))

))))   (widget-insert " ")
 (if (> cansell-number-selected-hypos-CACH 1)
  (progn
	 (widget-create  'push-button
           :tag "--"
	   :value ""
	   :help-echo "Another hypothesis"
	   :button-face  'pri-machines-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-minus")))
		       
				    (progn
				      (setq cansell-number-selected-hypos-CACH (1- cansell-number-selected-hypos-CACH))
				      (setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)	
				      (cansell-affiche-balbulette-bis))))))
(widget-insert  " " )
  	 (widget-create  'push-button
           :tag "nh"
	   :value ""
	   :help-echo "Next selected hypothesis"
	   :button-face  'pri-machines-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-nh")))
		       (progn
			   (setq  cansell-hypos-selection-CACH (cdr cansell-hypos-selection-CACHold)  )
			   (if cansell-hypos-selection-CACH () (setq cansell-hypos-selection-CACH cansell-first-cache-CACH))
			   (setq cansell-hypos-selection-CACHold cansell-hypos-selection-CACH)
			   (setq cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)
			   (setq cansell-hypos-selection-SEL cansell-hypos-selection-SELold)		
			   (cansell-affiche-balbulette-bis))
				
  ))) )) (widget-insert  "         " )
)

(widget-insert  " ")
  (widget-create  'push-button
           :tag "cl"
	   ;;:value n
	   :help-echo "remove all hypothesis from KH"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dl-CACH")))
			 (if cansell-affiche-nx () 	(progn 
				  (pri-prouveur-send-command "clk")
				  (pri-prouveur-send-command  "wx&ws"))
)))
	   )
)
	  (widget-insert  " -----------------------" ) (widget-insert  (concat "  (" (int-to-string (1-  cansell-number-selected-hypos-CACH )) "/" (int-to-string (1- cansell-nb-CACH )) ")\n " )  )
(widget-setup)
))

(eval-and-compile
(defun cansell-other-hypos-widget-SEL ()
  (widget-insert "\n")
  	 (widget-create  'push-button
           :tag "nh"
	   :value ""
	   :help-echo "Next selected hypothesis"
	   :button-face  'pri-machines-blue-face
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore)
		     (if  cansell-prover-not-works 
		     (if cansell-affiche-help
			 (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-nh")))
		       (progn
			 (setq  cansell-hypos-selection-SEL (cdr cansell-hypos-selection-SELold)  )
			 (if cansell-hypos-selection-SEL () (setq cansell-hypos-selection-SEL cansell-first-cache-SEL))
				(setq 	cansell-hypos-selection-SELold cansell-hypos-selection-SEL)
				(setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)
				(setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)	
				(cansell-affiche-balbulette-bis))
				
  )))) (widget-insert " ")
       (setq Le-wid-cansell-number-selected-hypos  (widget-create 'editable-field
                 
                 :value (concat " " (int-to-string (1- cansell-number-selected-hypos-SEL ))) 
                 :size 2
		 :help-echo "A number of hypothesis please!"
                 :action (lambda (widget &rest ignore)
			   (progn
			     (setq cansell-number-selected-hypos-SEL (+ 1 (string-to-int (widget-value widget))))
			     (setq 	cansell-hypos-selection-SEL cansell-hypos-selection-SELold)
				(setq 	cansell-hypos-selection-CACH cansell-hypos-selection-CACHold)
				(setq 	cansell-hypos-selection-RSH cansell-hypos-selection-RSHold)	
			     (cansell-affiche-balbulette-bis)))))
			     
 (widget-insert  "  ") (widget-create  'push-button
					 :tag "vb"
					 :value ""
					 :help-echo "Visible or not"
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						 (progn    
						   (setq cansell-affiche-SEL (not cansell-affiche-SEL))
						   (cansell-affiche-balbulette-bis)))) 

(widget-setup)
))

(eval-and-compile
(defun cansell-other-hypos-widget (m)
(if (= m 1) (cansell-other-hypos-widget-RSH)  
(if (= m 2)  (cansell-other-hypos-widget-CACH) 
  (cansell-other-hypos-widget-SEL))))
)

(eval-and-compile
(defun cansell-affiche-sel-loop(n m) 
  (cansell-affiche-sel-No n m)
  (cansell-other-hypos-widget m)
))

;;*****************************************************************************
;; FUNCTIONS
(eval-and-compile
(defun cansell-save-new-proof ()
        (interactive)
(set-buffer PRI-LOG)(end-of-buffer)
(widget-insert " ")
		     
		      	 (widget-create  'push-button
					 :tag "ns"
					 :value ""
					 :help-echo "No saving this new proof"
					 :button-face  'pri-machines-red-face
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-prover-not-works 
						   (if cansell-affiche-help
						       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-save-proof")))
						     (if cansell-affiche-nx ()  (progn (setq cansell-not-sv-nv  t ) (erase-buffer) (pri-atb-send-command  "No")
							    		   	   )))))) (widget-insert " ")
		      	 (widget-create  'push-button
					 :tag "sv"
					 :value ""
					 :button-face  'pri-machines-red-face
					 :help-echo "save this new proof"
					 :format  "%[[%t]%]"
					 :notify (lambda (widget &rest ignore) 
						   (if  cansell-prover-not-works 
						   (if cansell-affiche-help
						       (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-save-proof")))
						     (if cansell-affiche-nx ()  (progn   (setq cansell-not-sv-nv  t )  (pri-atb-send-command "Yes")
							   			   	   ))))))  
(widget-setup)
 (message "Not save (button [ns]) or save (button [sv])")
))




(eval-and-compile
(defun cansell-sg-SEL ()
(widget-insert "\n")
 (widget-create  'push-button
					 :tag "SL"
					 :value ""
					 :help-echo "Zoom or not"
					 :button-face  'pri-machines-blue-face
					 :format  "%t"
					 :notify (lambda (widget &rest ignore) 
						 (progn    
						   (setq cansell-affiche-SEL (not cansell-affiche-SEL))
						   (cansell-affiche-balbulette-bis)))) 

(widget-insert "\n ")
(if cansell-affiche-SEL
(progn
 (widget-insert "  ")
;; (widget-create  'push-button
;;					 :tag "!x."
;;					 :value ""
;;					 :help-echo "Forall hypothesis"
;;					 :format  "%[[%t]%]"
;;					 :notify (lambda (widget &rest ignore) 
;;						 (progn    
;;						   (pri-prouveur-send-command  "sh(!x.y)")
;;						   ))) (widget-insert " ") 
;; (widget-create  'push-button
;;					 :tag "e:s"
;;					 :value ""
;;					 :help-echo "Type hypothesis"
;;					 :format  "%[[%t]%]"
;;					 :notify (lambda (widget &rest ignore) 
;;						 (progn    
;;						   (pri-prouveur-send-command  "sh(x:y _or x<:y)")
;;						   ))) (widget-insert "\n") 

)(widget-insert "------------"))))

(eval-and-compile
(defun cansell-compense-rs (n)
(if (= n 0) ()
 (progn (insert "\n")( cansell-compense-rs (1- n)))
)))

(eval-and-compile
(defun cansell-affiche-balbulette ( cansell-val-a-remettre prfailed)

(pri-before-writting-buffer "pri-rs")
(erase-buffer )
(setq truncate-lines t)
  ;;pri-atelierb-B-mode)
cansell-nb-RSH 
;;(let ( (hauteur (window-height (get-buffer-window "pri-rs")) )
;;       (lignes (+ cansell-number-selected-hypos-RSH  cansell-number-selected-hypos-RSH 3)) )
;;(if (< lignes hauteur)
;;                      (progn  (cansell-compense-rs (+ 2 (- hauteur lignes))))))
				        (if cansell-first-cache-RSH 
					     (progn	
					        (if cansell-affiche-RSH 
						    (if (<  cansell-number-selected-hypos-RSH cansell-nb-RSH ) 
						   (cansell-affiche-sel-loop  cansell-number-selected-hypos-RSH 1)
						 (cansell-affiche-sel cansell-nb-RSH 1))				     
					       
					    (cansell-NO-RSH-hypos-widget))))
(pri-after-writting-buffer) 
;;(tester "???")

(if (not cansell-RS)
  (progn (pop-to-buffer  PRI-LOG nil cansell-proj-frame) (delete-other-windows))(set-buffer "pri-log") 
)
;;
			       		(pri-before-writting-buffer PRI-LOG)
(if cansell-exist-le-champs (widget-delete le-champ-editable)) 


;;(end-of-buffer)
(erase-buffer )
;;(setq DebPriLog (point))                  
;;(tester  cansell-Proof-Tree-diff)

 (widget-insert "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n")
				(setq  cansell-string-to-paste "")
				        (if cansell-first-cache-RSH 
					     (progn	
					        (if cansell-affiche-RSH 
						    (if (<  cansell-number-selected-hypos-RSH cansell-nb-RSH ) 
						   (cansell-affiche-sel-loop  cansell-number-selected-hypos-RSH 1)
						 (cansell-affiche-sel cansell-nb-RSH 1))				     
					       
					    (cansell-NO-RSH-hypos-widget))))

						(if cansell-first-cache-CACH 
						 (progn	
						   (if cansell-affiche-CACH 
						       (if (<  cansell-number-selected-hypos-CACH cansell-nb-CACH ) 
							   (cansell-affiche-sel-loop  cansell-number-selected-hypos-CACH 2)
							 (cansell-affiche-sel cansell-nb-CACH 2))
						         (cansell-NO-CACH-hypos-widget))))
					       ;; (insert (concat "\n\nCACH(" (int-to-string (1- cansell-nb-CACH)) ") --------------- \n"))));;(cansell-sg-CACH)

				         (if cansell-first-cache-SEL 
					     (progn
					       ;;(cansell-sg-SEL)
					       (if cansell-affiche-SEL
					       ;;(if (<  cansell-number-selected-hypos-SEL cansell-nb-SEL ) 
						;;   (cansell-affiche-sel-loop  cansell-number-selected-hypos-SEL 3)
						 (cansell-affiche-sel cansell-nb-SEL 3)
					        ) ;;(cansell-NO-other-hypos-widget 3))
(widget-insert  "\n")              
					      (widget-create  'push-button
							      :tag "SL"
							      :value ""
							      :help-echo "Visible or not"
							      :button-face  'pri-machines-blue-face
							      :format  "%[[%t]%]"
							      :notify (lambda (widget &rest ignore) 
									(if  cansell-prover-not-works 
									(if cansell-affiche-help
									    (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-SEL")))
									  (progn    
									    (setq cansell-affiche-SEL (not cansell-affiche-SEL))
									    (cansell-affiche-balbulette-bis))))))
(widget-insert  " ")
  (widget-create  'push-button
           :tag "cl"
	   ;;:value n
	   :help-echo "remove all hypothesis from SL"
	   :format  "%[[%t]%]"
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-dl-CACH")))
				 (if cansell-affiche-nx () (progn 
				  (pri-prouveur-send-command "cls")
				  (pri-prouveur-send-command  "wx&ws")
))))
	   )
)					(if cansell-affiche-SEL
					        (widget-insert  " --------------------------------------\n\n")
					(widget-insert  (concat " --------------------------------------  (" (int-to-string (1- cansell-nb-SEL))") \n\n" )))
					   )
(widget-insert "\n") )  

;;(widget-setup(insert (concat "\n\nSEL (" (int-to-string (1- cansell-nb-SEL)) ") --------------- \n\n")) ));; (cansell-sg-SEL))



				      ;;(cansell-prompt-pri)
				      ;;(end-of-buffer)

				     
	     (cansell-affiche-goal  cansell-The-Goal)
				     
				      		  (goto-char (point-max))		(widget-insert "\n")
				      ;;(insert cansell-le-message)

(if (and (= 0 pri-nb-unproved-pos) (string= (car cansell-The-Goal) " SUCCESS ") ) (progn (setq  cansell-val-a-remettre "BINGO")
;;(pop-to-buffer    "pri-errors" t  cansell-error-frame)  (delete-other-windows) (pri-before-writting-buffer  "pri-errors") (erase-buffer) (widget-insert "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n                          BINGO!") (font-lock-fontify-buffer)
;;(insert-file-contents (concat pri-balbulette-dir "/face.xpm"))  
(pri-after-writting-buffer)  ))
(if (not cansell-RS) (pop-to-buffer  PRI-LOG nil cansell-proj-frame))
				      (insert " GL  ------------------------------------------- \n")
				      (cansell-prompt-pri cansell-val-a-remettre) 
;;if cansell-succes 
(widget-insert "\n")
(pri-after-writting-buffer)
(cansell-add-bouton-ed) (widget-insert " ")
(if (= 0 pri-nb-unproved-pos)	()   (cansell-add-bouton-ne-pv))
(setq cansell-succes nil)
(if  cansell-not-sv-nv () (cansell-save-new-proof)) 
				     ;; (if (string= cansell-invariant "")
					;;  (insert  " \n\n")
				;;	(cansell-widget-invariant)
					;;)
;;(setq FinPriLog (point-max)) 
  (goto-char (point-max))
	;;(mark-end-of-buffer)
;;(goto-line (- (count-lines DebPriLog FinPriLog) 39))
;;( set-window-point pri-log-window(point)) 

;;(tester (window-point))
;;(recenter 10)			     			     ;; (goto-char LeDebEd)
 (goto-char (widget-field-start le-champ-editable)) 
 (insert cansell-val-a-remettre) (setq LaFinEd (point))
 	  ;;(end-of-buffer) 
;;(if  cansell-not-pri-log (progn  (setq cansell-not-pri-log nil)))
				      ;;(if cansell-affiche-message (insert cansell-le-message))
				    (if (search "%" cansell-le-message ) (message (replace-in-string cansell-le-message "%" "lamda "))(message cansell-le-message) )(setq  cansell-le-message "")
 ;;(if cansell-mouse-in-pri-log  (set-mouse-position pri-log-window LeCharPixelCol 55))
(garbage-collect)

 (if cansell-RS (if  cansell-not-sv-nv  (walk-windows  (function (lambda (w) (select-window w) (if (string= "pri-rs" (buffer-name (window-buffer)))  (progn 
                    (recenter -1))  (if (string= "pri-log" (buffer-name (window-buffer))) (set-buffer (window-buffer))(goto-char (point-max)) (goto-char (widget-field-start le-champ-editable)) 
 (insert cansell-val-a-remettre) (setq LaFinEd (point)))))) 'nomini)))


;;(scroll-down (min 0 (- (count-lines-buffer) (window-height) ))) 
(widget-setup)
))
;;(progn (beginning-of-buffer)(scroll-up (max 0 (+ (- (count-lines-buffer) (window-height) ) 3)  )))
(eval-and-compile
(defun cansell-affiche-balbulette-bis () 
 (interactive) (cansell-affiche-balbulette (widget-value le-champ-editable) "")(x-symbol-decode)
))
(eval-and-compile
(defun cansell-cons-CACH (l)
(if l
  (if (search "s" (car (cdr (car l))))
      (cansell-cons-CACH (cdr l))
    (cons (car l) (cansell-cons-CACH (cdr l)))
)
  nil)
))



(eval-and-compile
(defun cansell-cons-SEL (l)
(if l
  (if (search "s" (car (cdr (car l))))
      (cons (car l) (cansell-cons-SEL (cdr l)))
    (cansell-cons-SEL (cdr l))
)
  nil)))
(eval-and-compile
(defun  cansell-insert (mess)
(insert mess)(insert "\n")
))
(eval-and-compile
(defun  cansell-affiche-plus-moins-dans-pri-errors  (mess)
(if cansell-affiche-dans-errors  
 ;;(if  pri-error-list-window 
     (progn 
        (pop-to-buffer    "pri-errors" t  cansell-error-frame)  (delete-other-windows)
       (pri-before-writting-buffer  "pri-errors")  
       (if  cansell-erase-pri-errors  (progn  (setq cansell-erase-pri-errors nil) (erase-buffer)))
       ;;(set-window-point   pri-error-list-window (point-max "pri-errors")) 
       (goto-char (point-max))
      (if cansell-deja-plus-moins (progn (delete-backward-char 1)(cansell-insert mess))
       (cansell-insert (concat " \t" mess)))
       (setq cansell-deja-plus-moins t)
       ;;(setq titi (point-max "pri-errors")) 
       ;;(set-window-point   pri-error-list-window  titi) 
       (pri-after-writting-buffer) 
))))


(eval-and-compile
(defun  cansell-affiche-dans-pri-errors-sans-nl (mess)
(if cansell-affiche-dans-errors  
(if (string= " *" mess) ()
;; (if  pri-error-list-window 
     (progn 
        (pop-to-buffer    "pri-errors" t  cansell-error-frame)  (delete-other-windows)
       (pri-before-writting-buffer  "pri-errors")  
       (if  cansell-erase-pri-errors  (progn  (setq cansell-erase-pri-errors nil) (erase-buffer)))
       ;;(set-window-point   pri-error-list-window (point-max "pri-errors")) 
       (goto-char (point-max))
       (insert  mess)
       ;;(setq titi (point-max "pri-errors")) 
       ;;(set-window-point   pri-error-list-window  titi) 
       (pri-after-writting-buffer) 
)))))
(eval-and-compile
(defun  cansell-affiche-dans-pri-errors (mess)
(if cansell-affiche-dans-errors  
(if (string= " *" mess) ()
;; (if  pri-error-list-window 
     (progn 
       ;;(coucou mess)
        (pop-to-buffer    "pri-errors" t  cansell-error-frame)  (delete-other-windows)
       (pri-before-writting-buffer  "pri-errors")  
       (if  cansell-erase-pri-errors  (progn  (setq cansell-erase-pri-errors nil) (erase-buffer)))
       ;;(set-window-point   pri-error-list-window (point-max "pri-errors")) 
       (goto-char (point-max))
       (setq mess (replace-in-string mess "\n" "\n ")) 
       (cansell-insert (concat " " mess))
       ;;(setq titi (point-max "pri-errors")) 
       ;;(set-window-point   pri-error-list-window  titi) 
       (pri-after-writting-buffer) 
)))))
(eval-and-compile
(defun cansell-dec()

				  (setq cansell-succes nil) (setq cansell-SUCCES t) (if (= 0 pri-nb-unproved-pos)() (if cansell-decr-nb-Unpr (progn (setq  pri-nb-unproved-pos (1- pri-nb-unproved-pos)) (setq  cansell-decr-nb-Unpr nil))))
	;;(erase-buffer "pri-log")
			       (pri-prouveur-send-command "sw")

))


(eval-and-compile
(defun cansell-decale(n)
(if (= n 0) () (progn (insert "   ") (cansell-decale (1- n ))) 
    
)))

(eval-and-compile
(defun tester (l)
l
))

(eval-and-compile
(defun cansell-entre-deux-as()
  (if   cansell-proof-old-tree-pos
      (let ((cansell-val (car cansell-proof-old-tree-pos)))
	(if (string= "as" cansell-val)
           (progn (setq cansell-proof-old-tree-pos (cdr cansell-proof-old-tree-pos))
               nil
	       )
	(progn (setq cansell-proof-old-tree-pos (cdr cansell-proof-old-tree-pos))
	       (cons cansell-val (cansell-entre-deux-as)))
	))
    nil)
))

(eval-and-compile
(defun cansell-avance-dans-proof-tree (l)
  (if l
      (if   cansell-proof-old-tree-pos
      (let ((cansell-val (car cansell-proof-old-tree-pos)))
	(if (string= cansell-val (car l))
	(progn (setq cansell-proof-old-tree-pos (cdr cansell-proof-old-tree-pos))
	       (cansell-avance-dans-proof-tree (cdr l))
	       )))
      ))
))

(eval-and-compile
(defun cansell-encore-des-as(l)
  (if   l
      (if (string= "as" (car l))
           t
	(cansell-encore-des-as (cdr l)))
    nil
)))
(eval-and-compile
(defun cansell-min2-dec(i j)
  (if (< i j) i j)
))

(eval-and-compile
(defun cansell-min-dec(l)
  (if (cddr l)
      ( cansell-min2-dec (car l)   (cansell-min-dec (cddr l)))
    (car l)
)))

(eval-and-compile
(defun cansell-et (l)
(if l
(if (cdr l) 
  (concat (car l) "&" (cansell-et (cdr l)))

  (car l))
 ""
)))

(eval-and-compile
(defun cansell-pri-send-command-list-pt (l)

( pri-send-command (cansell-et l))
))

(eval-and-compile
(defun cansell-OPT-insert (c)
      (pri-before-writting-buffer  "pri-old-proof") 
      (insert c)
      (pri-after-writting-buffer) 
))

(eval-and-compile
(defun cansell-PT-insert (c k)
      (if k (pri-before-writting-buffer  "pri-proof-tree")  (pri-before-writting-buffer  "pri-old-proof") )
     (insert c)
      (pri-after-writting-buffer) 
))

(eval-and-compile
(defun cansell-construit-pour-paste (l1 l2)
  (if (eq l1 l2)
      (list (caddr (cdar l1)))
     (if   (= (caddar  l1) 1) (cons (caddr (cdar l1)) (cansell-construit-pour-paste (cdr l1) l2))
       (cansell-construit-pour-paste (cdr l1) l2)))
))
(eval-and-compile 
(defun  pri-send-command-mk (c)
( pri-send-command c)
(setq cansell-mouse-in-pri-log t) ;;( pri-send-command "gl")
))
(eval-and-compile 
(defun cansell-pri-send-command-list-mk (l)
(if (cdr l) 
 (progn
  ( pri-send-command (car l))
  (cansell-pri-send-command-list-mk (cdr l))
)
 (progn  (setq cansell-mouse-in-pri-log t) ( pri-send-command (car l))  )
)))

;;(eval-and-compile
;;(defun cansell-PT-apres-marque (n1 n2 l1 l2)
;;  (if (< n1 n2)
;;     (cansell-pri-send-command-list-mk (cansell-construit-pour-paste l1 l2))
;;  (cansell-pri-send-command-list-mk (cansell-construit-pour-paste l2 l1)))
;;))

(eval-and-compile
(defun cansell-PT-apres-marque (n1 n2 l1 l2)
  (if (< n1 n2)
     (cansell-construit-pour-paste l1 l2)
  (cansell-construit-pour-paste l2 l1))
))



(eval-and-compile
(defun cansell-PT-insert-boutons (l c n k)
 (if k
     (cansell-PROOF-TREE-insert-boutons l c n )
 (cansell-OLD-TREE-insert-boutons l c n )
)))


(eval-and-compile
(defun cansell-OLD-TREE-insert-boutons (l c n)
      (pri-before-writting-buffer  "pri-old-proof") 

    (if (= (caddar l) 4) 

	  (widget-insert "\n"))
(if (and (= (caddar l) 2) (not (cansell-teste-success c)))  ;; c'est un goal mais pas succeSS
(if (caar l) 
  (widget-create  'push-button
           :tag "zm"
	   ;;:value n
	   :help-echo "zoom or not zoom"
	   :button-face  'pri-machines-blue-bold-face
	   :format  "%[[%t]%]"
	   :laliste l
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ptzm")))
				  (progn 
				   (setq cansell-lca (car  (widget-get widget :laliste)))
				  (setcar cansell-lca (not (car cansell-lca)))	(cansell-affiche-OLD-TREE cansell-pour-aff-old-proof-tree)
)))))
 (widget-create  'push-button
           :tag "zm"
	   ;;:value n
	   :help-echo "zoom or not zoom"
	   :button-face  'pri-machines-red-bold-face
	   :format  "%[[%t]%]"
	   :laliste l
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ptzm")))
				  (progn 
				   (setq cansell-lca (car  (widget-get widget :laliste)))
				  (setcar cansell-lca (not (car cansell-lca)))	(cansell-affiche-OLD-TREE cansell-pour-aff-old-proof-tree)
))))))
(if (= (caddar l) 1) ;; c'est un cmd
    (if (eq l cansell-OPT-marque1)
	(widget-create  'push-button
           :tag "mk"
	   ;;:value n
	   :help-echo "mark to replay"
	   :button-face  'pri-machines-red-bold-face
	   :format  "%[[%t]%]"
	   :laliste l
	   :lamarque n
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ptmk")))
				(progn (setq  cansell-OPT-marque1 nil)  ( pri-send-command-mk (caddr (cdar (widget-get widget :laliste) ))) 
;;	(cansell-affiche-OLD-TREE cansell-pour-aff-old-proof-tree)
))
				   
				  
)))
	(widget-create  'push-button
           :tag "mk"
	   ;;:value n
	   :help-echo "mark to replay"
	   :format  "%[[%t]%]"
	   :laliste l
	   :lamarque n
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ptzm")))
				  (if cansell-OPT-marque1 
				      (progn (setq  cansell-PT-envoi (cansell-PT-apres-marque cansell-PT-mk-line (widget-get widget :lamarque) cansell-OPT-marque1 (widget-get widget :laliste)))(setq  cansell-PT-envoi-bis cansell-PT-envoi)(setq  cansell-OPT-marque1 nil)(setq cansell-PT-cmd (car  cansell-PT-envoi)) (setq cansell-PT-envoi (cdr  cansell-PT-envoi))(pri-prouveur-send-command cansell-PT-cmd))
				    (setq  cansell-OPT-marque1 (widget-get widget :laliste))(setq cansell-PT-mk-line (widget-get widget :lamarque))	(cansell-affiche-OLD-TREE cansell-pour-aff-old-proof-tree)
)))))))
				  
 (if (= (caddar l) 3)	(if cansell-not-aff-pos 
	    (progn
	      (widget-insert " => ")
	      ;;(cansell-decale-PT-insert l cansell-dec-po  "?" 0)
)
	  (widget-insert "\n"))
))
	   

(widget-setup)

(if (= (caddar l) 2) (if (cansell-teste-success c) (setq cansell-not-aff-pos nil)))
      (pri-after-writting-buffer) 
))


(eval-and-compile
(defun cansell-PROOF-TREE-insert-boutons (l c n )

      (pri-before-writting-buffer  "pri-proof-tree") 

    (if (= (caddar l) 4) 
(progn 
;;(setq cansell-long-PROOF-TREE (+ 2 cansell-long-PROOF-TREE)) 
	  (widget-insert "\n")))
(if (and (= (caddar l) 2) (not (cansell-teste-success c)))  ;; c'est un goal mais pas succeSS
(progn (setq cansell-long-PROOF-TREE (1+ cansell-long-PROOF-TREE)) 
(if (caar l) 
  (widget-create  'push-button
           :tag "zm"
	   ;;:value n
	   :help-echo "zoom or not zoom"
	   :button-face  'pri-machines-blue-bold-face
	   :format  "%[[%t]%]"
	   :laliste l
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ptzm")))
				  (progn 
				   (setq cansell-lca (car  (widget-get widget :laliste)))
				  (setcar cansell-lca (not (car cansell-lca)))	(cansell-affiche-PROOF-TREE cansell-pour-aff-proof-tree)
)))))
 (widget-create  'push-button
           :tag "zm"
	   ;;:value n
	   :help-echo "zoom or not zoom"
	   :button-face  'pri-machines-red-bold-face
	   :format  "%[[%t]%]"
	   :laliste l
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ptzm")))
				  (progn 
				   (setq cansell-lca (car  (widget-get widget :laliste)))
				  (setcar cansell-lca (not (car cansell-lca)))	(cansell-affiche-PROOF-TREE cansell-pour-aff-proof-tree)
))))))))
(if (= (caddar l) 1) ;; c'est un cmd
 (progn (setq cansell-long-PROOF-TREE (1+ cansell-long-PROOF-TREE)) 
   (if (eq l cansell-PT-marque1)
 (progn (setq  cansell-mk-PROOF-TREE cansell-long-PROOF-TREE) 
	(widget-create  'push-button
           :tag "mk"
	   ;;:value n
	   :help-echo "mark to replay"
	   :button-face  'pri-machines-red-bold-face
	   :format  "%[[%t]%]"
	   :laliste l
	   :lamarque n
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ptmk")))
				(progn (setq  cansell-PT-marque1 nil)  ( pri-send-command-mk (caddr (cdar (widget-get widget :laliste) ))) 		;;(cansell-affiche-PROOF-TREE cansell-pour-aff-proof-tree)
)))
				   
				  
)))
	(widget-create  'push-button
           :tag "mk"
	   ;;:value n
	   :help-echo "mark to replay"
	  ;; :button-face  'pri-machines-red-bold-face
	   :format  "%[[%t]%]"
	   :laliste l
	   :lamarque n
	   :notify (lambda (widget &rest ignore) 
		     (if cansell-prover-not-works
			      (if cansell-affiche-help
				  (progn (set-buffer "pri-help") (erase-buffer)(insert-file (concat pri-balbulette-dir "/pri-HELP/pri-help-ptzm")))
				  (if cansell-PT-marque1 
				      (progn (setq  cansell-PT-envoi (cansell-PT-apres-marque cansell-PT-mk-line (widget-get widget :lamarque) cansell-PT-marque1 (widget-get widget :laliste)))(setq  cansell-PT-envoi-bis cansell-PT-envoi) (setq  cansell-PT-marque1 nil)(setq cansell-PT-cmd (car  cansell-PT-envoi)) (setq cansell-PT-envoi (cdr  cansell-PT-envoi))(pri-prouveur-send-command cansell-PT-cmd))
				    (progn  
                                            (setq  cansell-PT-marque1 (widget-get widget :laliste))(setq cansell-PT-mk-line (widget-get widget :lamarque)))
	;;(widget-put  widget :button-face  pri-machines-red-face) (widget-setup)
(cansell-affiche-PROOF-TREE cansell-pour-aff-proof-tree)
))))))))
				  
 (if (= (caddar l) 3)(progn (setq cansell-long-PROOF-TREE (1+ cansell-long-PROOF-TREE)) 	(if cansell-not-aff-pos 
	    (progn
	      (widget-insert " => ")
	      ;;(cansell-decale-PT-insert l cansell-dec-po  "?" 0)
)
	  (widget-insert "\n"))
))
	   

(widget-setup)

(if (= (caddar l) 2) (if (cansell-teste-success c) (setq cansell-not-aff-pos nil)))
      (pri-after-writting-buffer) 
))


(eval-and-compile
(defun cansell-teste-success (c) (or (string= c "/*SUCCESS*/") (string= c "/*NO_SUCCESS*/"))))
 
(eval-and-compile
(defun cansell-PT-insert-info (l c k)
       (if k (pri-before-writting-buffer  "pri-proof-tree")  (pri-before-writting-buffer  "pri-old-proof")  )

    (if (= (caddar l) 3) (if cansell-not-aff-pos 
	    (progn
	      (setq cansell-not-aff-pos nil)(widget-insert " ?"))) (progn  (widget-insert " ") (widget-insert c)(widget-insert "\n")))
 
(widget-setup)
      (pri-after-writting-buffer) 
))


(eval-and-compile
(defun cansell-decale-OPT (n)
(if (= n 0) () (progn (cansell-OPT-insert "   ") (cansell-decale-OPT  (1- n ))) 
    
)))


(eval-and-compile
(defun cansell-decale-PT-insert (l n c b k)
(if (= n 0) (cansell-PT-insert-info l c k)  (progn (cansell-PT-insert "   " k) (cansell-decale-PT-insert l (1- n ) c b k)))
))


(eval-and-compile
(defun cansell-affiche-old (l)
(if l
	(progn  (cansell-decale-OPT  (car l) )   (cansell-OPT-insert  (cadr l))(cansell-OPT-insert "\n")
 (cansell-affiche-old  (cddr l))))
))

(eval-and-compile
(defun cansell-cherche-suivant-proof-tree-REC (l n)
 (if l 
   (if (> (cadar l) n)
       (cansell-cherche-suivant-proof-tree (cdr l) n)
     l)
   nil)
))
(eval-and-compile
(defun cansell-cherche-suivant-proof-tree (l n)
(while (and l  (> (cadar l) n))
(progn
 (setq l (cdr l))
))
l
))

;;(eval-and-compile
;;(defun  cansell-affiche-proof-tree-goal ( l n)
;;(if (= (caddar l) 2)
;;	(cansell-affiche-proof-tree (cansell-cherche-suivant-proof-tree (cdr l) n))
;;  (cansell-affiche-proof-tree (cansell-cherche-suivant-proof-tree  l n)))
;;))

(eval-and-compile
(defun cansell-affiche-proof-tree-RECONE (l n b)
(if l
  (if  (caar l) 
      (progn  (cansell-PT-insert-boutons l (caddr (cdar l)) n b)
	(cansell-decale-PT-insert l (cadar l) (caddr (cdar l)) n b) 
	(cansell-affiche-proof-tree (cdr l) (1+ n) b))
      (progn(cansell-PT-insert-boutons l (caddr (cdar l)) n b)
	(cansell-decale-PT-insert l (cadar l) (caddr (cdar l)) n b) 
	(cansell-affiche-proof-tree (cansell-cherche-suivant-proof-tree  (cdr l) (cadar l))(1+ n) b))))
))
(eval-and-compile
(defun cansell-affiche-proof-tree (l n b)
(while l 
            (progn
	      (cansell-PT-insert-boutons l (caddr (cdar l)) n b)
	      (cansell-decale-PT-insert l (cadar l) (caddr (cdar l)) n b)
              (setq n (1+ n))
	      (if  (caar l) 
                 (setq l (cdr l))
		(setq l (cansell-cherche-suivant-proof-tree  (cdr l) (cadar l)))
)))
))

(eval-and-compile
(defun cansell-cherche-premier-commentair (l)
(if l
   (if (= (caddar l) 2)
     (caddr (cdar l))
     (cansell-cherche-premier-commentair (cdr l)))
   "coucou"
)))

(eval-and-compile
(defun cansell-affiche-PROOF-TREE (l)
(setq cansell-long-PROOF-TREE 0)
  (pri-before-writting-buffer PRI-PROOF-TREE) 
 (erase-buffer  PRI-PROOF-TREE)(pri-after-writting-buffer)
  (cansell-affiche-proof-tree l 1 t)(setq cansell-not-aff-pos  t)
  (pri-before-writting-buffer PRI-PROOF-TREE) (font-lock-fontify-buffer) (x-symbol-decode)
;;(scroll-up   (max 0 (- (- (length l) (window-height (frame-selected-window cansell-error-frame)) ) 3)))) (pri-after-writting-buffer) 
  ;;(scroll-other-window (max 0 (- (- (length l) (window-height (frame-selected-window cansell-error-frame)) ) 3)))
))


(eval-and-compile
(defun cansell-affiche-OLD-TREE (l)
(setq cansell-long-OLD-TREE 0)
  (pri-before-writting-buffer PRI-OLD-PROOF)
  (erase-buffer  PRI-OLD-PROOF)(pri-after-writting-buffer)
  (cansell-affiche-proof-tree l 1 nil)(setq cansell-not-aff-pos  t)
  (pri-before-writting-buffer PRI-OLD-PROOF) (font-lock-fontify-buffer) (x-symbol-decode)(pri-after-writting-buffer)
))

(eval-and-compile
(defun cansell-affiche-old-avec-marque-as (l n)
 (if l (if (= n 1)
    (if (string= (cadr l) "as")
	(progn (cansell-OPT-insert" =>") (cansell-decale-OPT  (1- (car l) )) (cansell-OPT-insert "as\n")   
	       (cansell-affiche-old  (cddr l)))

      (progn  (cansell-decale-OPT  (car l) )   (cansell-OPT-insert  (cadr l))(cansell-OPT-insert "\n")
	      (cansell-affiche-old-avec-marque-as   (cddr l) 1)))
    (if (string= (cadr l) "as")
	(progn  (cansell-decale-OPT  (car l) )   (cansell-OPT-insert "as\n") 
	        (cansell-affiche-old-avec-marque-as   (cddr l) (1- n)))

	(progn  (cansell-decale-OPT  (car l) )   (cansell-OPT-insert  (cadr l))(cansell-OPT-insert "\n")
	        (cansell-affiche-old-avec-marque-as   (cddr l) n)))))      
))

(eval-and-compile
(defun cansell-cmd-to-1 (c)
 (cond
   ((string= "cmd" c) 1)
   ((string= "gol" c) 2)                          
   ((string= "shf" c) 3) 
   ((string= "wtg" c) 4)
)) )
(eval-and-compile
(defun  cansell-change-pasencore (l1 l a n)
 (if (string= (car l1) a)
       (setcar l n)
     (cansell-change-pasencore (cdr l1)  (cdr l) a n))))

(eval-and-compile
(defun  cansell-in (a l)
  (if l
     (if (string= a (car l)) 
          t
        (cansell-in a (cdr l)))
     nil)))


(eval-and-compile
(defun  cansell-diff (l1 l2)
  (if l1
      (if l2 
          (if (string= (car l1) (car l2))
	  (cansell-diff (cdr l1) (cdr l2))
	   (cons (car l2) (cansell-diff l1 (cdr l2))))
       l1)
     l2)
))

(eval-and-compile
(defun  affff (l)
  (if l
     (progn (insert (car l)) (insert "  ") (affff (cdr l))
))))

(eval-and-compile
(defun  cansell-change-stat  (l s n o c)
(coucou l)
(coucou s)
(coucou c)
(coucou n)

(if (string= (car l) c)
     (setcar (cdr s) (cons o n))
  (cansell-change-stat (cdr l) (cdr (cdr s))  n o c)
) 
))

(eval-and-compile
(defun  load-all-compo ()
(if cansell-load-compo (progn (setq cansell-load-compo nil)(cansell-load-all-source-buffer cansell-list-pour-ed )))
))
(eval-and-compile
(defun pri-traiter (message) 
;; (pri-trace (format "%s %s \n" 'pri-traiter message  ))
;; (pri-trace (format "%s   \n" cansell-mach-list))
;; (pri-trace (format "%s %s  \n"  cansell-affiche-dans-errors  cansell-pr-affiche-plus-moins))
;; (cansell-affiche-dans-pri-errors message)
  (setq pri-memory nil)
  (let (parsed-string cod index line )
	(setq parsed-string (pri-split-string message "##"))
	(setq cod (car parsed-string))
	(setq index (car (cdr parsed-string)))
	(setq line (car (cddr parsed-string)))

	(if line
		(progn
               ;; (setq line   (replace-in-string line ": " ":"))
		 ;;  (coucou index)
(setq index (string-to-int index))
                 ;; (coucou index)
        (if (string= cod "POG")
	      (if (= index 6)
                  (progn(setq cansell-pog-affiche-entete t)(setq cansell-pog-entete (replace-in-string  (replace-in-string line "\\[\".*\"\]@@" "") "\\\\n" "\n")))
		  (if (= index  8) 
                 (if cansell-pog-affiche-entete 
                   (progn (setq cansell-pog-affiche-entete nil)(setq cansell-pog-affiche-point t)(cansell-affiche-dans-pri-errors-sans-nl cansell-pog-entete)(cansell-affiche-dans-pri-errors-sans-nl " ."))
                   (progn (setq cansell-pog-affiche-point t)(cansell-affiche-dans-pri-errors-sans-nl ".")))
		(if (or (= index  9)(= index  3)(= index  10)(= index  16)) (if (= index  16)(cansell-affiche-dans-pri-errors "") )  (progn(if (= index  14)(cansell-affiche-dans-pri-errors "") )
		  (setq line(replace-in-string  (replace-in-string line "\\[\".*\"\]@@" "") "\\\\n" "\n"))
		  (if cansell-pog-affiche-point 
		      (progn (setq cansell-pog-affiche-point nil)(cansell-affiche-dans-pri-errors (concat  line)))
		    (if (or (= index  17)(= index  24)(= index  21))(progn (if (= index  21)(cansell-affiche-dans-pri-errors-sans-nl " ") )(setq line(replace-in-string line  "\n" " "))  (cansell-affiche-dans-pri-errors-sans-nl line)) (cansell-affiche-dans-pri-errors line)))
		  ;;(if (= index 6) (cansell-affiche-dans-pri-errors-sans-nl "        "))
	       )
	      )))
		  (cond
		   ;;cas des messages non formates
		   ((= -1 index)

		      (if cansell-goal 
			 (progn
			   (setq cansell-traite-le-goal t)
			   (setq cansell-The-Goal nil)
			   (setq cansell-affiche-wid-goal t)
			   ;;(beginning-of-line)
			   ;;(kill-line)
			   ;;(pri-log-print " ______________ \n")
			  
			   (if (search "$=>$" line) (setq cansell-goal-imply t) (setq cansell-goal-imply nil))
			   (setq cansell-goal nil) (setq cansell-know-goal t)

			   (cond

			   ((search "$or$" line)  

				(setq cansell-goal-natu "or"))
			   
			   
			   ((search "$nt$" line)  

				(setq cansell-goal-natu "nt"))


			   ((search "$!$" line)   

				(setq cansell-goal-natu "!"))


			   ((search "$#$" line)   

				(setq cansell-goal-natu "#"))

			   ((search "$:$" line)   

				(setq cansell-goal-natu ":"))

			   ((search "$eq$" line)   

				(setq cansell-goal-natu "eq"))			   (t

				(setq cansell-goal-natu "o")			   ))
			    (if (search "$<+$" line) (setq cansell-goal-natu (concat cansell-goal-natu "<+" )))
			    (if (search "$<:$" line) (setq cansell-goal-natu (concat cansell-goal-natu "<<" )))
                            (if (search "$nd$" line) (setq cansell-goal-natu (concat cansell-goal-natu "nd" )))
			    (if (search "$rx$" line)  (setq cansell-goal-natu (concat cansell-goal-natu "rx" )))
			    (if (search "$bg$" line)  (setq cansell-beginner nil))
			    (if (search "$xp$" line)  (setq cansell-beginner t))

)
			(if (get-buffer pri-output-buffer)
				(progn
				  (set-buffer pri-output-buffer)
				 ;; (pri-end-of-buffer)
)))
			(cond
			 ((string= pri-output-buffer PRI-PROOF-TREE)
			  (pri-before-writting-buffer PRI-PROOF-TREE)

		          (setq cansell-cgdecinfo (pri-split-string line "\\$\\$"))
			  
			  (let ((cansell-cg (car cansell-cgdecinfo))  (cansell-dec(cadr cansell-cgdecinfo)) (cansell-info (caddr cansell-cgdecinfo)))
		 ;;(if (string= "wtg" cansell-cg) (insert "\n"))	    
			;;  (cansell-decale (string-to-int cansell-dec))
			 
			  ;; (if (string= "shf" cansell-cg)  ()(progn (insert cansell-info)  (insert "\n")))
                          (if cansell-test-ba  (progn  (setq cansell-test-ba nil) (setq cansell-dec-ba  (string-to-int cansell-dec)))) 

                          (if (string= "cmd" cansell-cg) 
			      (progn 
				(if cansell-proof-tree 
				    (progn
				      (setcdr cansell-proof-tree-end (cons  cansell-info nil))
				      (setq cansell-proof-tree-end (cdr cansell-proof-tree-end))
				      
)

				  (progn 
				    (setq cansell-proof-tree-end (cons  cansell-info nil))
				    (setq cansell-proof-tree  cansell-proof-tree-end)
				    
))
				))

                      (if  cansell-pour-aff-proof-tree-old 
			(progn 
			  (if (and 
			     (= (string-to-int cansell-dec)(cadar  cansell-pour-aff-proof-tree-old))
			     (string= cansell-info (caddr (cdar  cansell-pour-aff-proof-tree-old))))
			    (setq  cansell-pour-aff-proof-tree-old (cdr  cansell-pour-aff-proof-tree-old))
			  (progn
			    (setq cansell-pour-aff-proof-tree-end cansell-pour-aff-proof-tree-old)
			    (setcdr cansell-pour-aff-proof-tree-end nil)
			    (setcar cansell-pour-aff-proof-tree-end (list t  (string-to-int cansell-dec)   (cansell-cmd-to-1 cansell-cg) cansell-info))
			    (setq  cansell-pour-aff-proof-tree-old nil))))

				(if  cansell-pour-aff-proof-tree
				    (progn
				      (setcdr cansell-pour-aff-proof-tree-end  (list (list t  (string-to-int cansell-dec)    (cansell-cmd-to-1 cansell-cg) cansell-info)))
				      (setq cansell-pour-aff-proof-tree-end  (cdr cansell-pour-aff-proof-tree-end))  
)

				  (progn 
				    (setq cansell-pour-aff-proof-tree-end  (list (list t  (string-to-int cansell-dec)   (cansell-cmd-to-1 cansell-cg) cansell-info)))
				    (setq cansell-pour-aff-proof-tree  cansell-pour-aff-proof-tree-end)
))
				
                          
)
 
			   (if (string= "shf" cansell-cg)
			       (setq cansell-dec-po  (string-to-int cansell-dec)) 
			     (if (string= "wtg" cansell-cg) ()
				 (if cansell-Proof-Tree 
				     (progn 
				       (if cansell-Proof-Tree-diff ()
					 (progn
					   (if cansell-Proof-Tree-Old 
					 (if (and (= (car cansell-Proof-Tree-Old)(string-to-int cansell-dec))(string= (cadr cansell-Proof-Tree-Old) cansell-info))
					     (setq cansell-Proof-Tree-Old (cddr cansell-Proof-Tree-Old))
					   (setq cansell-Proof-Tree-diff cansell-Proof-Tree-end)) 
				       (progn (setq cansell-Proof-Tree-diff cansell-Proof-Tree-end) (if cansell-ba (setq cansell-test-ba t)))))) 

				       (setcdr cansell-Proof-Tree-end (cons (string-to-int cansell-dec) (cons  cansell-info nil)))(setq cansell-Proof-Tree-end (cddr cansell-Proof-Tree-end)))
				   (progn
				     (setq cansell-Proof-Tree-end (cons (string-to-int cansell-dec) (cons  cansell-info nil)))
				     (setq cansell-Proof-Tree  cansell-Proof-Tree-end)
				      (setq cansell-Proof-Tree-end (cdr  cansell-Proof-Tree-end))
				     (if cansell-Proof-Tree-diff ()
				       (progn
					  ;; (tester cansell-Proof-Tree-Old)(tester (car cansell-Proof-Tree-Old))(tester cansell-dec)
					   ;; (tester (cadr cansell-Proof-Tree-Old))(tester  cansell-info)
					   
					   (if cansell-Proof-Tree-Old 
					 (if (and (= (car cansell-Proof-Tree-Old)(string-to-int cansell-dec))(string= (cadr cansell-Proof-Tree-Old) cansell-info))
					     (setq cansell-Proof-Tree-Old (cddr cansell-Proof-Tree-Old))
					 (progn (setq cansell-res-diff nil) (setq cansell-Proof-Tree-diff cansell-Proof-Tree))) 
				     (progn (setq cansell-res-diff nil) (setq cansell-Proof-Tree-diff cansell-Proof-Tree)))) )
))
			       )
)

			  

			  (if (string= cansell-info "as") (setq cansell-pas-faux-succes nil)))



			  (pri-after-writting-buffer))

			 ((string= pri-output-buffer PRI-OLD-PROOF)
			  (pri-before-writting-buffer PRI-OLD-PROOF)
			
			 (if (search "$$" line)
			  (progn
                          (setq cansell-cgdecinfo (pri-split-string line "\\$\\$"))

			  (let ((cansell-cg (car cansell-cgdecinfo))  (cansell-dec(cadr cansell-cgdecinfo)) (cansell-info (caddr cansell-cgdecinfo)))		;; (if (string= "wtg" cansell-cg) (insert "\n"))	    
;;			    (cansell-decale (string-to-int cansell-dec))
			    (if  cansell-old-proof-pour-as 
				(progn (setcdr cansell-old-proof-pour-as-end (cons (string-to-int cansell-dec) (cons cansell-info nil))) 
				       (setq cansell-old-proof-pour-as-end (cddr cansell-old-proof-pour-as-end)))
			      (progn (setq cansell-old-proof-pour-as (cons (string-to-int cansell-dec) (cons cansell-info nil))) 
(setq cansell-old-proof-pour-as-end  (cdr cansell-old-proof-pour-as))))

;;(tester cansell-old-proof-pour-as) 
			  ;;(insert cansell-info)  (insert "\n")
                          (if (string= "cmd" cansell-cg) 
			      (progn 
				(if cansell-proof-old-tree 
				   (progn  (setcdr cansell-proof-old-tree-end (cons  cansell-info nil))(setq cansell-proof-old-tree-end (cdr cansell-proof-old-tree-end)))

				  (progn 
				    (setq cansell-proof-old-tree-end (cons  cansell-info nil))
				    (setq cansell-proof-old-tree  cansell-proof-old-tree-end)
				    (setq cansell-proof-old-tree-pos  cansell-proof-old-tree-end)))
))

                      (if  cansell-pour-aff-old-proof-tree-old 
			(progn 
			  (if (and 
			     (= (string-to-int cansell-dec)(cadar  cansell-pour-aff-old-proof-tree-old))
			     (string= cansell-info (caddr (cdar  cansell-pour-aff-old-proof-tree-old))))
			    (setq  cansell-pour-aff-old-proof-tree-old (cdr  cansell-pour-aff-old-proof-tree-old))
			  (progn
			    (setq cansell-pour-aff-old-proof-tree-end cansell-pour-aff-old-proof-tree-old)
			    (setcdr cansell-pour-aff-old-proof-tree-end nil)
			    (setcar cansell-pour-aff-old-proof-tree-end (list t  (string-to-int cansell-dec)   (cansell-cmd-to-1 cansell-cg) cansell-info))
			    (setq  cansell-pour-aff-old-proof-tree-old nil))))

				(if  cansell-pour-aff-old-proof-tree
				    (progn
				      (setcdr cansell-pour-aff-old-proof-tree-end  (list (list t  (string-to-int cansell-dec)    (cansell-cmd-to-1 cansell-cg) cansell-info)))
				      (setq cansell-pour-aff-old-proof-tree-end  (cdr cansell-pour-aff-old-proof-tree-end))  
)

				  (progn 
				    (setq cansell-pour-aff-old-proof-tree-end  (list (list t  (string-to-int cansell-dec)   (cansell-cmd-to-1 cansell-cg) cansell-info)))
				    (setq cansell-pour-aff-old-proof-tree  cansell-pour-aff-old-proof-tree-end)
))
				
                          
)


)
)
(insert (replace-in-string line "^        " "")"\n"))
			  (pri-after-writting-buffer))

			 ((string= pri-output-buffer PRI-HYPOTHESIS)
;;			  (if pri-hypothesis-buffer-p
;;				  (progn
;;					(pri-before-writting-buffer PRI-HYPOTHESIS)
;;					(pri-add-hypothese line)
;;					(pri-after-writting-buffer)))
)

			 ((string= pri-output-buffer PRI-LOG)

			    (if cansell-message 
				(progn
                                  (if  (or (string= " " line) (string= "" line)) () (setq cansell-le-message line))))
				
			     (if (and cansell-hypo (search (cansell-string-nb cansell-nb) line))
                                   (progn
				        (pri-before-writting-buffer PRI-LOG)
					(if (>= cansell-nb 2)
					    (if (=  cansell-nb 2)
						(progn 
						  (setq cansell-end-cache (cons  (cons 1 (cons cansell-hypo-nature (cons cansell-deb-hypo (cons  cansell-end-first-hypo nil )))) nil))
						  (setq cansell-first-cache cansell-end-cache))
						(progn 
						  (setcdr cansell-end-cache (cons (cons (- cansell-nb 1) (cons cansell-hypo-nature (cons cansell-deb-hypo (cons cansell-end-first-hypo nil)))) nil))
						  (setq cansell-end-cache (cdr cansell-end-cache)))))
					  
					
 				        (setq cansell-new-line (replace-in-string line (cansell-string-nb cansell-nb)  ""))


					(if (search "$<+$" cansell-new-line) 
					     (progn
					       (setq cansell-hypo-nature "<+")
					       (setq cansell-new-line (replace-in-string cansell-new-line "\\$<\\+\\$" "")))
					     (setq cansell-hypo-nature ""))

					(if (search "$<:$" cansell-new-line) 
					     (progn
					       (setq cansell-hypo-nature (concat "<<"  cansell-hypo-nature))
					       (setq cansell-new-line (replace-in-string cansell-new-line "\\$<:\\$" ""))))
					(if (search "$:$" cansell-new-line) 
					     (progn
					       (setq cansell-hypo-nature (concat ":"  cansell-hypo-nature))
					       (setq cansell-new-line (replace-in-string cansell-new-line "\\$:\\$" ""))))
					(cond


					    ( (search "$=>$$select$" cansell-new-line) 
					     ;;(cansell-add-hypothese-imply 
					      ;;(replace-in-string   cansell-new-line "\\$=>\\$" "") 
					      ;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "s=>"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$=>\\$\\$select\\$" ""))
					     (setq cansell-end-first-hypo nil)
					     )

					    ((search "$or$$select$" cansell-new-line) 
					     ;;(cansell-add-hypothese-or 
					       ;; (replace-in-string  cansell-new-line "\\$or\\$" "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "sor"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$or\\$\\$select\\$" ""))
					     (setq cansell-end-first-hypo nil)
					     )
 
					    ((search "$=$ $select$" cansell-new-line) 
					     ;;(cansell-add-hypothese-equals 
					      ;;  (replace-in-string   cansell-new-line "\\$=\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature  "s="))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$=\\$ \\$select\\$" ""))
					     (setq cansell-end-first-hypo nil)
					    )

					    ((search "$nt$$select$" cansell-new-line) 
					     ;;(cansell-add-hypothese-not 
					       ;; (replace-in-string   cansell-new-line "\\$nt\\$" "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "snt"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$nt\\$\\$select\\$" ""))
					     (setq cansell-end-first-hypo nil)
					    )

					    ((search "$!$ $select$" cansell-new-line) 
					     ;;(cansell-add-hypothese-forall 
					       ;; (replace-in-string   cansell-new-line "\\$!\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "s!"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$!\\$ \\$select\\$" ""))
					     (setq cansell-end-first-hypo nil)
					    )

					    ((search "$#$ $select$" cansell-new-line) 
					     ;;(cansell-add-hypothese-exists 
					       ;; (replace-in-string   cansell-new-line "\\$#\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "s#"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$#\\$ \\$select\\$" ""))
					     (setq cansell-end-first-hypo nil)
					    )

					    ((search "$:$ $select$" cansell-new-line) 
					     ;;(cansell-add-hypothese-in 
					      ;;  (replace-in-string   cansell-new-line "\\$:\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$:\\$ \\$select\\$" ""))
					     (setq cansell-end-first-hypo nil)
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "s:"))
					    )

					    ((search "$eq$ $select$" cansell-new-line) 
					     ;;(cansell-add-hypothese-in 
					      ;;  (replace-in-string   cansell-new-line "\\$:\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$eq\\$ \\$select\\$" ""))
					     (setq cansell-end-first-hypo nil)
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "seq"))
					    )
					    ((search "$select$" cansell-new-line) 
					     	   ;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "sother"))
					     (setq cansell-deb-hypo  (replace-in-string   cansell-new-line " *\\$select\\$" ""))
					     (setq cansell-end-first-hypo  nil))

					    ( (search "$=>$" cansell-new-line) 
					     ;;(cansell-add-hypothese-imply 
					      ;;(replace-in-string   cansell-new-line "\\$=>\\$" "") 
					      ;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "=>"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$=>\\$" ""))
					     (setq cansell-end-first-hypo nil)
					     )

					    ((search "$or$" cansell-new-line) 
					     ;;(cansell-add-hypothese-or 
					       ;; (replace-in-string  cansell-new-line "\\$or\\$" "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "or"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$or\\$" ""))
					     (setq cansell-end-first-hypo nil)
					     )
 
					    ((search "$=$ " cansell-new-line) 
					     ;;(cansell-add-hypothese-equals 
					      ;;  (replace-in-string   cansell-new-line "\\$=\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "="))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$=\\$" ""))
					     (setq cansell-end-first-hypo nil)
					    )

					    ((search "$nt$" cansell-new-line) 
					     ;;(cansell-add-hypothese-not 
					       ;; (replace-in-string   cansell-new-line "\\$nt\\$" "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "nt"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$nt\\$" ""))
					     (setq cansell-end-first-hypo nil)
					    )

					    ((search "$!$ " cansell-new-line) 
					     ;;(cansell-add-hypothese-forall 
					       ;; (replace-in-string   cansell-new-line "\\$!\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "!"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$!\\$" ""))
					     (setq cansell-end-first-hypo nil)
					    )

					    ((search "$#$ " cansell-new-line) 
					     ;;(cansell-add-hypothese-exists 
					       ;; (replace-in-string   cansell-new-line "\\$#\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "#"))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$#\\$" ""))
					     (setq cansell-end-first-hypo nil)
					    )

					    ((search "$:$ " cansell-new-line) 
					     ;;(cansell-add-hypothese-in 
					      ;;  (replace-in-string   cansell-new-line "\\$:\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$:\\$" ""))
					     (setq cansell-end-first-hypo nil)
					     (setq cansell-hypo-nature (concat cansell-hypo-nature ":"))
					    )

					    ((search "$eq$ " cansell-new-line) 
					     ;;(cansell-add-hypothese-in 
					      ;;  (replace-in-string   cansell-new-line "\\$:\\$ " "") 
						;;(cansell-string-nb cansell-nb))
					     (setq cansell-deb-hypo (replace-in-string   cansell-new-line "\\$eq\\$" ""))
					     (setq cansell-end-first-hypo nil)
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "eq"))
					    )
					     ( t 
					          ;;(cansell-add-hypothese  
						  ;; cansell-new-line 
						   ;;(cansell-string-nb cansell-nb))
					     (setq cansell-hypo-nature (concat cansell-hypo-nature "other"))
					     (setq cansell-deb-hypo  cansell-new-line)
					     (setq cansell-end-first-hypo  nil))
					    )


					;;(pri-after-writting-buffer)
					(setq cansell-nb (+ 1 cansell-nb)))
				   
			     (if  (or (string= " " line) (string= "" line))
				  ()
			          (progn 
				    (if cansell-hypo (setq cansell-end-first-hypo (cons line cansell-end-first-hypo))) ;;(pri-log-print (concat "  " line "\n"))
))))

			 ((string= pri-output-buffer PRI-GOAL)
			  (if cansell-know-goal
				  (progn 
					 (setq cansell-know-goal nil))
			  (let* ((pri-goal (replace-in-string line "        " "" )))
				;;(pri-before-writting-buffer PRI-GOAL)
				;;(insert (concat pri-goal "\n"))
				;;(pri-after-writting-buffer)
				(if  (or (string= " SUCCESS " pri-goal)(string= " NO_SUCCESS " pri-goal) ) (progn(if  cansell-SUCCES (setq cansell-SUCCES nil)(setq cansell-succes t))))
										       (if (and (search "Check that the invariant (" pri-goal ) (search ") is preserved by the operation - ref " pri-goal ))
							  (progn
							     (string-match "Check that the invariant (" pri-goal ) 
							     (setq deb (match-end 0))
							     (string-match ") is preserved by the operation - ref " pri-goal )
							     (setq cansell-invariant (substring pri-goal deb (match-beginning 0 )))))
				(if (and cansell-goal-imply (search  "=>" pri-goal) (= (string-match  "=>" pri-goal ) 0)) 
				    (progn 									  
				      
				      (setq cansell-affiche-wid-goal t)
				      (setq cansell-The-Goal nil))
				      (if cansell-affiche-wid-goal 
					  (progn 

                                            (if  (or (string= " " pri-goal) (string= "\n" pri-goal) (string= "" pri-goal))
						()
					      (progn 
						(setq cansell-The-Goal (cons pri-goal cansell-The-Goal)

)))
))))))))
		   ((< index 12)
	      (if (= index  8) 
                 (progn (setq cansell-pr-affiche-plus-moins t)(cansell-affiche-dans-pri-errors-sans-nl "-"))
		(if (= index  7) 
		    (progn (setq cansell-pr-affiche-plus-moins t)(cansell-affiche-dans-pri-errors-sans-nl "+"))
		  (progn
                    
		    (setq line (replace-in-string  (replace-in-string line "\\[\".*\"\\]@@" "") "\\\\n" "\n"))
		    (if (<= index  5) () (if cansell-pr-affiche-plus-moins
			(progn (setq cansell-pr-affiche-plus-moins nil)(cansell-affiche-dans-pri-errors (concat "\n" line)))
		       (cansell-affiche-dans-pri-errors line)))
		    (if (= index 6) (cansell-affiche-dans-pri-errors-sans-nl "        "))                
(if (= index  3) 
                  (progn (setq cansell-le-message "End of Proof")(message cansell-le-message)(cansell-affiche-dans-pri-errors "") (setq cansell-pas-fini-les-interrupt nil)))
	       )
	      )))
		   ;;reception de l'arbre de preuve
		   ((= PRI-PRV-II-M5-1 index)
                     (setq pri-output-buffer PRI-PROOF-TREE)
                    (if cansell-pour-aff-proof-tree
                     (setq cansell-pour-aff-proof-tree-old cansell-pour-aff-proof-tree)(setq cansell-pour-aff-proof-tree-old nil))
                     ;;(setq cansell-pour-aff-proof-tree nil)
                     ;;(setq cansell-pour-aff-proof-tree-end nil)
			(setq cansell-proof-tree nil) (setq cansell-proof-tree-end nil) (setq cansell-Proof-Tree-Old  cansell-Proof-Tree)(setq cansell-Proof-Tree nil) (setq cansell-Proof-Tree-end nil)(setq cansell-Proof-Tree-diff nil)(setq cansell-pas-faux-succes t)(setq cansell-res-diff t)
)
		   
		   ;;ancienne preuve
		   ((= PRI-PRV-II-M6-1 index)
			(setq  pri-output-buffer PRI-OLD-PROOF)
		                    (if cansell-pour-aff-old-proof-tree
                     (setq cansell-pour-aff-old-proof-tree-old cansell-pour-aff-old-proof-tree)(setq cansell-pour-aff-old-proof-tree-old nil))
                        (setq cansell-proof-old-tree nil) (setq cansell-proof-old-tree-end nil)(setq cansell-proof-old-tree-pos nil) (setq cansell-old-proof-pour-as nil)(setq cansell-old-proof-pour-as-end nil)
     )
		   
		   ;;reception des hypotheses
		   ((= PRI-PRV-II-M7-1 index)
			(setq pri-output-buffer PRI-HYPOTHESIS)
;;			(if (get-buffer PRI-HYPOTHESIS)
;;				(progn
;;				  (pri-reset-hypothesis-list)
;;				  (pri-before-writting-buffer PRI-HYPOTHESIS)
;;				  (erase-buffer pri-output-buffer)
;;
;;				  (pri-after-writting-buffer))
;;))
)
		   
		   ;;reception du but
		   ((= PRI-PRV-II-M8-1 index)
			(setq pri-output-buffer PRI-GOAL)
			;;(pri-before-writting-buffer PRI-GOAL)
			;;(erase-buffer pri-output-buffer)
			;;(pri-after-writting-buffer)
			(setq cansell-goal t)
			;;(setq cansell-list-goal nil)
			;;(pri-log-print "goal:")
                        )
		   
		   ;;c'est le end ajoute par d cansell
		   ((= 22 index)
		    ;;(if  cansell-traite-le-goal (pri-log-print " ______________ \n"))
                     ;;(if  cansell-hypo-not-found 
			;; (progn
			  ;; (setq  cansell-hypo-not-found nil) 
			   ;;(setq cansell-first-cache-RSH nil)
			  ;; (setq cansell-nb-RSH 0)
			  ;; (setq cansell-hypos-selection-RSH  nil)
			   ;;))
		    (if (and cansell-hypo  (>= cansell-nb 2))
			(progn 
			  (if (=  cansell-nb 2)
			      (setq cansell-first-cache (cons (cons 1 (cons cansell-hypo-nature (cons cansell-deb-hypo (cons cansell-end-first-hypo nil)))) nil))
			    (setcdr cansell-end-cache (cons (cons (- cansell-nb 1) (cons cansell-hypo-nature (cons cansell-deb-hypo  (cons cansell-end-first-hypo nil)))) nil)))
			  (if cansell-cache
			      (progn
				(setq cansell-first-cache-CACH (cansell-cons-CACH cansell-first-cache))
				(setq cansell-nb-CACH (length cansell-first-cache-CACH)) 
				(setq cansell-first-cache-SEL (cansell-cons-SEL cansell-first-cache))
				(setq cansell-nb-SEL (- cansell-nb cansell-nb-CACH))
				(setq cansell-nb-CACH (+ cansell-nb-CACH 1))
				(setq cansell-hypos-selection-CACH  cansell-first-cache-CACH)
				(setq cansell-hypos-selection-SEL   cansell-first-cache-SEL ))
			    (progn
			      (setq cansell-first-cache-RSH cansell-first-cache )
			      (setq cansell-nb-RSH cansell-nb)
			      (setq cansell-hypos-selection-RSH  cansell-first-cache-RSH)))
			;;  (erase-buffer pri-output-buffer)
			 ;; (if (<= 5 cansell-nb ) 
			 ;;     (cansell-affiche-sel-loop 5)
			  ;;    (cansell-affiche-sel cansell-nb))))
			 
			  ))
		    (if (and cansell-hypo  (= cansell-nb 1))
			(if cansell-cache
			      (progn
				(setq cansell-first-cache-CACH nil)
				(setq cansell-nb-CACH 1)
				(setq cansell-first-cache-SEL nil)
				(setq cansell-nb-SEL 1)
				(setq cansell-hypos-selection-CACH  cansell-first-cache-CACH)
				(setq cansell-hypos-selection-SEL   cansell-first-cache-SEL ))
			    (progn
			      (setq cansell-first-cache-RSH nil)
			      (setq cansell-nb-RSH 0)
			      (setq cansell-hypos-selection-RSH  cansell-first-cache-RSH))))
		    	;;(if (and cansell-hypo  cansell-cache) 
			;;			  (setq cansell-a-la-table-wx t))
			(if (and cansell-hypo   (not cansell-cache)) 
				      (setq cansell-a-les-tables t))
		         (setq  cansell-affiche-prompt-pri t)
			(setq cansell-traite-le-goal nil)
                        (setq cansell-hypo nil)(setq cansell-message nil)
			(setq cansell-affiche-wid-goal nil)
	   )

		   ;;reception hypotheses a ajouter
		   ((= PRI-PRV-II-M9-1 index)
			(setq pri-output-buffer PRI-HYPOTHESIS))
		   
		   ;;debut de la liste des PO
		   ((= PRI-PRV-II-BB-4 index)
			(setq pri-output-buffer PRI-PO-LIST)
			  (setq pri-nb-unproved-pos 0)
                           (setq pri-nb-pos 0)
			;;(let ((inhibit-read-only t))
			  ;;(erase-buffer pri-output-buffer)
)

		 ;;  ((= PRI-PRV-II-NN-59 index)
                 ;;     (setq  cansell-hypo-not-found t))

		   ;;debut de PO courante
		   ((= PRI-PRV-II-BB-1 index)
			(goto-char (point-max))
			(setq line 
				  (replace-in-string line "\\[\".*\"\]@@Current PO is" ""))
			(if  (string= line " o.n") (setq cansell-message t))
                        (if  (or (string= line " wx.search")  (string= line " cache.wx"))
			    (progn
			      (setq cansell-hypo t)
			      (setq cansell-cache  (string= line " cache.wx"))
			      ;;(pri-log-print "\n")
			      (setq cansell-nb 1)
			      			      (if cansell-cache (progn
			      (setq cansell-les-ph-pas-point-CACH nil)  (setq cansell-les-ph-pas-point-SEL nil) 
			      (setq cansell-les-ph-pas-point-droit-CACH nil) (setq cansell-les-ph-pas-point-droit-SEL nil))
				(progn 

				  (setq cansell-les-ph-pas-point-RSH nil) (setq cansell-les-ph-pas-point-droit-RSH nil)))
			      (setq cansell-first-cache nil)
			      (setq cansell-end-cache nil)(setq cansell-end-first-hypo nil)
			    )
			   (progn (if (string-match "\\([^\\.]*\\)\\." line )
				  (progn
				    (setq pri-operation-name
					  	(substring line 0 (match-end 1)))
				    (setq pri-operation-name
					  	(replace-in-string pri-operation-name "^[ \t]+" ""))))
			  (setq line (replace-in-string line "[^.]*\\." ""))
			  (pri-current-po line))))


                    

		   ;;Pas de PO courante
		   ((= PRI-PRV-II-NN-2 index)
			;enleve le ["novar"]@@ du debut de message
			(setq line (replace-in-string line "\\[\".*\"\]@@" ""))
			(setq pri-output-buffer PRI-LOG)
			(set-buffer pri-output-buffer)
			;;(pri-log-print line)
                        (setq cansell-le-message  line)
			(pri-current-po "0")
			)
		   
		   ;;reception nom d'operation
		   ((= PRI-PRV-II-M1-4 index)
			;;(set-buffer PRI-PO-LIST)
			(string-match "@@ .*" line)
			(setq pri-operation-name (replace-in-string (match-string 0 line)
													"@@ *" ""))
			;;(goto-char (point-max))
			;;(widget-insert pri-operation-name "\n")
			)
		   
		   ;;reception d'une PO prouvee
		   ((= PRI-PRV-II-M2-4 index)
			(if (string-match "\\([0-9]+\\)" line)
				(progn
				  (setq line (match-string 1 line))
				    (setq pri-nb-pos (+ pri-nb-pos 1))
;;(pri-add-po line "proved" pri-operation-name)
)))
		   
		   ;;reception d'une PO non prouvee
		   ((= PRI-PRV-II-M3-4 index)
			(if (string-match "\\([0-9]+\\)" line)
				(progn
				  (setq line (match-string 1 line)) 
	  (setq pri-nb-unproved-pos (+ pri-nb-unproved-pos 1)) (setq pri-nb-pos (+ pri-nb-pos 1))
				 ;; (pri-add-po line "unproved" pri-operation-name)
)))
		   
		   ;;reception fin d'envoi des po
		   ((= PRI-PRV-II-EE-4 index)
			;;(set-buffer PRI-PO-LIST)
(set-buffer cansell-component-buffer)			  ;;(add-hook 'pri-machines-mode-hook 
				    ;;'turn-on-font-lock) 	
(pri-machines-mode)(font-lock-fontify-buffer) 	
(setq pri-log-window (selected-window))
						   (pop-to-buffer  PRI-LOG nil cansell-proj-frame) (delete-other-windows)
                                                 (set-buffer  PRI-LOG)   (x-symbol-mode "B entity")
;;(font-lock-fontify-buffer) ;;pri-atelierb-B-mode)
						 (insert  "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n")
                                                 
						 (setq pri-output-buffer PRI-LOG)
			;;(goto-char (point-min))
)
		   
		   ;;pour sauvrgarder la preuve ou non
		   ;;((= PRI-PRV-II-NN-11 index) )
		   ;;((= PRI-PRV-II-NN-12 index))
		   ((= PRI-PRV-II-NN-13 index)
		    (setq pri-process-busy nil)
		    (setq pri-process-open-p t)
		    (setq cansell-not-sv-nv nil)
                    (set-buffer "pri-log")
                   		    (if cansell-RS (progn   (setq cansell-RS t) (pop-to-buffer"pri-rs" nil cansell-proj-frame) (delete-other-windows) (setq wrs (split-window  (frame-selected-window cansell-proj-frame) )) (set-window-buffer wrs  "pri-log" )
(walk-windows  (function (lambda (w) (select-window w) 
      (if (string= "pri-rs" (buffer-name (window-buffer))) 
                                (recenter -1) 
 )))
 'nomini)
       (select-window wrs)   (if (string= "pri-log" (buffer-name (window-buffer))) 
          (cansell-affiche-balbulette-bis)


)) (cansell-affiche-balbulette-bis)
))

		   ((= PRI-PRV-II-NN-53 index)
			(progn (setq cansell-sortez   t) 
))

		   ;;reception du prompt PRI>
		   ((= PRI-PRV-II-NN-52 index)
                    (if cansell-res-diff (progn (setq cansell-Proof-Tree-diff (cons cansell-dec-po (cons "JRA" (cdr cansell-Proof-Tree-diff))))(setq cansell-res-diff nil)))

(if cansell-sortez
				  (progn (setq pri-process-busy nil)(setq  cansell-sortez nil)(setq cansell-exist-le-champs nil)(pri-exit))
		 (progn   (setq pri-output-buffer PRI-LOG)
		    (set-buffer pri-output-buffer)
		    (setq pri-process-busy nil)

		    (if cansell-debut-de-la-preuve 
			(progn
                          (setq cansell-dans-error nil)
			  (setq cansell-debut-de-la-preuve nil)
                          (setq cansell-exist-le-champs nil)
			  (setq cansell-decr-nb-Unpr t)
			  (pop-to-buffer "pri-rs")

                          ;;(pri-proof-tree-mode) 
			    
  (pop-to-buffer PRI-PROOF-TREE)
  (pri-atelierb-mode)
  (x-symbol-mode)

(if pri-hypothesis-buffer-p
			      (pri-hypotheses-list-mode))
			  ;;(pri-goal-mode)
			    (pop-to-buffer PRI-OLD-PROOF) ;;(pri-old-proof-mode)
  (pri-atelierb-mode)
  (x-symbol-mode)
			  (pri-log-mode)
			 ;; (pri-po-list-mode)
                            
			  
			  (message "BALBULETTE Version : %s." pri-version)
			  
(setq pri-output-buffer PRI-PO-LIST)
			 (delete-other-windows)	   
			  (pri-send-command "gs & ne")
			  (setq cansell-debut-d-une-preuve t)
			  (setq pri-log-print-p t)
(pop-to-buffer    PRI-PROOF-TREE  t cansell-error-frame) 
  (delete-other-windows)
			 ;; (setq pri-po-list-window (selected-window))
			  ;;(set-window-buffer pri-po-list-window PRI-PO-LIST)
			  ;;(setq pri-output-buffer PRI-PO-LIST)
			  ;;(pri-trace "<--IF   pri-load-component")
                          )			
			  (if cansell-succes 
			  (progn
				  (setq cansell-succes nil) (setq cansell-SUCCES t)
				  (if cansell-pas-faux-succes
				  (progn (if (= 0 pri-nb-unproved-pos)() (if cansell-decr-nb-Unpr (progn (setq  pri-nb-unproved-pos (1- pri-nb-unproved-pos)) (setq  cansell-decr-nb-Unpr nil))))))
(setq cansell-exist-le-champs nil)
	;;(erase-buffer "pri-log")
			       (pri-prouveur-send-command "sw"))
			    (if cansell-affiche-prompt-pri
			      (if cansell-sortez
				  (progn (setq  cansell-sortez nil)(setq cansell-exist-le-champs nil)(pri-exit))
			      (if (string= cansell-invariant "") 
				(if  cansell-a-les-tables 
				  (progn 
				     (if cansell-reset-proof (progn (cansell-avance-dans-proof-tree cansell-proof-tree)))
;;(tester cansell-marque-dec-as )
;;(pri-trace (format "MARQUE %s \n" cansell-marque-dec-as))

				     (if  cansell-marque-dec-as 
					 (progn
					   (setq cansell-last-as cansell-dec-po)
					   (setq cansell-lg-nx (length cansell-proof-tree))
					   (setq cansell-marque-dec-as nil)
					  
					   (pri-before-writting-buffer PRI-OLD-PROOF) 
					   (erase-buffer  PRI-OLD-PROOF)(pri-after-writting-buffer)
;;(pri-trace (format "NBAS %s \n" cansell-cansell-nb-as))
					   
))
                                   
				     (setq  cansell-affiche-prompt-pri nil)
				      (setq  cansell-a-les-tables  nil)
				      (setq cansell-a-la-table-wx  nil)
				      (setq 	cansell-hypos-selection-CACHold cansell-hypos-selection-CACH)	
					    (setq 	cansell-hypos-selection-SELold cansell-hypos-selection-SEL)	
					    (setq 	cansell-hypos-selection-RSHold cansell-hypos-selection-RSH)
					    (setq cansell-prover-not-works t)
					    ;;(set-buffer "pri-errors")(end-of-buffer)(set-buffer "pri-log")

;;(pri-trace (format "COUCOU: %s : %s"  cansell-reset-proof cansell-after-nx  ))
                                        (if cansell-raff-preuve 
					    (if cansell-reset-proof
						(progn 	(setq cansell-reset-proof  nil) (setq cansell-affiche-nx t))
					      (if cansell-after-nx 
						(progn 

	(setq cansell-after-nx nil) (setq cansell-affiche-nx nil))
(if (cansell-encore-des-as cansell-proof-old-tree-pos) 
(if cansell-Proof-Tree-diff  
   (progn
 (setq cansell-affiche-nx  (< (cansell-min-dec cansell-Proof-Tree-diff) cansell-last-as)))
  (progn
 (setq cansell-affiche-nx nil)))
;;(if cansell-proof-old-tree-pos 
(if cansell-Proof-Tree-diff  
   (progn
 (setq cansell-affiche-nx  (< (cansell-min-dec cansell-Proof-Tree-diff) cansell-last-as)))
  (progn
 (setq cansell-affiche-nx nil))) 
;;(setq cansell-affiche-nx nil))
)))
 
 (setq cansell-affiche-nx nil))(setq cansell-Proof-Tree-diff nil)

					(if  cansell-affiche-nx
(progn   (setq cansell-cansell-nb-as (1+ cansell-cansell-nb-as)) (setq cansell-marque-dec-as t) (setq cansell-after-nx t)
				(let ((entre-deux (cansell-entre-deux-as)))
				   ;;(tester entre-deux)
				  (if entre-deux (cansell-pri-send-command-list-pt entre-deux )
				    (progn (pri-send-command "gl")
))))
(cansell-affiche-PROOF-TREE cansell-pour-aff-proof-tree)
(walk-windows  (function (lambda (w) (select-window w) (if (string= "pri-proof-tree" (buffer-name (window-buffer))) (scroll-up (max 0 (+ (- cansell-long-PROOF-TREE (window-height) ) 3)))))) 'nomini t)

;;(if (string= (cansell-cherche-premier-commentair cansell-pour-aff-proof-tree)(cansell-cherche-premier-commentair cansell-pour-aff-old-proof-tree))

(if cansell-raff-preuve (cansell-affiche-old-avec-marque-as cansell-old-proof-pour-as  cansell-cansell-nb-as)
 (cansell-affiche-OLD-TREE cansell-pour-aff-old-proof-tree))

;;(cansell-affiche-OLD-TREE nil)
;;)
 ;;                                          (if cansell-mouse-in-pri-log (progn  ;;(setq cansell-mouse-in-pri-log nil) 

;;(setq cansell-mouse-in-PT ( mouse-pixel-position)) 


;;(set-mouse-pixel-position pri-log-window 346 101  )))  

				    (if (and cansell-ba (>= cansell-dec-ba cansell-dec-po-old))
                                      (progn  (setq cansell-old-goal cansell-The-Goal)(pri-prouveur-send-command   "ba & wx & ws") (setq cansell-after-pr t) )
                                     (progn (if  cansell-after-pr 
                                             (if (cdr cansell-old-goal) (cansell-affiche-balbulette "" (concat "pr failed on " (cansell-affiche-goal-ln cansell-old-goal) ))(cansell-affiche-balbulette "" (concat "pr failed on " (car cansell-old-goal)))) 
                                              (cansell-affiche-balbulette "" "") 
                                         )(setq cansell-after-pr nil) (x-symbol-decode)))
	 (setq  cansell-ba nil)
 (if cansell-PT-envoi 
     (progn 
        ;;(sleep-for 0.2)
        (setq cansell-PT-cmd (car  cansell-PT-envoi)) (setq cansell-PT-envoi (cdr  cansell-PT-envoi)) (setq cansell-prover-not-works (not (or (string=  cansell-PT-cmd "pp(rp.0)" )(string=  cansell-PT-cmd "pp(rp.1)" ) (string=  cansell-PT-cmd "pr" )(string=  cansell-PT-cmd  "ml(ff(0)|rp.0)")(string=  cansell-PT-cmd  "ml(ff(0;1)|rp.1)"))))(if (not cansell-prover-not-works)(progn (cansell-affiche-balbulette-bis) (message "Wait the predicate prover works!")))(pri-prouveur-send-command cansell-PT-cmd) ))

;;(if cansell-mouse-in-pri-log  (prognml(ff(0;1)|rp.1)


;; (setq cansell-mouse-in-pri-log nil)  ;;(set-mouse-pixel-position (car cansell-mouse-in-PT) (cadr cansell-mouse-in-PT) (cddr cansell-mouse-in-PT)  )
;;))
)

					    ) 
				  (progn   
				    (setq  cansell-list-widget-value-ph-SEL nil)(setq  cansell-list-widget-value-ph-CACH nil)(setq  cansell-list-widget-value-ph-RSH nil)
                                    (setq  cansell-affiche-prompt-pri nil) 
				    (setq cansell-exist-le-champs nil) 

                                      (if  cansell-debut-d-une-preuve 
					(progn 
					  (if cansell-beginner 
					      (pri-prouveur-send-command   "cl & bg & wx & ws")
					    (pri-prouveur-send-command   "cl & xp & wx & ws"))
					  (setq cansell-debut-d-une-preuve  nil)) 
				      (pri-prouveur-send-command   "wx & ws")) 
))
				  				  (progn  

 (setq cansell-exist-le-champs nil) (setq cansell-debut-d-une-preuve  nil)(setq  cansell-affiche-prompt-pri nil) (setq  cansell-list-widget-value-ph-SEL nil)(setq  cansell-list-widget-value-ph-CACH nil)(setq  cansell-list-widget-value-ph-RSH nil)
;; (cansell-affiche-dans-pri-errors cansell-invariant)									    
									   (if  cansell-beginner (pri-prouveur-send-command  (concat "cl & nv(" cansell-invariant ") & bg & wx & ws"))
									     (pri-prouveur-send-command  (concat "cl & nv(" cansell-invariant ") & xp & wx & ws")))									    (setq cansell-invariant "")))
))
))
			    (setq pri-process-open-p t)			
 ;; on ne met pas de prompt dans la fenetre log :
			    ;; pourrait tromper l'utilisateur
			    ;; une ligne blanche permet de separer les differentes commandes

			    ;;(sleep-for 0.5)

			   ;; (set-buffer PRI-PO-LIST)
			    ;;(pri-modeline)
			    ;;(set-buffer pri-output-buffer)
			    ;;(pri-end-of-buffer)
			    (pri-modeline)		
			    ;;(if (and pri-log-print-p pri-interactive-send-command-p (not pri-beginning-p))
			    ;;	(progn
			    ;;	  (setq  pri-interactive-send-command-p nil)
			    ;;	  (call-interactively 'pri-send-command)))
;;			    (other-window 1)
			    ;;(pri-end-of-buffer)
;;			    (other-window 1)
			    (if (string= pri-current-po-state "Proved")
				(message "PO Proved"))
;;(coucou cansell-PT-envoi)


 )) )
		   
		   ;;fin de session de preuve
		   ((= PRI-PRV-II-NN-259 index)
			(setq pri-process-busy nil)(setq cansell-exist-le-champs nil)
			(pri-stop))


		   ;; etat de la PO courante
		   ((memq index 
				  (list PRI-PRV-II-M1-1 PRI-PRV-II-M2-1 
						PRI-PRV-II-M3-1 PRI-PRV-II-M4-1))
			;enleve le ["novar"]@@ du debut de message
			(setq line (replace-in-string line "\\[\".*\"\]@@" ""))
			(setq line (replace-in-string line "^[ \t]+" ""))
			(setq line (replace-in-string line " saved.*$" ""))
			(pri-current-po-state line))
		   
		   ;;messages  afficher dans la fenetre Log
		   ((memq index pri-messages-list)
			;enleve le ["novar"]@@ du debut de message
			(setq line (replace-in-string line "\\[\".*\"\]@@" ""))
			(if (search "Nothing to backtrack" line)
                          (progn  (setq  cansell-affiche-prompt-pri t)
			(setq cansell-traite-le-goal nil)
                        (setq cansell-hypo nil))
			    ;; (pri-prouveur-send-command  "re"))
			   )  
(setq  cansell-affiche-prompt-pri t)
			(setq cansell-traite-le-goal nil)
                        (setq cansell-hypo nil)
			(if (= index 85)
                          (progn  (setq  cansell-affiche-prompt-pri t)
			(setq cansell-traite-le-goal nil)
                        (setq cansell-hypo nil))
			    ;; (pri-prouveur-send-command  "re"))
			   )  
			    (setq cansell-le-message  line) ;;(pri-log-print (concat line "\n"))
			   
			(if (memq index pri-question-messages-list)
			;;	(progn
				  (setq pri-process-busy nil))
			;;	  (if pri-interactive-send-command-p
			;;		  (call-interactively 'pri-send-command)))))
			)
		   ;;reception du resultat des commandes sh et sr
		    ((memq index (list PRI-PRV-II-BB-58))
			 (setq pri-output-buffer PRI-LOG)
			 (set-buffer pri-output-buffer)
			 (goto-char (point-max))
			 (setq cansell-le-message  line) ;;(pri-log-print line)
			 ;;(pri-end-of-buffer)
)

			;;reception de debut de trace de pr
			((memq index (list PRI-PRV-II-BB-251 PRI-PRV-II-EE-251))
			 (setq pri-output-buffer PRI-LOG)
			 (set-buffer pri-output-buffer)
			 ;;(pri-end-of-buffer)
)
			
			(t 
) ;; fin de (t )
		   )))
	  
	  ;;*******************************
	  ;; messages de l'AtelierB

	  (cond 

	   ;;*******************************
	   ;; messages du Kernel
	   ;;probleme de memoire
	   ((string-match pri-kernel-msg-regexp message)
             (if (string= "TOO MANY HYPOTHESES"  message) (progn (cansell-affiche-dans-pri-errors message)(cansell-affiche-composant)))
              (message message)
		
)
	   
	   ;;probleme de parseur
	   ((string-match "^line" message)
              (cansell-affiche-dans-pri-errors message)
                (setq old-message message)
		(setq  cansell-affiche-prompt-pri t)
                (setq pri-process-busy nil)		    (setq pri-process-open-p t)
(pri-prouveur-send-command "")
		(setq cansell-le-message  message);;(pri-log-print message)
		;;(if (and pri-log-print-p pri-interactive-send-command-p
		;;	 pri-process-open-p)
		;;	(progn
		;;	  (setq  pri-interactive-send-command-p nil)
		;;	  (call-interactively 'pri-send-command))
		 ;; (message message)))
		)
	   ;;*******************************
	   ;; messages de l'AtelierB
	   
  	   ;; debut de l'AtelierB
	   ((string= "Beginning interpretation ..." message)
(pri-atb-send-command "spl")
             )

	   ;;recuperation de l'erreur en cas No licence available
	   ((search "No licence available" message)
         	 (setq pri-begin-message (search "No licence available" message))
                 (cansell-affiche-dans-pri-errors "No licence available" )
               
                  (setq pri-atb-open-p nil)
                  
		 )


  ((search "No component matching pattern '*'" message))

 ((search "Someone is currently using the project" message)
  (setq pri-begin-message (search "Someone is currently using the project" message))(setq cansell-pas-fini-les-interrupt nil)
 (pop-to-buffer PRI-PROJECTS-LIST)(end-of-buffer)(setq cansell-le-message (substring message pri-begin-message))
   (cansell-affiche-dans-pri-errors  (substring message pri-begin-message))
             
)
 ((and cansell-pas-fini-les-interrupt  (search "Dependency graph error in "  message))
       (setq cansell-pas-fini-les-interrupt nil))

 ((and cansell-trouve-stat (search "Dependency graph error in "  message))
                ;; (setq cansell-Dependency-graph t)
                (setq cansell-machines-stat-list (cons 1 (cons ""  cansell-machines-stat-list))) (setq  cansell-pasencore  (cons (replace-in-string message "Dependency graph error in " "") cansell-pasencore)) 
                  (setq cansell-machines-name-list (cons "pasencore" cansell-machines-name-list)) (setq  cansell-stat-list nil) (setq  cansell-stat-nb-list (1+ cansell-stat-nb-list)))

	   ;;recuperation de l'erreur en cas Someone is modifying component
	   ((search "Someone is adding or removing a component in the project" message)(setq cansell-le-message (substring message (search "Someone is adding or removing a component in the project" message)))
                  (cansell-affiche-dans-pri-errors (substring message (search "Someone is adding or removing a component in the project" message)))
                 (pop-to-buffer PRI-COMPONENTS-LIST nil cansell-proj-frame) (delete-other-windows)(end-of-buffer)
                 )

	   ;;recuperation de l'erreur en cas Someone is modifying component
	   ((search "Someone is modifying component" message)
		  (setq pri-begin-message (search "Someone is modifying component" message)) (setq cansell-pas-fini-les-interrupt nil)
		   (cansell-affiche-dans-pri-errors (substring message pri-begin-message))
              (setq  cansell-debut-de-la-preuve nil)   (setq cansell-not-pb-p nil)
(setq cansell-le-message "Someone is modifying component")
		  (pri-stop)
                  (delete-other-windows)(end-of-buffer)
		  
		 )
	   
		     	   
           ;; fin de l'AtelierB
	   ((search "End of interpretation" message)
		(progn
		  (delete-process PRI-PROCESS)
		  (save-buffers-kill-emacs)))
	   
		;;; debut de la liste des projets
		((or (search "Printing Projects list ..." message)(search "Printing Project list ..." message))
		 ;;(pri-trace "Debut de la liste des projets")
                 (setq cansell-liste-projet nil)
		 (setq pri-output-buffer PRI-PROJECTS-LIST)
                 (setq cansell-prj-list t)
)

		;;; fin de la liste des projets
		((or (search "End of Projects list" message)(search "End of Project list" message))
		 ;;(pri-trace "fin de la liste des projets")
                  (setq  cansell-liste-projet   (reverse cansell-liste-projet))
                  (setq  cansell-selected-projects cansell-liste-projet)                         (setq  cansell-selected-projectsold cansell-liste-projet)                      (setq  cansell-prj-list nil) ;;(set-window-buffer pri-projects-list-window PRI-PROJECTS-LIST)
                  (cansell-affiche-projet) ;;(set-window-point   pri-projects-list-window  (point-max)) 

		 ;;(goto-char (point-min))
                 
                  )

		;;; fin d'un status
		((search "End of Printing the status"  message)
                 (if   cansell-attend-stat 
               (progn  (setq  cansell-attend-stat nil)(cansell-change-stat cansell-liste-machine cansell-machines-stat-list  cansell-mach-stat cansell-obvious  cansell-compo-change) (load-all-compo) (cansell-affiche-composant))(progn(setq cansell-machines-stat-list (cons cansell-stat-mach (cons (cons cansell-obvious cansell-mach-stat)  cansell-machines-stat-list)))
                  (setq cansell-machines-name-list (cons cansell-file-name-mach cansell-machines-name-list))(setq cansell-obvious nil)
		 (setq  cansell-stat-list nil) (setq  cansell-stat-nb-list (1+ cansell-stat-nb-list))))
)
		;;; debut d'un status
		((search "Printing the status"  message)
(setq cansell-current-mach (replace-in-string message "Printing the status of " "") )
(setq cansell-liste-Machine  (cons  cansell-current-mach cansell-liste-Machine))
		  (setq  cansell-stat-list t)
)
   


		;;; debut de la liste des machines
		((or (search "Printing machines list ..." message)(search "Printing machine list ..." message))
		 ;;(pri-trace "Debut de la liste des machines")
		 (setq  cansell-mach-list t)  (setq cansell-machines-stat-list nil)(setq cansell-machines-name-list  nil)(setq cansell-obvious nil)

                 (setq  cansell-liste-machine  nil)
)

		;;; fin de la liste des machines
		((or (string= "End of machines list" message)(string= "End of machine list" message))
		 (setq cansell-nb-mach ( length cansell-liste-machine)) (setq  cansell-stat-nb-list 0)  (setq  cansell-stat-NB-list 0) (setq  cansell-nb-pasencore 0) 
                 ;;(pri-trace "Fin de la liste des machines")
                  (setq  cansell-mach-list nil)
                ;; (setq cansell-mach-list-fin t)
                 (setq mode-name (concat "projet: "  pri-project-name))
;;(setq cansell-copy-liste-mach  (reverse cansell-liste-machine))
(setq cansell-liste-Machine nil)
(setq cansell-NB-pasencore 0)
(setq cansell-cherche-stat t)

                 ;;(cansell-stat-composant)
                ;; (cansell-affiche-composant)

		;; (goto-char (point-min))
)
;; ((and cansell-cherche-stat (search "Dependency graph error in "  message))
;;                (setq cansell-machines-stat-list (cons 1 (cons ""  cansell-machines-stat-list)))(setq cansell-nb-pasencore (1+ cansell-nb-pasencore))(setq  cansell-nb-pasencore  (cons cansell-current-mach cansell-nb-pasencore)) 
;;                  (setq cansell-machines-name-list (cons "pasencore" cansell-machines-name-list)) (setq  cansell-stat-list nil) (setq  cansell-stat-nb-list (1+ cansell-stat-nb-list)))

		;;recuperation de l'erreur en cas de ".lock" sur le composant
		((search "Someone is modifying component" message)
		 (setq pri-begin-message (search "Someone is modifying component" message));(setq cansell-pas-fini-les-interrupt nil)
		   (cansell-affiche-dans-pri-errors  pri-begin-message) (setq cansell-not-pb-p nil)
                 (pri-stop)
		 (delete-other-windows)
		 )

		 ;; ( (search "Project status"  message)
                 ;; (setq cansell-affiche-status-project t)
                 ;; (setq pri-output-buffer PRI-COMPONENTS-LIST)
                 ;;	(pri-before-writting-buffer  PRI-COMPONENTS-LIST)(beginning-of-buffer)
                 ;; )


		;;recuperation au ca ou il n'y a pas de PO sur le composant
		((search "All of the PO of component" message)
		 (setq pri-begin-message (search "All of the PO of component" message))
		   (cansell-affiche-dans-pri-errors (substring message pri-begin-message))
                 (pri-stop)
		 		 )



                ((search "TOTAL for " message)
                  (cansell-affiche-dans-pri-errors message)
                  (setq old-message message))

                ((search "REFINEMENT     -->" message)())

                ((search "SPECIFICATION  -->" message)())

                ((search "IMPLEMENTATION -->" message) ())
 
		;; reception de l'info sur le composant
		((search "LOCATION       -->" message)
                  (setq pri-component-file (replace-in-string  message"LOCATION       --> " "" ))
                
)

		((search "OWNER          -->" message)
                   (setq cansell-NB-pasencore (1+ cansell-NB-pasencore ))

                   (cansell-change-pasencore  cansell-liste-machine cansell-machines-name-list (car cansell-pasencore )pri-component-file)(setq cansell-pasencore (cdr cansell-pasencore )))
		((search "Nothing to prove in" message)(setq cansell-pas-fini-les-interrupt nil))
		;; pour eviter les messages bbatch en liste des projets
		((search "bbatch" message)
;;(setq cansell-pas-fini-les-interrupt nil)
(setq pri-process-busy nil)
;;(coucou cansell-machines-name-list)
;;(coucou cansell-pasencore)
             (setq cansell-type-check nil)
              (if   cansell-envoi-resources (progn (setq cansell-envoi-resources nil)(setq  cansell-envoi-sml t)(pri-atb-send-command ""))
               (if   cansell-gziptar (progn (setq cansell-gziptar nil) (shell-command (concat "gzip -f " PRI-MODELE-dir  "/Archives/tar" cansell-filegziptar  ".arc"))) (if  cansell-envoi-stat  
                  (progn  (setq cansell-envoi-stat nil)(setq cansell-attend-stat t)(pri-atb-send-command cansell-cmd-stat))
		   (if cansell-envoi-sml (progn (setq cansell-envoi-sml nil)(pri-atb-send-command "sml"))
		    (if cansell-cherche-stat
(progn (setq  cansell-pasencore nil) (setq cansell-cherche-stat nil) (setq cansell-trouve-stat t) (pri-atb-send-command  "s  *"))
 ;;                    (if cansell-copy-liste-mach
;;			(progn  (pri-atb-send-command (concat "s " (car cansell-copy-liste-mach))) (setq cansell-copy-liste-mach (cdr cansell-copy-liste-mach)))
;;		       (progn (setq  cansell-pasencore nil) 
;;;;(setq cansell-pasencore (cons "mm1" (cons "mm3" nil)))
;;;;(setq cansell-pasencore (cansell-diff cansell-liste-Machine cansell-liste-machine )) 
 ;;                     (setq cansell-cherche-stat nil) (setq cansell-trouve-stat t)(pri-atb-send-command "")))
(if  cansell-trouve-stat
     (if cansell-pasencore
            (pri-atb-send-command (concat "ic "  (car cansell-pasencore) ))
		     (progn(setq cansell-trouve-stat nil)
 		 (setq pri-output-buffer PRI-COMPONENTS-LIST)
		 (setq cansell-cherche-stat nil)
			 (cansell-affiche-composant)
(setq cansell-affiche-dans-errors t)(message cansell-le-message)
))))
 ;;(cansell-affiche-dans-pri-errors (replace-in-string message "bbatch.\\(0\\|1\\|2\\|3\\|4\\|5\\|6\\|7\\|8\\|9\\)*>. *" "" ))
 		 (if cansell-debut-de-la-preuve (setq pri-process-open-p nil))
))))
(message cansell-le-message)
)

		;; reception de la liste des projets
		( cansell-prj-list 
                  ;;(string= pri-output-buffer PRI-PROJECTS-LIST)
		 ;;(pri-trace "reception des projets")
		 ;;(set-buffer pri-output-buffer)
		 ;;(goto-char (point-max))
		 ;;(pri-add-project message)
                  (setq cansell-liste-projet  (cons (replace-in-string message "^[\t ]+" "")  cansell-liste-projet)))

		;;((search  "sources/"  message)(setq pri-process-busy nil))


		;; reception de la liste des composants
		(cansell-mach-list
                 ;;(if cansell-debut-de-la-preuve ()
		 (progn 
		   ;;(pri-trace "reception des machines")
		   ;;(pri-trace (concat "$" (replace-in-string message "^[\t ]+" "")"$"))
		   (setq cansell-liste-machine  (cons (replace-in-string message "^[\t ]+" "") cansell-liste-machine))
)
		
)
		((or cansell-stat-list cansell-attend-stat)
                  (cond 
		   ((search   "NbObv |" message) (setq cansell-obvious t))
		   ((search  "Modified /"  message) (setq cansell-stat-mach 1) (setq cansell-file-name-mach (cadr (pri-split-string   message " Modified "))))
		   ((search  "Parsed /"  message) (setq cansell-stat-mach 1) (setq cansell-file-name-mach (cadr (pri-split-string   message " Parsed "))))
		   ((search  "TypeChecked /"  message)(setq cansell-stat-mach 2)(setq cansell-file-name-mach (cadr (pri-split-string   message " TypeChecked "))))
		   ((search  "POGenerated /"  message)(setq cansell-stat-mach 3)(setq cansell-file-name-mach (cadr (pri-split-string   message " POGenerated "))))
                   ((search  "AutoProved /"  message)(setq cansell-stat-mach 4)(setq cansell-file-name-mach (cadr (pri-split-string   message " AutoProved "))))
		   ((search  "| " message) (setq cansell-mach-stat message))
;;(t (cansell-affiche-dans-pri-errors message)) 
))
                 
                 ((and cansell-pas-fini-les-interrupt  (or (string= message  "+")(string= message "-"))) (cansell-affiche-plus-moins-dans-pri-errors message)) 		   ((search  "Proof timeout" message) )
              ((string-match pri-kernel-msg-regexp message) (message message))
             (cansell-type-check
               (if (search "Type Checking " message)
                  (setq cansell-mach-type-check (replace-in-string  message "Type Checking " "")))
               (if (search "	Checking " message)
                 (progn    
(setq cansell-clause-entete(replace-in-string   (replace-in-string  (replace-in-string message "	Checking " "") " clause" "") "operation " "")) 
                  (cansell-affiche-dans-pri-errors-sans-nl ".") ))
                 (if (search ".mch:" message) (cansell-affiche-dans-pri-errors message)                 (if (search ".ref:" message) (cansell-affiche-dans-pri-errors message))                 (if (search ".imp:" message) (cansell-affiche-dans-pri-errors message)))
                  (if (search "Error:" message) 
                    (progn(cansell-affiche-dans-pri-errors "") (cansell-affiche-dans-pri-errors cansell-clause-entete)(cansell-affiche-dans-pri-errors message) (cansell-affiche-dans-pri-errors (concat " in "  cansell-mach-type-check))))
                (if (search "End of Type checking" message) (progn(cansell-affiche-dans-pri-errors ""))))
                ;; (t  (message message))
                 (t (if cansell-dans-error  (cansell-affiche-dans-pri-errors message) (progn (setq cansell-le-message message)(message cansell-le-message))))
 
                
)))))